=== modified file 'CHANGES'
--- CHANGES	2011-06-03 03:18:07 +0000
+++ CHANGES	2011-06-27 18:09:28 +0000
@@ -1,11 +1,21 @@
+Serf 1.0.0 [2011-..., branch 1.0.x r...]
+  Fixed issue 38: enable builds using non-GNU make
+  Fixed issue 56: allow Subject Alternative Name, and enable SNI
+  Fixed issue 61: include order dependencies
+  Corrected contents of build/serf.def; it now includes bucket types
+  Removed "snapshot" feature from buckets
+
+
 Serf 0.7.2 [2011-03-12, branch 0.7.x r1451]
   Actually disable Nagle when creating a connection (r1441).
   Return error when app asks for HTTPS over proxy connection (r1433).
 
+
 Serf 0.7.1 [2011-01-25, branch 0.7.x r1431]
   Fix memory leak when using SSL (r1408, r1416).
   Fix build for blank apr-util directory (r1421).
 
+
 Serf 0.7.0 [2010-08-25, r1407]
   Fix double free abort when destroying request buckets.
   Fix test server in unit test framework to avoid random test failures.

=== modified file 'Makefile.in'
--- Makefile.in	2011-06-03 03:18:07 +0000
+++ Makefile.in	2011-06-27 18:09:28 +0000
@@ -15,7 +15,8 @@
           buckets/deflate_buckets.lo buckets/limit_buckets.lo \
           buckets/ssl_buckets.lo buckets/barrier_buckets.lo \
           buckets/chunk_buckets.lo buckets/bwtp_buckets.lo \
-          incoming.lo outgoing.lo \
+	  buckets/iovec_buckets.lo \
+          incoming.lo outgoing.lo ssltunnel.lo \
           auth/auth.lo auth/auth_basic.lo auth/auth_digest.lo \
           auth/auth_kerb.lo auth/auth_kerb_gss.lo
 
@@ -26,7 +27,7 @@
 
 TEST_SUITE_OBJECTS = test/CuTest.lo test/test_all.lo test/test_util.lo \
                      test/test_buckets.lo test/test_context.lo \
-                     test/test_ssl.lo 
+                     test/test_ssl.lo test/server/test_server.lo
 
 PROGRAMS = $(TEST_OBJECTS:.lo=) test/test_all
 
@@ -59,6 +60,7 @@
 context.lo: context.c $(HEADERS)
 incoming.lo: incoming.c $(HEADERS)
 outgoing.lo: outgoing.c $(HEADERS)
+ssltunnel.lo: ssltunnel.c $(HEADERS)
 buckets/aggregate_buckets.lo: buckets/aggregate_buckets.c $(HEADERS)
 buckets/request_buckets.lo: buckets/request_buckets.c $(HEADERS)
 buckets/buckets.lo: buckets/buckets.c $(HEADERS)
@@ -76,6 +78,7 @@
 buckets/barrier_buckets.lo: buckets/barrier_buckets.c $(HEADERS)
 buckets/chunk_buckets.lo: buckets/chunk_buckets.c $(HEADERS)
 buckets/bwtp_buckets.lo: buckets/bwtp_buckets.c $(HEADERS)
+buckets/iovec_buckets.lo: buckets/iovec_buckets.c $(HEADERS)
 
 test/serf_get.lo: test/serf_get.c $(HEADERS)
 test/serf_response.lo: test/serf_response.c $(HEADERS)
@@ -92,28 +95,28 @@
 test/test_ssl.lo: test/test_ssl.c $(HEADERS)
 
 $(TARGET_LIB): $(OBJECTS)
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -rpath $(libdir) -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -rpath $(libdir) -o $@ $(OBJECTS) $(LIBS)
 
 test/serf_get: $(TARGET_LIB) test/serf_get.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_get.lo $(LIBS)
 
 test/serf_response: $(TARGET_LIB) test/serf_response.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_response.lo $(LIBS)
 
 test/serf_request: $(TARGET_LIB) test/serf_request.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_request.lo $(LIBS)
 
 test/serf_server: $(TARGET_LIB) test/serf_server.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_server.lo $(LIBS)
 
 test/serf_spider: $(TARGET_LIB) test/serf_spider.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_spider.lo $(LIBS)
 
 test/serf_bwtp: $(TARGET_LIB) test/serf_bwtp.lo
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) test/serf_bwtp.lo $(LIBS)
 
 test/test_all: $(TARGET_LIB) $(TEST_SUITE_OBJECTS)
-	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $(TARGET_LIB) $(TEST_SUITE_OBJECTS) $(LIBS)
 
 check: test/serf_response test/test_all
 	@for i in $(TESTCASES); \
@@ -151,4 +154,4 @@
 	fi;
 
 .c.lo:
-	$(LIBTOOL) $(LTFLAGS) --mode=compile $(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c -o $@ $< && touch $@
+	$(LIBTOOL) $(LTFLAGS) --mode=compile $(CC) $(INCLUDES) $(CFLAGS) $(CPPFLAGS) -c -o $@ $< && touch $@

=== modified file 'NOTICE'
--- NOTICE	2011-06-03 03:18:07 +0000
+++ NOTICE	2011-06-27 18:09:28 +0000
@@ -1,3 +1,2 @@
 This product includes software developed by
-The Apache Software Foundation (http://www.apache.org/) and
-by the Subversion Corporation (http://subversion.org).
+The Apache Software Foundation (http://www.apache.org/).

=== modified file 'auth/auth.c'
--- auth/auth.c	2011-06-03 03:18:07 +0000
+++ auth/auth.c	2011-06-27 18:09:28 +0000
@@ -206,8 +206,10 @@
             if (status) {
                 scheme_found = FALSE;
                 scheme = NULL;
-                ab->status = status;
             }
+            /* Let the caller now if the authentication setup was succesful
+               or not. */
+            ab->status = status;
 
             break;
         }

=== modified file 'auth/auth_kerb_sspi.c'
--- auth/auth_kerb_sspi.c	2011-06-03 03:18:07 +0000
+++ auth/auth_kerb_sspi.c	2011-06-27 18:09:28 +0000
@@ -89,6 +89,32 @@
     return APR_SUCCESS;
 }
 
+static apr_status_t
+get_canonical_hostname(const char **canonname,
+                       const char *hostname,
+                       apr_pool_t *pool)
+{
+    struct addrinfo hints;
+    struct addrinfo *addrinfo;
+
+    ZeroMemory(&hints, sizeof(hints));
+    hints.ai_flags = AI_CANONNAME;
+
+    if (getaddrinfo(hostname, NULL, &hints, &addrinfo)) {
+        return apr_get_netos_error();
+    }
+
+    if (addrinfo) {
+        *canonname = apr_pstrdup(pool, addrinfo->ai_canonname);
+    }
+    else {
+        *canonname = apr_pstrdup(pool, hostname);
+    }
+
+    freeaddrinfo(addrinfo);
+    return APR_SUCCESS;
+}
+
 apr_status_t
 serf__kerb_init_sec_context(serf__kerb_context_t *ctx,
                             const char *service,
@@ -106,8 +132,14 @@
     SecBuffer sspi_out_buffer;
     SecBufferDesc sspi_out_buffer_desc;
     char *target_name;
+    apr_status_t apr_status;
+    const char *canonname;
 
-    target_name = apr_pstrcat(scratch_pool, service, "/", hostname, NULL);
+    apr_status = get_canonical_hostname(&canonname, hostname, scratch_pool);
+    if (apr_status) {
+        return apr_status;
+    }
+    target_name = apr_pstrcat(scratch_pool, service, "/", canonname, NULL);
 
     /* Prepare input buffer description. */
     sspi_in_buffer.BufferType = SECBUFFER_TOKEN;

=== modified file 'buckets/aggregate_buckets.c'
--- buckets/aggregate_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/aggregate_buckets.c	2011-06-27 18:09:28 +0000
@@ -28,10 +28,9 @@
     bucket_list_t *last; /* last bucket of the list */
     bucket_list_t *done; /* we finished reading this; now pending a destroy */
 
-    /* Marks if a snapshot is set. */
-    int snapshot; 
     serf_bucket_aggregate_eof_t hold_open;
     void *hold_open_baton;
+
     /* Does this bucket own its children? !0 if yes, 0 if not. */
     int bucket_owner;
 } aggregate_context_t;
@@ -42,11 +41,6 @@
 {
     bucket_list_t *next_list;
 
-    /* If a snapshot is set, don't clear the done list, we might need
-       it later. */
-    if (ctx->snapshot)
-        return;
-
     /* If we finished reading a bucket during the previous read, then
      * we can now toss that bucket.
      */
@@ -79,10 +73,9 @@
     ctx->list = NULL;
     ctx->last = NULL;
     ctx->done = NULL;
-    ctx->snapshot = 0;
     ctx->hold_open = NULL;
     ctx->hold_open_baton = NULL;
-	ctx->bucket_owner = 1;
+    ctx->bucket_owner = 1;
 
     return ctx;
 }
@@ -202,7 +195,7 @@
     int i;
 
     /* Add in reverse order. */
-    for (i = vecs_count - 1; i > 0; i--) {
+    for (i = vecs_count - 1; i >= 0; i--) {
         serf_bucket_t *new_bucket;
 
         new_bucket = serf_bucket_simple_create(vecs[i].iov_base,
@@ -220,19 +213,12 @@
     struct iovec *vecs,
     int vecs_count)
 {
-    int i;
-
-    for (i = 0; i < vecs_count; i++) {
-        serf_bucket_t *new_bucket;
-
-        new_bucket = serf_bucket_simple_create(vecs[i].iov_base,
-                                               vecs[i].iov_len,
-                                               NULL, NULL,
-                                               aggregate_bucket->allocator);
-
-        serf_bucket_aggregate_append(aggregate_bucket, new_bucket);
-
-    }
+    serf_bucket_t *new_bucket;
+
+    new_bucket = serf_bucket_iovec_create(vecs, vecs_count,
+                                          aggregate_bucket->allocator);
+
+    serf_bucket_aggregate_append(aggregate_bucket, new_bucket);
 }
 
 static apr_status_t read_aggregate(serf_bucket_t *bucket,
@@ -242,6 +228,7 @@
 {
     aggregate_context_t *ctx = bucket->data;
     int cur_vecs_used;
+    apr_status_t status;
 
     *vecs_used = 0;
 
@@ -254,9 +241,9 @@
         }
     }
 
-    while (1) {
+    status = APR_SUCCESS;
+    while (requested) {
         serf_bucket_t *head = ctx->list->bucket;
-        apr_status_t status;
 
         status = serf_bucket_read_iovec(head, requested, vecs_size, vecs,
                                         &cur_vecs_used);
@@ -273,7 +260,7 @@
             /* If we got SUCCESS (w/bytes) or EAGAIN, we want to return now
              * as it isn't safe to read more without returning to our caller.
              */
-            if (!status || APR_STATUS_IS_EAGAIN(status)) {
+            if (!status || APR_STATUS_IS_EAGAIN(status) || status == SERF_ERROR_WAIT_CONN) {
                 return status;
             }
 
@@ -321,7 +308,8 @@
             }
         }
     }
-    /* NOTREACHED */
+
+    return status;
 }
 
 static apr_status_t serf_aggregate_read(serf_bucket_t *bucket,
@@ -399,67 +387,6 @@
     return serf_bucket_read_bucket(ctx->list->bucket, type);
 }
 
-static apr_status_t serf_aggregate_snapshot(serf_bucket_t *bucket)
-{
-    bucket_list_t *next_ctx;
-    aggregate_context_t *ctx = bucket->data;
-    apr_status_t status;
-
-    /* Clear all read buckets. */
-    cleanup_aggregate(ctx, bucket->allocator);
-
-    /* Make a snapshot of all the children too. */
-    next_ctx = ctx->list;
-    while (next_ctx) {
-        status = serf_bucket_snapshot(next_ctx->bucket);
-        if (status)
-  	    return status;
-        next_ctx = next_ctx->next;
-    }    
-
-    /* From now on, stop clearing read buckets. */
-    ctx->snapshot = 1;
-
-    return APR_SUCCESS;
-}
-
-static apr_status_t serf_aggregate_restore_snapshot(serf_bucket_t *bucket)
-{
-    bucket_list_t *next_ctx;
-    aggregate_context_t *ctx = bucket->data;
-    apr_status_t status;
-
-    /* Move all the DONE buckets back in the LIST. */
-    if (! ctx->last && ! ctx->list)
-        ctx->last = ctx->done;
-
-    while (ctx->done) {
-        next_ctx = ctx->done->next;
-        ctx->done->next = ctx->list;
-        ctx->list = ctx->done;
-        ctx->done = next_ctx;
-    }
-
-    /* Now restore all the child buckets. If resetting one of those buckets
-       fails, consider this restore operation as failed too. */
-    next_ctx = ctx->list;
-    while (next_ctx) {
-        status = serf_bucket_restore_snapshot(next_ctx->bucket);
-        if (status)
-            return status;
-        next_ctx = next_ctx->next;
-    }    
-    ctx->snapshot = 0;
-
-    return APR_SUCCESS;
-}
-
-static int serf_aggregate_is_snapshot_set(serf_bucket_t *bucket)
-{
-    aggregate_context_t *ctx = bucket->data;
-
-    return ctx->snapshot;
-}
 
 const serf_bucket_type_t serf_bucket_type_aggregate = {
     "AGGREGATE",
@@ -470,7 +397,4 @@
     serf_aggregate_read_bucket,
     serf_aggregate_peek,
     serf_aggregate_destroy_and_data,
-    serf_aggregate_snapshot,
-    serf_aggregate_restore_snapshot,
-    serf_aggregate_is_snapshot_set,
 };

=== modified file 'buckets/barrier_buckets.c'
--- buckets/barrier_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/barrier_buckets.c	2011-06-27 18:09:28 +0000
@@ -94,7 +94,4 @@
     serf_default_read_bucket,
     serf_barrier_peek,
     serf_barrier_destroy,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/buckets.c'
--- buckets/buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/buckets.c	2011-06-27 18:09:28 +0000
@@ -122,25 +122,6 @@
 }
 
 
-apr_status_t serf_default_snapshot(serf_bucket_t *bucket)
-{
-    /* Not implemented. */
-    return APR_ENOTIMPL;
-}
-
-
-apr_status_t serf_default_restore_snapshot(serf_bucket_t *bucket)
-{
-    /* Not implemented. */
-    return APR_ENOTIMPL;
-}
-
-
-int serf_default_is_snapshot_set(serf_bucket_t *bucket)
-{
-    return 0;  
-}
-
 /* ==================================================================== */
 
 

=== modified file 'buckets/bwtp_buckets.c'
--- buckets/bwtp_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/bwtp_buckets.c	2011-06-27 18:09:28 +0000
@@ -307,9 +307,6 @@
     serf_default_read_bucket,
     serf_bwtp_frame_peek,
     serf_default_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };
 
 
@@ -596,7 +593,4 @@
     serf_default_read_bucket,
     bwtp_incoming_peek,
     bwtp_incoming_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/chunk_buckets.c'
--- buckets/chunk_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/chunk_buckets.c	2011-06-27 18:09:28 +0000
@@ -57,7 +57,7 @@
     serf_bucket_t *simple_bkt;
     apr_size_t chunk_len;
     apr_size_t stream_len;
-    struct iovec vecs[34]; /* 32 + chunk trailer + EOF trailer = 34 */
+    struct iovec vecs[66]; /* 64 + chunk trailer + EOF trailer = 66 */
     int vecs_read;
     int i;
 
@@ -67,7 +67,7 @@
 
     ctx->last_status =
         serf_bucket_read_iovec(ctx->stream, SERF_READ_ALL_AVAIL,
-                               32, vecs, &vecs_read);
+                               64, vecs, &vecs_read);
 
     if (SERF_BUCKET_READ_ERROR(ctx->last_status)) {
         /* Uh-oh. */
@@ -232,7 +232,4 @@
     serf_default_read_bucket,
     serf_chunk_peek,
     serf_chunk_destroy,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/dechunk_buckets.c'
--- buckets/dechunk_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/dechunk_buckets.c	2011-06-27 18:09:28 +0000
@@ -182,7 +182,4 @@
     serf_default_read_bucket,
     serf_dechunk_peek,
     serf_dechunk_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/deflate_buckets.c'
--- buckets/deflate_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/deflate_buckets.c	2011-06-27 18:09:28 +0000
@@ -60,10 +60,10 @@
     int bufferSize;
 
     /* How much of the chunk, or the terminator, do we have left to read? */
-    apr_int64_t stream_left;
+    apr_size_t stream_left;
 
     /* How much are we supposed to read? */
-    apr_int64_t stream_size;
+    apr_size_t stream_size;
 
     int stream_status; /* What was the last status we read? */
 
@@ -178,10 +178,10 @@
         case STATE_HEADER:
             if (ctx->hdr_buffer[0] != deflate_magic[0] ||
                 ctx->hdr_buffer[1] != deflate_magic[1]) {
-                return APR_EGENERAL;
+                return SERF_ERROR_DECOMPRESSION_FAILED;
             }
             if (ctx->hdr_buffer[3] != 0) {
-                return APR_EGENERAL;
+                return SERF_ERROR_DECOMPRESSION_FAILED;
             }
             ctx->state++;
             break;
@@ -189,18 +189,18 @@
             /* Do the checksum computation. */
             compCRC = getLong((unsigned char*)ctx->hdr_buffer);
             if (ctx->crc != compCRC) {
-                return APR_EGENERAL;
+                return SERF_ERROR_DECOMPRESSION_FAILED;
             }
             compLen = getLong((unsigned char*)ctx->hdr_buffer + 4);
             if (ctx->zstream.total_out != compLen) {
-                return APR_EGENERAL;
+                return SERF_ERROR_DECOMPRESSION_FAILED;
             }
             ctx->state++;
             break;
         case STATE_INIT:
             zRC = inflateInit2(&ctx->zstream, ctx->windowSize);
             if (zRC != Z_OK) {
-                return APR_EGENERAL;
+                return SERF_ERROR_DECOMPRESSION_FAILED;
             }
             ctx->zstream.next_out = ctx->buffer;
             ctx->zstream.avail_out = ctx->bufferSize;
@@ -331,7 +331,7 @@
                     break;
                 }
                 if (zRC != Z_OK) {
-                    return APR_EGENERAL;
+                    return SERF_ERROR_DECOMPRESSION_FAILED;
                 }
             }
             /* Okay, we've inflated.  Try to read. */
@@ -344,7 +344,15 @@
                  * we'll iterate one more time.
                  */
                 if (APR_STATUS_IS_EOF(status)) {
-                    return APR_SUCCESS;
+                    /* No more data to read from the stream, and everything
+                       inflated. If all data was received correctly, state
+                       should have been advanced to STATE_READING_VERIFY or
+                       STATE_FINISH. If not, then the data was incomplete
+                       and we have an error. */
+                    if (ctx->state != STATE_INFLATE)
+                        return APR_SUCCESS;
+                    else
+                        return SERF_ERROR_DECOMPRESSION_FAILED;
                 }
             }
             return status;
@@ -373,8 +381,4 @@
     serf_default_read_bucket,
     serf_deflate_peek,
     serf_deflate_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };
-

=== modified file 'buckets/file_buckets.c'
--- buckets/file_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/file_buckets.c	2011-06-27 18:09:28 +0000
@@ -114,7 +114,4 @@
     serf_default_read_bucket,
     serf_file_peek,
     serf_default_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/headers_buckets.c'
--- buckets/headers_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/headers_buckets.c	2011-06-27 18:09:28 +0000
@@ -426,7 +426,4 @@
     serf_default_read_bucket,
     serf_headers_peek,
     serf_headers_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== added file 'buckets/iovec_buckets.c'
--- buckets/iovec_buckets.c	1970-01-01 00:00:00 +0000
+++ buckets/iovec_buckets.c	2011-06-27 18:09:28 +0000
@@ -0,0 +1,169 @@
+/* Copyright 2011 Justin Erenkrantz and Greg Stein
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include <apr_pools.h>
+
+#include "serf.h"
+#include "serf_bucket_util.h"
+
+
+typedef struct {
+    struct iovec *vecs;
+
+    /* Total number of buffer stored in the vecs var. */
+    int vecs_len;
+    /* Points to the first unread buffer. */
+    int current_vec;
+    /* First buffer offset. */
+    int offset;
+} iovec_context_t;
+
+serf_bucket_t *serf_bucket_iovec_create(
+    struct iovec vecs[],
+    int len,
+    serf_bucket_alloc_t *allocator)
+{
+    iovec_context_t *ctx;
+    int i;
+
+    ctx = serf_bucket_mem_alloc(allocator, sizeof(*ctx));
+    ctx->vecs = serf_bucket_mem_alloc(allocator, len * sizeof(struct iovec));
+    ctx->vecs_len = len;
+    ctx->current_vec = 0;
+    ctx->offset = 0;
+
+    /* copy all buffers to our iovec. */
+    for (i = 0; i < len; i++) {
+        ctx->vecs[i].iov_base = vecs[i].iov_base;
+        ctx->vecs[i].iov_len = vecs[i].iov_len;
+    }
+
+    return serf_bucket_create(&serf_bucket_type_iovec, allocator, ctx);
+}
+
+static apr_status_t serf_iovec_readline(serf_bucket_t *bucket,
+                                         int acceptable, int *found,
+                                         const char **data, apr_size_t *len)
+{
+    return APR_ENOTIMPL;
+}
+
+static apr_status_t serf_iovec_read_iovec(serf_bucket_t *bucket,
+                                          apr_size_t requested,
+                                          int vecs_size,
+                                          struct iovec *vecs,
+                                          int *vecs_used)
+{
+    iovec_context_t *ctx = bucket->data;
+
+    *vecs_used = 0;
+
+    /* copy the requested amount of buffers to the provided iovec. */
+    for (; ctx->current_vec < ctx->vecs_len; ctx->current_vec++) {
+        struct iovec vec = ctx->vecs[ctx->current_vec];
+        apr_size_t remaining;
+
+        if (requested != SERF_READ_ALL_AVAIL && requested <= 0)
+            break;
+        if (*vecs_used >= vecs_size)
+            break;
+
+        vecs[*vecs_used].iov_base = (char*)vec.iov_base + ctx->offset;
+        remaining = vec.iov_len - ctx->offset;
+
+        /* Less bytes requested than remaining in the current buffer. */
+        if (requested != SERF_READ_ALL_AVAIL && requested < remaining) {
+            vecs[*vecs_used].iov_len = requested;
+            ctx->offset += requested;
+            requested = 0;
+            (*vecs_used)++;
+            break;
+        } else {
+            /* Copy the complete buffer. */
+            vecs[*vecs_used].iov_len = remaining;
+            ctx->offset = 0;
+            if (requested != SERF_READ_ALL_AVAIL)
+                requested -= remaining;
+            (*vecs_used)++;
+        }
+    }
+
+    if (ctx->current_vec == ctx->vecs_len && !ctx->offset)
+        return APR_EOF;
+
+    return APR_SUCCESS;
+}
+
+static apr_status_t serf_iovec_read(serf_bucket_t *bucket,
+                                    apr_size_t requested,
+                                    const char **data, apr_size_t *len)
+{
+    struct iovec vec[1];
+    apr_status_t status;
+    int vecs_used;
+
+    status = serf_iovec_read_iovec(bucket, requested, 1, vec, &vecs_used);
+
+    if (vecs_used) {
+        *data = vec[0].iov_base;
+        *len = vec[0].iov_len;
+    } else {
+        *len = 0;
+    }
+
+    return status;
+}
+
+static apr_status_t serf_iovec_peek(serf_bucket_t *bucket,
+                                    const char **data,
+                                    apr_size_t *len)
+{
+    iovec_context_t *ctx = bucket->data;
+
+    if (ctx->current_vec >= ctx->vecs_len) {
+        *len = 0;
+        return APR_EOF;
+    }
+
+    /* Return the first unread buffer, don't bother combining all
+       remaining data. */
+    *data = ctx->vecs[ctx->current_vec].iov_base;
+    *len = ctx->vecs[ctx->current_vec].iov_len;
+
+    if (ctx->current_vec + 1 == ctx->vecs_len)
+        return APR_EOF;
+
+    return APR_SUCCESS;
+}
+
+static void serf_iovec_destroy(serf_bucket_t *bucket)
+{
+    iovec_context_t *ctx = bucket->data;
+
+    serf_bucket_mem_free(bucket->allocator, ctx->vecs);
+    serf_default_destroy_and_data(bucket);
+}
+
+
+const serf_bucket_type_t serf_bucket_type_iovec = {
+    "IOVEC",
+    serf_iovec_read,
+    serf_iovec_readline,
+    serf_iovec_read_iovec,
+    serf_default_read_for_sendfile,
+    serf_default_read_bucket,
+    serf_iovec_peek,
+    serf_iovec_destroy,
+};

=== modified file 'buckets/limit_buckets.c'
--- buckets/limit_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/limit_buckets.c	2011-06-27 18:09:28 +0000
@@ -21,12 +21,12 @@
 
 typedef struct {
     serf_bucket_t *stream;
-    apr_size_t remaining;
+    apr_uint64_t remaining;
 } limit_context_t;
 
 
 serf_bucket_t *serf_bucket_limit_create(
-    serf_bucket_t *stream, apr_size_t len, serf_bucket_alloc_t *allocator)
+    serf_bucket_t *stream, apr_uint64_t len, serf_bucket_alloc_t *allocator)
 {
     limit_context_t *ctx;
 
@@ -49,8 +49,13 @@
         return APR_EOF;
     }
 
-    if (requested == SERF_READ_ALL_AVAIL || requested > ctx->remaining)
-        requested = ctx->remaining;
+    if (requested == SERF_READ_ALL_AVAIL || requested > ctx->remaining) {
+        if (ctx->remaining <= APR_SIZE_MAX) {
+            requested = (apr_size_t) ctx->remaining;
+        } else {
+            requested = APR_SIZE_MAX;
+        }
+    }
 
     status = serf_bucket_read(ctx->stream, requested, data, len);
 
@@ -119,7 +124,4 @@
     serf_default_read_bucket,
     serf_limit_peek,
     serf_limit_destroy,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/mmap_buckets.c'
--- buckets/mmap_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/mmap_buckets.c	2011-06-27 18:09:28 +0000
@@ -115,7 +115,4 @@
     serf_default_read_bucket,
     serf_mmap_peek,
     serf_default_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/request_buckets.c'
--- buckets/request_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/request_buckets.c	2011-06-27 18:09:28 +0000
@@ -200,8 +200,5 @@
     serf_default_read_bucket,
     serf_request_peek,
     serf_default_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };
 

=== modified file 'buckets/response_buckets.c'
--- buckets/response_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/response_buckets.c	2011-06-27 18:09:28 +0000
@@ -109,7 +109,7 @@
     res = apr_date_checkmask(ctx->linebuf.line, "HTTP/#.# ###*");
     if (!res) {
         /* Not an HTTP response?  Well, at least we won't understand it. */
-        return APR_EGENERAL;
+        return SERF_ERROR_BAD_HTTP_RESPONSE;
     }
 
     ctx->sl.version = SERF_HTTP_VERSION(ctx->linebuf.line[5] - '0',
@@ -150,7 +150,7 @@
         end_key = c = memchr(ctx->linebuf.line, ':', ctx->linebuf.used);
         if (!c) {
             /* Bad headers? */
-            return APR_EGENERAL;
+            return SERF_ERROR_BAD_HTTP_RESPONSE;
         }
 
         /* Skip over initial ':' */
@@ -426,7 +426,4 @@
     serf_default_read_bucket,
     serf_response_peek,
     serf_response_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/simple_buckets.c'
--- buckets/simple_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/simple_buckets.c	2011-06-27 18:09:28 +0000
@@ -27,7 +27,6 @@
     serf_simple_freefunc_t freefunc;
     void *baton;
 
-    apr_size_t original_len;
 } simple_context_t;
 
 
@@ -46,10 +45,8 @@
     simple_context_t *ctx;
 
     ctx = serf_bucket_mem_alloc(allocator, sizeof(*ctx));
-    ctx->current = data;
+    ctx->original = ctx->current = data;
     ctx->remaining = len;
-    ctx->original = NULL;
-    ctx->original_len = -1;
     ctx->freefunc = freefunc;
     ctx->baton = freefunc_baton;
 
@@ -132,34 +129,6 @@
     serf_default_destroy_and_data(bucket);
 }
 
-static apr_status_t serf_simple_snapshot(serf_bucket_t *bucket)
-{
-    simple_context_t *ctx = bucket->data;
-
-    ctx->original = ctx->current;
-    ctx->original_len = ctx->remaining;
-
-    return APR_SUCCESS;
-}
-
-static apr_status_t serf_simple_restore_snapshot(serf_bucket_t *bucket)
-{
-    simple_context_t *ctx = bucket->data;
-
-    ctx->current = ctx->original;
-    ctx->remaining = ctx->original_len;
-    ctx->original = NULL;
-    ctx->original_len = -1;
-
-    return APR_SUCCESS;
-}
-
-static int serf_simple_is_snapshot_set(serf_bucket_t *bucket)
-{
-    simple_context_t *ctx = bucket->data;
-
-    return ctx->original != NULL;  
-}
 
 const serf_bucket_type_t serf_bucket_type_simple = {
     "SIMPLE",
@@ -170,7 +139,4 @@
     serf_default_read_bucket,
     serf_simple_peek,
     serf_simple_destroy,
-    serf_simple_snapshot,
-    serf_simple_restore_snapshot,
-    serf_simple_is_snapshot_set,
 };

=== modified file 'buckets/socket_buckets.c'
--- buckets/socket_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/socket_buckets.c	2011-06-27 18:09:28 +0000
@@ -111,7 +111,4 @@
     serf_default_read_bucket,
     serf_socket_peek,
     serf_default_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'buckets/ssl_buckets.c'
--- buckets/ssl_buckets.c	2011-06-03 03:18:07 +0000
+++ buckets/ssl_buckets.c	2011-06-27 18:09:28 +0000
@@ -49,6 +49,7 @@
 #include <openssl/ssl.h>
 #include <openssl/err.h>
 #include <openssl/pkcs12.h>
+#include <openssl/x509v3.h>
 
 #ifndef APR_VERSION_AT_LEAST /* Introduced in APR 1.3.0 */
 #define APR_VERSION_AT_LEAST(major,minor,patch)                           \
@@ -126,6 +127,8 @@
 
     /* The status of the last thing we read. */
     apr_status_t status;
+    apr_status_t exhausted;
+    int exhausted_reset;
 
     /* Data we've read but not processed. */
     serf_bucket_t *pending;
@@ -201,7 +204,17 @@
     printf("bio_bucket_read called for %d bytes\n", inlen);
 #endif
 
-    BIO_clear_retry_flags(bio);
+    if (ctx->encrypt.status == SERF_ERROR_WAIT_CONN
+        && BIO_should_read(ctx->bio)) {
+#ifdef SSL_VERBOSE
+        printf("bio_bucket_read waiting: (%d %d %d)\n",
+           BIO_should_retry(ctx->bio), BIO_should_read(ctx->bio),
+           BIO_get_retry_flags(ctx->bio));
+#endif
+        /* Falling back... */
+        ctx->encrypt.exhausted_reset = 1;
+        BIO_clear_retry_flags(bio);
+    }
 
     status = serf_bucket_read(ctx->decrypt.pending, inlen, &data, &len);
 
@@ -234,7 +247,17 @@
 #ifdef SSL_VERBOSE
     printf("bio_bucket_write called for %d bytes\n", inl);
 #endif
-    BIO_clear_retry_flags(bio);
+    if (ctx->encrypt.status == SERF_ERROR_WAIT_CONN
+        && !BIO_should_read(ctx->bio)) {
+#ifdef SSL_VERBOSE
+        printf("bio_bucket_write waiting: (%d %d %d)\n",
+           BIO_should_retry(ctx->bio), BIO_should_read(ctx->bio),
+           BIO_get_retry_flags(ctx->bio));
+#endif
+        /* Falling back... */
+        ctx->encrypt.exhausted_reset = 1;
+        BIO_clear_retry_flags(bio);
+    }
 
     tmp = serf_bucket_simple_copy_create(in, inl,
                                          ctx->encrypt.pending->allocator);
@@ -442,6 +465,10 @@
     const char *data;
     int ssl_len;
 
+#ifdef SSL_VERBOSE
+    printf("ssl_decrypt: begin %d\n", bufsize);
+#endif
+
     /* Is there some data waiting to be read? */
     ssl_len = SSL_read(ctx->ssl, buf, bufsize);
     if (ssl_len > 0) {
@@ -496,6 +523,9 @@
         }
         else {
             *len = ssl_len;
+#ifdef SSL_VERBOSE
+            printf("---\n%s\n-(%d)-\n", buf, *len);
+#endif
         }
     }
     else {
@@ -513,10 +543,15 @@
                                 char *buf, apr_size_t *len)
 {
     const char *data;
+    apr_size_t interim_bufsize;
     serf_ssl_context_t *ctx = baton;
     apr_status_t status;
 
-    /* Try to read unread data first. */
+#ifdef SSL_VERBOSE
+    printf("ssl_encrypt: begin %d\n", bufsize);
+#endif
+
+    /* Try to read already encrypted but unread data first. */
     status = serf_bucket_read(ctx->encrypt.pending, bufsize, &data, len);
     if (SERF_BUCKET_READ_ERROR(status)) {
         return status;
@@ -543,72 +578,145 @@
         return APR_EAGAIN;
     }
 
+    /* If we were previously blocked, unblock ourselves now. */
+    if (BIO_should_read(ctx->bio)) {
+#ifdef SSL_VERBOSE
+        printf("ssl_encrypt: reset %d %d (%d %d %d)\n", status,
+               ctx->encrypt.status,
+           BIO_should_retry(ctx->bio), BIO_should_read(ctx->bio),
+           BIO_get_retry_flags(ctx->bio));
+#endif
+        ctx->encrypt.status = APR_SUCCESS;
+        ctx->encrypt.exhausted_reset = 0;
+    }
+
     /* Oh well, read from our stream now. */
-    if (!APR_STATUS_IS_EOF(ctx->encrypt.status)) {
-        status = serf_bucket_read(ctx->encrypt.stream, bufsize, &data, len);
-    }
-    else {
-        *len = 0;
-        status = APR_EOF;
-    }
-
-    if (!SERF_BUCKET_READ_ERROR(status) && *len) {
-        int ssl_len;
-
-#ifdef SSL_VERBOSE
-        printf("ssl_encrypt: bucket read %d bytes; status %d\n", *len, status);
-#endif
-        ctx->encrypt.status = status;
-
-        ssl_len = SSL_write(ctx->ssl, data, *len);
-#ifdef SSL_VERBOSE
-        printf("ssl_encrypt: SSL write: %d\n", ssl_len);
-#endif
-        if (ssl_len < 0) {
-            int ssl_err;
-            serf_bucket_t *tmp;
-
-            /* Ah, bugger. We need to put that data back. */
-            tmp = serf_bucket_simple_copy_create(data, *len,
-                                             ctx->encrypt.stream->allocator);
-
-            serf_bucket_aggregate_prepend(ctx->encrypt.stream, tmp);
-
-            ssl_err = SSL_get_error(ctx->ssl, ssl_len);
-            if (ssl_err == SSL_ERROR_SYSCALL) {
-                status = ctx->encrypt.status;
-                if (SERF_BUCKET_READ_ERROR(status)) {
-                    return status;
-                }
-            }
-            else {
-                /* Oh, no. */
-                if (ssl_err == SSL_ERROR_WANT_READ) {
-                    status = APR_EAGAIN;
-                }
-                else {
-                    status = APR_EGENERAL;
-                }
-            }
+    interim_bufsize = bufsize;
+    do {
+        apr_size_t interim_len;
+
+        if (!ctx->encrypt.status) {
+            struct iovec vecs[64];
+            int vecs_read;
+
+            status = serf_bucket_read_iovec(ctx->encrypt.stream,
+                                            interim_bufsize, 64, vecs,
+                                            &vecs_read);
+
+            if (!SERF_BUCKET_READ_ERROR(status) && vecs_read) {
+                char *vecs_data;
+                int i, cur, vecs_data_len;
+                int ssl_len;
+
+                /* Combine the buffers of the iovec into one buffer, as
+                   that is with SSL_write requires. */
+                vecs_data_len = 0;
+                for (i = 0; i < vecs_read; i++) {
+                    vecs_data_len += vecs[i].iov_len;
+                }
+
+                vecs_data = serf_bucket_mem_alloc(ctx->allocator,
+                                                  vecs_data_len);
+
+                cur = 0;
+                for (i = 0; i < vecs_read; i++) {
+                    memcpy(vecs_data + cur, vecs[i].iov_base, vecs[i].iov_len);
+                    cur += vecs[i].iov_len;
+                }
+
+                interim_bufsize -= vecs_data_len;
+                interim_len = vecs_data_len;
+
+#ifdef SSL_VERBOSE
+                printf("ssl_encrypt: bucket read %d bytes; status %d\n",
+                       interim_len, status);
+                printf("---\n%s\n-(%d)-\n", vecs_data, interim_len);
+#endif
+                /* Stash our status away. */
+                ctx->encrypt.status = status;
+
+                ssl_len = SSL_write(ctx->ssl, vecs_data, interim_len);
+#ifdef SSL_VERBOSE
+                printf("ssl_encrypt: SSL write: %d\n", ssl_len);
+#endif
+                /* We're done. */
+                serf_bucket_mem_free(ctx->allocator, vecs_data);
+
+                /* If we failed to write... */
+                if (ssl_len < 0) {
+                    int ssl_err;
+
+                    /* Ah, bugger. We need to put that data back. */
+                    serf_bucket_aggregate_prepend_iovec(ctx->encrypt.stream,
+                                                        vecs, vecs_read);
+
+                    ssl_err = SSL_get_error(ctx->ssl, ssl_len);
+#ifdef SSL_VERBOSE
+                    printf("ssl_encrypt: SSL write error: %d\n", ssl_err);
+#endif
+                    if (ssl_err == SSL_ERROR_SYSCALL) {
+                        status = ctx->encrypt.status;
+                        if (SERF_BUCKET_READ_ERROR(status)) {
+                            return status;
+                        }
+                    }
+                    else {
+                        /* Oh, no. */
+                        if (ssl_err == SSL_ERROR_WANT_READ) {
+                            status = SERF_ERROR_WAIT_CONN;
+                        }
+                        else {
+                            status = APR_EGENERAL;
+                        }
+                    }
+#ifdef SSL_VERBOSE
+                    printf("ssl_encrypt: SSL write error: %d %d\n", status, *len);
+#endif
+                }
+            }
+        }
+        else {
+            interim_len = 0;
             *len = 0;
-        }
-        else {
-            apr_status_t agg_status;
-
-            /* We read something! */
-            agg_status = serf_bucket_read(ctx->encrypt.pending, bufsize,
-                                          &data, len);
-
-            memcpy(buf, data, *len);
-
-            if (APR_STATUS_IS_EOF(status) && !APR_STATUS_IS_EOF(agg_status)) {
-                status = agg_status;
-            }
-        }
-    }
-
-#ifdef SSL_VERBOSE
-    printf("ssl_encrypt finished: %d %d %d\n", status, *len,
+            status = ctx->encrypt.status;
+        }
+
+    } while (!status && interim_bufsize);
+
+    /* Okay, we exhausted our underlying stream. */
+    if (!SERF_BUCKET_READ_ERROR(status)) {
+        apr_status_t agg_status;
+        struct iovec vecs[64];
+        int vecs_read, i;
+
+        /* We read something! */
+        agg_status = serf_bucket_read_iovec(ctx->encrypt.pending, bufsize,
+                                            64, vecs, &vecs_read);
+        *len = 0;
+        for (i = 0; i < vecs_read; i++) {
+            memcpy(buf + *len, vecs[i].iov_base, vecs[i].iov_len);
+            *len += vecs[i].iov_len;
+        }
+
+#ifdef SSL_VERBOSE
+        printf("ssl_encrypt read agg: %d %d %d %d\n", status, agg_status,
+               ctx->encrypt.status, *len);
+#endif
+
+        if (!agg_status) {
+            status = agg_status;
+        }
+    }
+
+    if (status == SERF_ERROR_WAIT_CONN
+        && BIO_should_retry(ctx->bio) && BIO_should_read(ctx->bio)) {
+        ctx->encrypt.exhausted = ctx->encrypt.status;
+        ctx->encrypt.status = SERF_ERROR_WAIT_CONN;
+    }
+
+#ifdef SSL_VERBOSE
+    printf("ssl_encrypt finished: %d %d (%d %d %d)\n", status, *len,
+           BIO_should_retry(ctx->bio), BIO_should_read(ctx->bio),
            BIO_get_retry_flags(ctx->bio));
 #endif
     return status;
@@ -996,6 +1104,17 @@
     return serf_bucket_create(type, allocator, ctx);
 }
 
+apr_status_t serf_ssl_set_hostname(serf_ssl_context_t *context,
+                                   const char * hostname)
+{
+#ifdef SSL_set_tlsext_host_name
+    if (SSL_set_tlsext_host_name(context->ssl, hostname) != 1) {
+        ERR_clear_error();
+    }
+#endif
+    return APR_SUCCESS;
+}
+
 apr_status_t serf_ssl_use_default_certificates(serf_ssl_context_t *ssl_ctx)
 {
     X509_STORE *store = SSL_CTX_get_cert_store(ssl_ctx->ctx);
@@ -1059,8 +1178,6 @@
     }
     ctx->ssl_ctx->decrypt.stream = stream;
     ctx->our_stream = &ctx->ssl_ctx->decrypt.stream;
-    ctx->ssl_ctx->decrypt.pending =
-        serf_bucket_aggregate_create(allocator);
 
     return bkt;
 }
@@ -1215,6 +1332,7 @@
     unsigned int md_size, i;
     unsigned char md[EVP_MAX_MD_SIZE];
     BIO *bio;
+    STACK_OF(GENERAL_NAME) *names;
 
     /* sha1 fingerprint */
     if (X509_digest(cert->ssl_cert, EVP_sha1(), md, &md_size)) {
@@ -1258,6 +1376,33 @@
     }
     BIO_free(bio);
 
+    /* Get subjectAltNames */
+    names = X509_get_ext_d2i(cert->ssl_cert, NID_subject_alt_name, NULL, NULL);
+    if (names) {
+        int names_count = sk_GENERAL_NAME_num(names);
+
+        apr_array_header_t *san_arr = apr_array_make(pool, names_count,
+                                                     sizeof(char*));
+        apr_hash_set(tgt, "subjectAltName", APR_HASH_KEY_STRING, san_arr);
+        for (i = 0; i < names_count; i++) {
+            char *p = NULL;
+            GENERAL_NAME *nm = sk_GENERAL_NAME_value(names, i);
+
+            switch (nm->type) {
+            case GEN_DNS:
+                p = apr_pstrmemdup(pool, nm->d.ia5->data, nm->d.ia5->length);
+                break;
+            default:
+                /* Don't know what to do - skip. */
+                break;
+            }
+            if (p) {
+                APR_ARRAY_PUSH(san_arr, char*) = p;
+            }
+        }
+        sk_GENERAL_NAME_pop_free(names, GENERAL_NAME_free);
+    }
+
     return tgt;
 }
 
@@ -1266,9 +1411,10 @@
     const serf_ssl_certificate_t *cert,
     apr_pool_t *pool)
 {
-    char *binary_cert, *p;
+    char *binary_cert;
     char *encoded_cert;
     int len;
+    unsigned char *unused;
 
     /* find the length of the DER encoding. */
     len = i2d_X509(cert->ssl_cert, NULL);
@@ -1277,8 +1423,8 @@
     }
 
     binary_cert = apr_palloc(pool, len);
-    p = binary_cert;
-    len = i2d_X509(cert->ssl_cert, &p); /* p is incremented */
+    unused = (unsigned char *)binary_cert;
+    len = i2d_X509(cert->ssl_cert, &unused);  /* unused is incremented  */
     if (len < 0) {
         return NULL;
     }
@@ -1383,9 +1529,6 @@
     serf_default_read_bucket,
     serf_ssl_peek,
     serf_ssl_encrypt_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };
 
 const serf_bucket_type_t serf_bucket_type_ssl_decrypt = {
@@ -1397,7 +1540,4 @@
     serf_default_read_bucket,
     serf_ssl_peek,
     serf_ssl_decrypt_destroy_and_data,
-    serf_default_snapshot,
-    serf_default_restore_snapshot,
-    serf_default_is_snapshot_set,
 };

=== modified file 'build/config.guess'
--- build/config.guess	2007-02-21 03:27:51 +0000
+++ build/config.guess	2011-06-27 18:09:28 +0000
@@ -1,10 +1,10 @@
 #! /bin/sh
 # Attempt to guess a canonical system name.
 #   Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999,
-#   2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software Foundation,
-#   Inc.
+#   2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008
+#   Free Software Foundation, Inc.
 
-timestamp='2006-07-02'
+timestamp='2008-01-23'
 
 # This file is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by
@@ -56,8 +56,8 @@
 GNU config.guess ($timestamp)
 
 Originally written by Per Bothner.
-Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005
-Free Software Foundation, Inc.
+Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001,
+2002, 2003, 2004, 2005, 2006, 2007, 2008 Free Software Foundation, Inc.
 
 This is free software; see the source for copying conditions.  There is NO
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
@@ -161,6 +161,7 @@
 	    arm*) machine=arm-unknown ;;
 	    sh3el) machine=shl-unknown ;;
 	    sh3eb) machine=sh-unknown ;;
+	    sh5el) machine=sh5le-unknown ;;
 	    *) machine=${UNAME_MACHINE_ARCH}-unknown ;;
 	esac
 	# The Operating System including object format, if it has switched
@@ -329,7 +330,7 @@
     sun4*:SunOS:5.*:* | tadpole*:SunOS:5.*:*)
 	echo sparc-sun-solaris2`echo ${UNAME_RELEASE}|sed -e 's/[^.]*//'`
 	exit ;;
-    i86pc:SunOS:5.*:*)
+    i86pc:SunOS:5.*:* | i86xen:SunOS:5.*:*)
 	echo i386-pc-solaris2`echo ${UNAME_RELEASE}|sed -e 's/[^.]*//'`
 	exit ;;
     sun4*:SunOS:6*:*)
@@ -531,7 +532,7 @@
 		echo rs6000-ibm-aix3.2
 	fi
 	exit ;;
-    *:AIX:*:[45])
+    *:AIX:*:[456])
 	IBM_CPU_ID=`/usr/sbin/lsdev -C -c processor -S available | sed 1q | awk '{ print $1 }'`
 	if /usr/sbin/lsattr -El ${IBM_CPU_ID} | grep ' POWER' >/dev/null 2>&1; then
 		IBM_ARCH=rs6000
@@ -780,7 +781,7 @@
     i*:CYGWIN*:*)
 	echo ${UNAME_MACHINE}-pc-cygwin
 	exit ;;
-    i*:MINGW*:*)
+    *:MINGW*:*)
 	echo ${UNAME_MACHINE}-pc-mingw32
 	exit ;;
     i*:windows32*:*)
@@ -790,12 +791,18 @@
     i*:PW*:*)
 	echo ${UNAME_MACHINE}-pc-pw32
 	exit ;;
-    x86:Interix*:[3456]*)
-	echo i586-pc-interix${UNAME_RELEASE}
-	exit ;;
-    EM64T:Interix*:[3456]*)
-	echo x86_64-unknown-interix${UNAME_RELEASE}
-	exit ;;
+    *:Interix*:[3456]*)
+    	case ${UNAME_MACHINE} in
+	    x86)
+		echo i586-pc-interix${UNAME_RELEASE}
+		exit ;;
+	    EM64T | authenticamd)
+		echo x86_64-unknown-interix${UNAME_RELEASE}
+		exit ;;
+	    IA64)
+		echo ia64-unknown-interix${UNAME_RELEASE}
+		exit ;;
+	esac ;;
     [345]86:Windows_95:* | [345]86:Windows_98:* | [345]86:Windows_NT:*)
 	echo i${UNAME_MACHINE}-pc-mks
 	exit ;;
@@ -829,7 +836,14 @@
 	echo ${UNAME_MACHINE}-pc-minix
 	exit ;;
     arm*:Linux:*:*)
-	echo ${UNAME_MACHINE}-unknown-linux-gnu
+	eval $set_cc_for_build
+	if echo __ARM_EABI__ | $CC_FOR_BUILD -E - 2>/dev/null \
+	    | grep -q __ARM_EABI__
+	then
+	    echo ${UNAME_MACHINE}-unknown-linux-gnu
+	else
+	    echo ${UNAME_MACHINE}-unknown-linux-gnueabi
+	fi
 	exit ;;
     avr32*:Linux:*:*)
 	echo ${UNAME_MACHINE}-unknown-linux-gnu
@@ -950,6 +964,9 @@
     x86_64:Linux:*:*)
 	echo x86_64-unknown-linux-gnu
 	exit ;;
+    xtensa*:Linux:*:*)
+    	echo ${UNAME_MACHINE}-unknown-linux-gnu
+	exit ;;
     i*86:Linux:*:*)
 	# The BFD linker knows what the default object file format is, so
 	# first see if it will tell us. cd to the root directory to prevent
@@ -1208,6 +1225,15 @@
     SX-6:SUPER-UX:*:*)
 	echo sx6-nec-superux${UNAME_RELEASE}
 	exit ;;
+    SX-7:SUPER-UX:*:*)
+	echo sx7-nec-superux${UNAME_RELEASE}
+	exit ;;
+    SX-8:SUPER-UX:*:*)
+	echo sx8-nec-superux${UNAME_RELEASE}
+	exit ;;
+    SX-8R:SUPER-UX:*:*)
+	echo sx8r-nec-superux${UNAME_RELEASE}
+	exit ;;
     Power*:Rhapsody:*:*)
 	echo powerpc-apple-rhapsody${UNAME_RELEASE}
 	exit ;;
@@ -1458,9 +1484,9 @@
 the operating system you are using. It is advised that you
 download the most up to date version of the config scripts from
 
-  http://savannah.gnu.org/cgi-bin/viewcvs/*checkout*/config/config/config.guess
+  http://git.savannah.gnu.org/gitweb/?p=config.git;a=blob_plain;f=config.guess;hb=HEAD
 and
-  http://savannah.gnu.org/cgi-bin/viewcvs/*checkout*/config/config/config.sub
+  http://git.savannah.gnu.org/gitweb/?p=config.git;a=blob_plain;f=config.sub;hb=HEAD
 
 If the version you run ($0) is already up to date, please
 send the following data and any information you think might be

=== modified file 'build/config.sub'
--- build/config.sub	2007-02-21 03:27:51 +0000
+++ build/config.sub	2011-06-27 18:09:28 +0000
@@ -1,10 +1,10 @@
 #! /bin/sh
 # Configuration validation subroutine script.
 #   Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999,
-#   2000, 2001, 2002, 2003, 2004, 2005, 2006 Free Software Foundation,
-#   Inc.
+#   2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008
+#   Free Software Foundation, Inc.
 
-timestamp='2006-07-02'
+timestamp='2008-01-16'
 
 # This file is (in principle) common to ALL GNU software.
 # The presence of a machine in this file suggests that SOME GNU software
@@ -72,8 +72,8 @@
 version="\
 GNU config.sub ($timestamp)
 
-Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005
-Free Software Foundation, Inc.
+Copyright (C) 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001,
+2002, 2003, 2004, 2005, 2006, 2007, 2008 Free Software Foundation, Inc.
 
 This is free software; see the source for copying conditions.  There is NO
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
@@ -245,12 +245,12 @@
 	| bfin \
 	| c4x | clipper \
 	| d10v | d30v | dlx | dsp16xx \
-	| fr30 | frv \
+	| fido | fr30 | frv \
 	| h8300 | h8500 | hppa | hppa1.[01] | hppa2.0 | hppa2.0[nw] | hppa64 \
 	| i370 | i860 | i960 | ia64 \
 	| ip2k | iq2000 \
 	| m32c | m32r | m32rle | m68000 | m68k | m88k \
-	| maxq | mb | microblaze | mcore \
+	| maxq | mb | microblaze | mcore | mep \
 	| mips | mipsbe | mipseb | mipsel | mipsle \
 	| mips16 \
 	| mips64 | mips64el \
@@ -276,6 +276,7 @@
 	| pdp10 | pdp11 | pj | pjl \
 	| powerpc | powerpc64 | powerpc64le | powerpcle | ppcbe \
 	| pyramid \
+	| score \
 	| sh | sh[1234] | sh[24]a | sh[23]e | sh[34]eb | sheb | shbe | shle | sh[1234]le | sh3ele \
 	| sh64 | sh64le \
 	| sparc | sparc64 | sparc64b | sparc64v | sparc86x | sparclet | sparclite \
@@ -284,7 +285,7 @@
 	| tahoe | thumb | tic4x | tic80 | tron \
 	| v850 | v850e \
 	| we32k \
-	| x86 | xscale | xscalee[bl] | xstormy16 | xtensa \
+	| x86 | xc16x | xscale | xscalee[bl] | xstormy16 | xtensa \
 	| z8k)
 		basic_machine=$basic_machine-unknown
 		;;
@@ -323,7 +324,7 @@
 	| clipper-* | craynv-* | cydra-* \
 	| d10v-* | d30v-* | dlx-* \
 	| elxsi-* \
-	| f30[01]-* | f700-* | fr30-* | frv-* | fx80-* \
+	| f30[01]-* | f700-* | fido-* | fr30-* | frv-* | fx80-* \
 	| h8300-* | h8500-* \
 	| hppa-* | hppa1.[01]-* | hppa2.0-* | hppa2.0[nw]-* | hppa64-* \
 	| i*86-* | i860-* | i960-* | ia64-* \
@@ -367,11 +368,15 @@
 	| tron-* \
 	| v850-* | v850e-* | vax-* \
 	| we32k-* \
-	| x86-* | x86_64-* | xps100-* | xscale-* | xscalee[bl]-* \
-	| xstormy16-* | xtensa-* \
+	| x86-* | x86_64-* | xc16x-* | xps100-* | xscale-* | xscalee[bl]-* \
+	| xstormy16-* | xtensa*-* \
 	| ymp-* \
 	| z8k-*)
 		;;
+	# Recognize the basic CPU types without company name, with glob match.
+	xtensa*)
+		basic_machine=$basic_machine-unknown
+		;;
 	# Recognize the various machine names and aliases which stand
 	# for a CPU type and a company and sometimes even an OS.
 	386bsd)
@@ -442,6 +447,14 @@
 		basic_machine=ns32k-sequent
 		os=-dynix
 		;;
+	blackfin)
+		basic_machine=bfin-unknown
+		os=-linux
+		;;
+	blackfin-*)
+		basic_machine=bfin-`echo $basic_machine | sed 's/^[^-]*-//'`
+		os=-linux
+		;;
 	c90)
 		basic_machine=c90-cray
 		os=-unicos
@@ -474,8 +487,8 @@
 		basic_machine=craynv-cray
 		os=-unicosmp
 		;;
-	cr16c)
-		basic_machine=cr16c-unknown
+	cr16)
+		basic_machine=cr16-unknown
 		os=-elf
 		;;
 	crds | unos)
@@ -667,6 +680,14 @@
 		basic_machine=m68k-isi
 		os=-sysv
 		;;
+	m68knommu)
+		basic_machine=m68k-unknown
+		os=-linux
+		;;
+	m68knommu-*)
+		basic_machine=m68k-`echo $basic_machine | sed 's/^[^-]*-//'`
+		os=-linux
+		;;
 	m88k-omron*)
 		basic_machine=m88k-omron
 		;;
@@ -682,6 +703,10 @@
 		basic_machine=i386-pc
 		os=-mingw32
 		;;
+	mingw32ce)
+		basic_machine=arm-unknown
+		os=-mingw32ce
+		;;
 	miniframe)
 		basic_machine=m68000-convergent
 		;;
@@ -808,6 +833,14 @@
 		basic_machine=i860-intel
 		os=-osf
 		;;
+	parisc)
+		basic_machine=hppa-unknown
+		os=-linux
+		;;
+	parisc-*)
+		basic_machine=hppa-`echo $basic_machine | sed 's/^[^-]*-//'`
+		os=-linux
+		;;
 	pbd)
 		basic_machine=sparc-tti
 		;;
@@ -909,6 +942,10 @@
 	sb1el)
 		basic_machine=mipsisa64sb1el-unknown
 		;;
+	sde)
+		basic_machine=mipsisa32-sde
+		os=-elf
+		;;
 	sei)
 		basic_machine=mips-sei
 		os=-seiux
@@ -920,6 +957,9 @@
 		basic_machine=sh-hitachi
 		os=-hms
 		;;
+	sh5el)
+		basic_machine=sh5le-unknown
+		;;
 	sh64)
 		basic_machine=sh64-unknown
 		;;
@@ -1009,6 +1049,10 @@
 		basic_machine=tic6x-unknown
 		os=-coff
 		;;
+	tile*)
+		basic_machine=tile-unknown
+		os=-linux-gnu
+		;;
 	tx39)
 		basic_machine=mipstx39-unknown
 		;;
@@ -1214,7 +1258,7 @@
 	      | -os2* | -vos* | -palmos* | -uclinux* | -nucleus* \
 	      | -morphos* | -superux* | -rtmk* | -rtmk-nova* | -windiss* \
 	      | -powermax* | -dnix* | -nx6 | -nx7 | -sei* | -dragonfly* \
-	      | -skyos* | -haiku* | -rdos* | -toppers*)
+	      | -skyos* | -haiku* | -rdos* | -toppers* | -drops*)
 	# Remember, each alternative MUST END IN *, to match a version number.
 		;;
 	-qnx*)
@@ -1366,6 +1410,9 @@
 # system, and we'll never get to this point.
 
 case $basic_machine in
+        score-*)
+		os=-elf
+		;;
         spu-*)
 		os=-elf
 		;;
@@ -1406,6 +1453,9 @@
 	m68*-cisco)
 		os=-aout
 		;;
+        mep-*)
+		os=-elf
+		;;
 	mips*-cisco)
 		os=-elf
 		;;

=== modified file 'build/gen_def.py'
--- build/gen_def.py	2011-06-03 03:18:07 +0000
+++ build/gen_def.py	2011-06-27 18:09:28 +0000
@@ -21,7 +21,7 @@
 #
 # Typically, this script is used like:
 #
-#    C:\PATH> python build/gen_def.py serf.h serf_bucket_types.h serf_bucket_util.h > serf.def
+#    C:\PATH> python build/gen_def.py serf.h serf_bucket_types.h serf_bucket_util.h > build/serf.def
 #
 
 import re
@@ -41,11 +41,22 @@
 _funcs = re.compile(r'^(?:(?:\w+|\*) )+\*?(serf_[a-z][a-z_0-9]*)\(',
                     re.MULTILINE)
 
-def extract_funcs(fname):
-  funcs = [ ]
-  for name in _funcs.findall(open(fname).read()):
-    funcs.append(name)
-  return funcs
+# This regex parses the bucket type definitions which look like:
+#
+#    extern const serf_bucket_type_t serf_bucket_type_FOO;
+#
+_types = re.compile(r'^extern const serf_bucket_type_t (serf_[a-z_]*);',
+                    re.MULTILINE)
+
+
+def extract_exports(fname):
+  content = open(fname).read()
+  exports = [ ]
+  for name in _funcs.findall(content):
+    exports.append(name)
+  for name in _types.findall(content):
+    exports.append(name)
+  return exports
 
 
 if __name__ == '__main__':
@@ -53,5 +64,5 @@
   import sys
   print("EXPORTS")
   for fname in sys.argv[1:]:
-    for func in extract_funcs(fname):
+    for func in extract_exports(fname):
       print(func)

=== modified file 'build/serf.def'
--- build/serf.def	2011-06-03 03:18:07 +0000
+++ build/serf.def	2011-06-27 18:09:28 +0000
@@ -1,4 +1,5 @@
 EXPORTS
+serf_error_string
 serf_context_create
 serf_context_create_ex
 serf_event_trigger
@@ -95,15 +96,13 @@
 serf_bucket_ssl_decrypt_create
 serf_bucket_ssl_decrypt_context_get
 serf_bucket_barrier_create
+serf_bucket_iovec_create
 serf_bucket_create
 serf_default_read_iovec
 serf_default_read_for_sendfile
 serf_default_read_bucket
 serf_default_destroy
 serf_default_destroy_and_data
-serf_default_snapshot
-serf_default_restore_snapshot
-serf_default_is_snapshot_set
 serf_bucket_mem_alloc
 serf_bucket_mem_calloc
 serf_bucket_mem_free

=== modified file 'buildconf'
--- buildconf	2011-06-03 03:18:07 +0000
+++ buildconf	2011-06-27 18:09:28 +0000
@@ -23,8 +23,9 @@
 # set a couple of defaults for where we should be looking for our support libs.
 # can be overridden with --with-apr=[dir] and --with-apr-util=[dir]
 
-apr_src_dir="apr ../apr"
-apu_src_dir="apr-util ../apr-util"
+apr_src_dir="/usr/share/apr-1.0 apr ../apr"
+apu_src_dir="/usr/share/apr-1.0 apr-util ../apr-util"
+ac_src_dir=/usr/share/misc
 
 while test $# -gt 0 
 do
@@ -101,7 +102,7 @@
 fi
 
 echo copying build files
-cp $apr_src_dir/build/config.guess $apr_src_dir/build/config.sub \
+cp $ac_src_dir/config.guess $ac_src_dir/config.sub \
    $apr_src_dir/build/install.sh $apr_src_dir/build/apr_common.m4 \
    $apr_src_dir/build/find_apr.m4 $apr_src_dir/build/get-version.sh build
 

=== removed file 'configure'
--- configure	2011-06-03 03:18:07 +0000
+++ configure	1970-01-01 00:00:00 +0000
@@ -1,6106 +0,0 @@
-#! /bin/sh
-# Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.65.
-#
-#
-# Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
-# 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009 Free Software Foundation,
-# Inc.
-#
-#
-# This configure script is free software; the Free Software Foundation
-# gives unlimited permission to copy, distribute and modify it.
-## -------------------- ##
-## M4sh Initialization. ##
-## -------------------- ##
-
-# Be more Bourne compatible
-DUALCASE=1; export DUALCASE # for MKS sh
-if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then :
-  emulate sh
-  NULLCMD=:
-  # Pre-4.2 versions of Zsh do word splitting on ${1+"$@"}, which
-  # is contrary to our usage.  Disable this feature.
-  alias -g '${1+"$@"}'='"$@"'
-  setopt NO_GLOB_SUBST
-else
-  case `(set -o) 2>/dev/null` in #(
-  *posix*) :
-    set -o posix ;; #(
-  *) :
-     ;;
-esac
-fi
-
-
-as_nl='
-'
-export as_nl
-# Printing a long string crashes Solaris 7 /usr/bin/printf.
-as_echo='\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\'
-as_echo=$as_echo$as_echo$as_echo$as_echo$as_echo
-as_echo=$as_echo$as_echo$as_echo$as_echo$as_echo$as_echo
-# Prefer a ksh shell builtin over an external printf program on Solaris,
-# but without wasting forks for bash or zsh.
-if test -z "$BASH_VERSION$ZSH_VERSION" \
-    && (test "X`print -r -- $as_echo`" = "X$as_echo") 2>/dev/null; then
-  as_echo='print -r --'
-  as_echo_n='print -rn --'
-elif (test "X`printf %s $as_echo`" = "X$as_echo") 2>/dev/null; then
-  as_echo='printf %s\n'
-  as_echo_n='printf %s'
-else
-  if test "X`(/usr/ucb/echo -n -n $as_echo) 2>/dev/null`" = "X-n $as_echo"; then
-    as_echo_body='eval /usr/ucb/echo -n "$1$as_nl"'
-    as_echo_n='/usr/ucb/echo -n'
-  else
-    as_echo_body='eval expr "X$1" : "X\\(.*\\)"'
-    as_echo_n_body='eval
-      arg=$1;
-      case $arg in #(
-      *"$as_nl"*)
-	expr "X$arg" : "X\\(.*\\)$as_nl";
-	arg=`expr "X$arg" : ".*$as_nl\\(.*\\)"`;;
-      esac;
-      expr "X$arg" : "X\\(.*\\)" | tr -d "$as_nl"
-    '
-    export as_echo_n_body
-    as_echo_n='sh -c $as_echo_n_body as_echo'
-  fi
-  export as_echo_body
-  as_echo='sh -c $as_echo_body as_echo'
-fi
-
-# The user is always right.
-if test "${PATH_SEPARATOR+set}" != set; then
-  PATH_SEPARATOR=:
-  (PATH='/bin;/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 && {
-    (PATH='/bin:/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 ||
-      PATH_SEPARATOR=';'
-  }
-fi
-
-
-# IFS
-# We need space, tab and new line, in precisely that order.  Quoting is
-# there to prevent editors from complaining about space-tab.
-# (If _AS_PATH_WALK were called with IFS unset, it would disable word
-# splitting by setting IFS to empty value.)
-IFS=" ""	$as_nl"
-
-# Find who we are.  Look in the path if we contain no directory separator.
-case $0 in #((
-  *[\\/]* ) as_myself=$0 ;;
-  *) as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    test -r "$as_dir/$0" && as_myself=$as_dir/$0 && break
-  done
-IFS=$as_save_IFS
-
-     ;;
-esac
-# We did not find ourselves, most probably we were run as `sh COMMAND'
-# in which case we are not to be found in the path.
-if test "x$as_myself" = x; then
-  as_myself=$0
-fi
-if test ! -f "$as_myself"; then
-  $as_echo "$as_myself: error: cannot find myself; rerun with an absolute file name" >&2
-  exit 1
-fi
-
-# Unset variables that we do not need and which cause bugs (e.g. in
-# pre-3.0 UWIN ksh).  But do not cause bugs in bash 2.01; the "|| exit 1"
-# suppresses any "Segmentation fault" message there.  '((' could
-# trigger a bug in pdksh 5.2.14.
-for as_var in BASH_ENV ENV MAIL MAILPATH
-do eval test x\${$as_var+set} = xset \
-  && ( (unset $as_var) || exit 1) >/dev/null 2>&1 && unset $as_var || :
-done
-PS1='$ '
-PS2='> '
-PS4='+ '
-
-# NLS nuisances.
-LC_ALL=C
-export LC_ALL
-LANGUAGE=C
-export LANGUAGE
-
-# CDPATH.
-(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
-
-if test "x$CONFIG_SHELL" = x; then
-  as_bourne_compatible="if test -n \"\${ZSH_VERSION+set}\" && (emulate sh) >/dev/null 2>&1; then :
-  emulate sh
-  NULLCMD=:
-  # Pre-4.2 versions of Zsh do word splitting on \${1+\"\$@\"}, which
-  # is contrary to our usage.  Disable this feature.
-  alias -g '\${1+\"\$@\"}'='\"\$@\"'
-  setopt NO_GLOB_SUBST
-else
-  case \`(set -o) 2>/dev/null\` in #(
-  *posix*) :
-    set -o posix ;; #(
-  *) :
-     ;;
-esac
-fi
-"
-  as_required="as_fn_return () { (exit \$1); }
-as_fn_success () { as_fn_return 0; }
-as_fn_failure () { as_fn_return 1; }
-as_fn_ret_success () { return 0; }
-as_fn_ret_failure () { return 1; }
-
-exitcode=0
-as_fn_success || { exitcode=1; echo as_fn_success failed.; }
-as_fn_failure && { exitcode=1; echo as_fn_failure succeeded.; }
-as_fn_ret_success || { exitcode=1; echo as_fn_ret_success failed.; }
-as_fn_ret_failure && { exitcode=1; echo as_fn_ret_failure succeeded.; }
-if ( set x; as_fn_ret_success y && test x = \"\$1\" ); then :
-
-else
-  exitcode=1; echo positional parameters were not saved.
-fi
-test x\$exitcode = x0 || exit 1"
-  as_suggested="  as_lineno_1=";as_suggested=$as_suggested$LINENO;as_suggested=$as_suggested" as_lineno_1a=\$LINENO
-  as_lineno_2=";as_suggested=$as_suggested$LINENO;as_suggested=$as_suggested" as_lineno_2a=\$LINENO
-  eval 'test \"x\$as_lineno_1'\$as_run'\" != \"x\$as_lineno_2'\$as_run'\" &&
-  test \"x\`expr \$as_lineno_1'\$as_run' + 1\`\" = \"x\$as_lineno_2'\$as_run'\"' || exit 1
-test \$(( 1 + 1 )) = 2 || exit 1"
-  if (eval "$as_required") 2>/dev/null; then :
-  as_have_required=yes
-else
-  as_have_required=no
-fi
-  if test x$as_have_required = xyes && (eval "$as_suggested") 2>/dev/null; then :
-
-else
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-as_found=false
-for as_dir in /bin$PATH_SEPARATOR/usr/bin$PATH_SEPARATOR$PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-  as_found=:
-  case $as_dir in #(
-	 /*)
-	   for as_base in sh bash ksh sh5; do
-	     # Try only shells that exist, to save several forks.
-	     as_shell=$as_dir/$as_base
-	     if { test -f "$as_shell" || test -f "$as_shell.exe"; } &&
-		    { $as_echo "$as_bourne_compatible""$as_required" | as_run=a "$as_shell"; } 2>/dev/null; then :
-  CONFIG_SHELL=$as_shell as_have_required=yes
-		   if { $as_echo "$as_bourne_compatible""$as_suggested" | as_run=a "$as_shell"; } 2>/dev/null; then :
-  break 2
-fi
-fi
-	   done;;
-       esac
-  as_found=false
-done
-$as_found || { if { test -f "$SHELL" || test -f "$SHELL.exe"; } &&
-	      { $as_echo "$as_bourne_compatible""$as_required" | as_run=a "$SHELL"; } 2>/dev/null; then :
-  CONFIG_SHELL=$SHELL as_have_required=yes
-fi; }
-IFS=$as_save_IFS
-
-
-      if test "x$CONFIG_SHELL" != x; then :
-  # We cannot yet assume a decent shell, so we have to provide a
-	# neutralization value for shells without unset; and this also
-	# works around shells that cannot unset nonexistent variables.
-	BASH_ENV=/dev/null
-	ENV=/dev/null
-	(unset BASH_ENV) >/dev/null 2>&1 && unset BASH_ENV ENV
-	export CONFIG_SHELL
-	exec "$CONFIG_SHELL" "$as_myself" ${1+"$@"}
-fi
-
-    if test x$as_have_required = xno; then :
-  $as_echo "$0: This script requires a shell more modern than all"
-  $as_echo "$0: the shells that I found on your system."
-  if test x${ZSH_VERSION+set} = xset ; then
-    $as_echo "$0: In particular, zsh $ZSH_VERSION has bugs and should"
-    $as_echo "$0: be upgraded to zsh 4.3.4 or later."
-  else
-    $as_echo "$0: Please tell bug-autoconf@gnu.org about your system,
-$0: including any error possibly output before this
-$0: message. Then install a modern shell, or manually run
-$0: the script under such a shell if you do have one."
-  fi
-  exit 1
-fi
-fi
-fi
-SHELL=${CONFIG_SHELL-/bin/sh}
-export SHELL
-# Unset more variables known to interfere with behavior of common tools.
-CLICOLOR_FORCE= GREP_OPTIONS=
-unset CLICOLOR_FORCE GREP_OPTIONS
-
-## --------------------- ##
-## M4sh Shell Functions. ##
-## --------------------- ##
-# as_fn_unset VAR
-# ---------------
-# Portably unset VAR.
-as_fn_unset ()
-{
-  { eval $1=; unset $1;}
-}
-as_unset=as_fn_unset
-
-# as_fn_set_status STATUS
-# -----------------------
-# Set $? to STATUS, without forking.
-as_fn_set_status ()
-{
-  return $1
-} # as_fn_set_status
-
-# as_fn_exit STATUS
-# -----------------
-# Exit the shell with STATUS, even in a "trap 0" or "set -e" context.
-as_fn_exit ()
-{
-  set +e
-  as_fn_set_status $1
-  exit $1
-} # as_fn_exit
-
-# as_fn_mkdir_p
-# -------------
-# Create "$as_dir" as a directory, including parents if necessary.
-as_fn_mkdir_p ()
-{
-
-  case $as_dir in #(
-  -*) as_dir=./$as_dir;;
-  esac
-  test -d "$as_dir" || eval $as_mkdir_p || {
-    as_dirs=
-    while :; do
-      case $as_dir in #(
-      *\'*) as_qdir=`$as_echo "$as_dir" | sed "s/'/'\\\\\\\\''/g"`;; #'(
-      *) as_qdir=$as_dir;;
-      esac
-      as_dirs="'$as_qdir' $as_dirs"
-      as_dir=`$as_dirname -- "$as_dir" ||
-$as_expr X"$as_dir" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
-	 X"$as_dir" : 'X\(//\)[^/]' \| \
-	 X"$as_dir" : 'X\(//\)$' \| \
-	 X"$as_dir" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X"$as_dir" |
-    sed '/^X\(.*[^/]\)\/\/*[^/][^/]*\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)[^/].*/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-      test -d "$as_dir" && break
-    done
-    test -z "$as_dirs" || eval "mkdir $as_dirs"
-  } || test -d "$as_dir" || as_fn_error "cannot create directory $as_dir"
-
-
-} # as_fn_mkdir_p
-# as_fn_append VAR VALUE
-# ----------------------
-# Append the text in VALUE to the end of the definition contained in VAR. Take
-# advantage of any shell optimizations that allow amortized linear growth over
-# repeated appends, instead of the typical quadratic growth present in naive
-# implementations.
-if (eval "as_var=1; as_var+=2; test x\$as_var = x12") 2>/dev/null; then :
-  eval 'as_fn_append ()
-  {
-    eval $1+=\$2
-  }'
-else
-  as_fn_append ()
-  {
-    eval $1=\$$1\$2
-  }
-fi # as_fn_append
-
-# as_fn_arith ARG...
-# ------------------
-# Perform arithmetic evaluation on the ARGs, and store the result in the
-# global $as_val. Take advantage of shells that can avoid forks. The arguments
-# must be portable across $(()) and expr.
-if (eval "test \$(( 1 + 1 )) = 2") 2>/dev/null; then :
-  eval 'as_fn_arith ()
-  {
-    as_val=$(( $* ))
-  }'
-else
-  as_fn_arith ()
-  {
-    as_val=`expr "$@" || test $? -eq 1`
-  }
-fi # as_fn_arith
-
-
-# as_fn_error ERROR [LINENO LOG_FD]
-# ---------------------------------
-# Output "`basename $0`: error: ERROR" to stderr. If LINENO and LOG_FD are
-# provided, also output the error to LOG_FD, referencing LINENO. Then exit the
-# script with status $?, using 1 if that was 0.
-as_fn_error ()
-{
-  as_status=$?; test $as_status -eq 0 && as_status=1
-  if test "$3"; then
-    as_lineno=${as_lineno-"$2"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-    $as_echo "$as_me:${as_lineno-$LINENO}: error: $1" >&$3
-  fi
-  $as_echo "$as_me: error: $1" >&2
-  as_fn_exit $as_status
-} # as_fn_error
-
-if expr a : '\(a\)' >/dev/null 2>&1 &&
-   test "X`expr 00001 : '.*\(...\)'`" = X001; then
-  as_expr=expr
-else
-  as_expr=false
-fi
-
-if (basename -- /) >/dev/null 2>&1 && test "X`basename -- / 2>&1`" = "X/"; then
-  as_basename=basename
-else
-  as_basename=false
-fi
-
-if (as_dir=`dirname -- /` && test "X$as_dir" = X/) >/dev/null 2>&1; then
-  as_dirname=dirname
-else
-  as_dirname=false
-fi
-
-as_me=`$as_basename -- "$0" ||
-$as_expr X/"$0" : '.*/\([^/][^/]*\)/*$' \| \
-	 X"$0" : 'X\(//\)$' \| \
-	 X"$0" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X/"$0" |
-    sed '/^.*\/\([^/][^/]*\)\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\/\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\/\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-
-# Avoid depending upon Character Ranges.
-as_cr_letters='abcdefghijklmnopqrstuvwxyz'
-as_cr_LETTERS='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
-as_cr_Letters=$as_cr_letters$as_cr_LETTERS
-as_cr_digits='0123456789'
-as_cr_alnum=$as_cr_Letters$as_cr_digits
-
-
-  as_lineno_1=$LINENO as_lineno_1a=$LINENO
-  as_lineno_2=$LINENO as_lineno_2a=$LINENO
-  eval 'test "x$as_lineno_1'$as_run'" != "x$as_lineno_2'$as_run'" &&
-  test "x`expr $as_lineno_1'$as_run' + 1`" = "x$as_lineno_2'$as_run'"' || {
-  # Blame Lee E. McMahon (1931-1989) for sed's syntax.  :-)
-  sed -n '
-    p
-    /[$]LINENO/=
-  ' <$as_myself |
-    sed '
-      s/[$]LINENO.*/&-/
-      t lineno
-      b
-      :lineno
-      N
-      :loop
-      s/[$]LINENO\([^'$as_cr_alnum'_].*\n\)\(.*\)/\2\1\2/
-      t loop
-      s/-\n.*//
-    ' >$as_me.lineno &&
-  chmod +x "$as_me.lineno" ||
-    { $as_echo "$as_me: error: cannot create $as_me.lineno; rerun with a POSIX shell" >&2; as_fn_exit 1; }
-
-  # Don't try to exec as it changes $[0], causing all sort of problems
-  # (the dirname of $[0] is not the place where we might find the
-  # original and so on.  Autoconf is especially sensitive to this).
-  . "./$as_me.lineno"
-  # Exit status is that of the last command.
-  exit
-}
-
-ECHO_C= ECHO_N= ECHO_T=
-case `echo -n x` in #(((((
--n*)
-  case `echo 'xy\c'` in
-  *c*) ECHO_T='	';;	# ECHO_T is single tab character.
-  xy)  ECHO_C='\c';;
-  *)   echo `echo ksh88 bug on AIX 6.1` > /dev/null
-       ECHO_T='	';;
-  esac;;
-*)
-  ECHO_N='-n';;
-esac
-
-rm -f conf$$ conf$$.exe conf$$.file
-if test -d conf$$.dir; then
-  rm -f conf$$.dir/conf$$.file
-else
-  rm -f conf$$.dir
-  mkdir conf$$.dir 2>/dev/null
-fi
-if (echo >conf$$.file) 2>/dev/null; then
-  if ln -s conf$$.file conf$$ 2>/dev/null; then
-    as_ln_s='ln -s'
-    # ... but there are two gotchas:
-    # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
-    # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -p'.
-    ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
-      as_ln_s='cp -p'
-  elif ln conf$$.file conf$$ 2>/dev/null; then
-    as_ln_s=ln
-  else
-    as_ln_s='cp -p'
-  fi
-else
-  as_ln_s='cp -p'
-fi
-rm -f conf$$ conf$$.exe conf$$.dir/conf$$.file conf$$.file
-rmdir conf$$.dir 2>/dev/null
-
-if mkdir -p . 2>/dev/null; then
-  as_mkdir_p='mkdir -p "$as_dir"'
-else
-  test -d ./-p && rmdir ./-p
-  as_mkdir_p=false
-fi
-
-if test -x / >/dev/null 2>&1; then
-  as_test_x='test -x'
-else
-  if ls -dL / >/dev/null 2>&1; then
-    as_ls_L_option=L
-  else
-    as_ls_L_option=
-  fi
-  as_test_x='
-    eval sh -c '\''
-      if test -d "$1"; then
-	test -d "$1/.";
-      else
-	case $1 in #(
-	-*)set "./$1";;
-	esac;
-	case `ls -ld'$as_ls_L_option' "$1" 2>/dev/null` in #((
-	???[sx]*):;;*)false;;esac;fi
-    '\'' sh
-  '
-fi
-as_executable_p=$as_test_x
-
-# Sed expression to map a string onto a valid CPP name.
-as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
-
-# Sed expression to map a string onto a valid variable name.
-as_tr_sh="eval sed 'y%*+%pp%;s%[^_$as_cr_alnum]%_%g'"
-
-
-test -n "$DJDIR" || exec 7<&0 </dev/null
-exec 6>&1
-
-# Name of the host.
-# hostname on some systems (SVR3.2, Linux) returns a bogus exit status,
-# so uname gets run too.
-ac_hostname=`(hostname || uname -n) 2>/dev/null | sed 1q`
-
-#
-# Initializations.
-#
-ac_default_prefix=/usr/local
-ac_clean_files=
-ac_config_libobj_dir=.
-LIBOBJS=
-cross_compiling=no
-subdirs=
-MFLAGS=
-MAKEFLAGS=
-
-# Identity of this package.
-PACKAGE_NAME=
-PACKAGE_TARNAME=
-PACKAGE_VERSION=
-PACKAGE_STRING=
-PACKAGE_BUGREPORT=
-PACKAGE_URL=
-
-ac_unique_file="context.c"
-ac_default_prefix=/usr/local/serf
-# Factoring default headers for most tests.
-ac_includes_default="\
-#include <stdio.h>
-#ifdef HAVE_SYS_TYPES_H
-# include <sys/types.h>
-#endif
-#ifdef HAVE_SYS_STAT_H
-# include <sys/stat.h>
-#endif
-#ifdef STDC_HEADERS
-# include <stdlib.h>
-# include <stddef.h>
-#else
-# ifdef HAVE_STDLIB_H
-#  include <stdlib.h>
-# endif
-#endif
-#ifdef HAVE_STRING_H
-# if !defined STDC_HEADERS && defined HAVE_MEMORY_H
-#  include <memory.h>
-# endif
-# include <string.h>
-#endif
-#ifdef HAVE_STRINGS_H
-# include <strings.h>
-#endif
-#ifdef HAVE_INTTYPES_H
-# include <inttypes.h>
-#endif
-#ifdef HAVE_STDINT_H
-# include <stdint.h>
-#endif
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif"
-
-ac_subst_vars='LTLIBOBJS
-LIBOBJS
-EXTRA_INCLUDES
-EXTRA_LIBS
-EXTRA_LDFLAGS
-EXTRA_CXXFLAGS
-EXTRA_CFLAGS
-EXTRA_CPPFLAGS
-SERF_LIBS
-EGREP
-GREP
-SERF_CLEAN_SRCLIB_DIRS
-SERF_BUILD_SRCLIB_DIRS
-SERF_DOTTED_VERSION
-SERF_MAJOR_VERSION
-INSTALL_DATA
-INSTALL_SCRIPT
-INSTALL_PROGRAM
-CPP
-OBJEXT
-EXEEXT
-ac_ct_CC
-CPPFLAGS
-LDFLAGS
-CFLAGS
-CC
-APU_CONFIG
-APU_VERSION
-APU_INCLUDES
-APU_BINDIR
-APR_CONFIG
-APR_VERSION
-APR_INCLUDES
-APR_BINDIR
-APR_LIBTOOL
-LTFLAGS
-target_os
-target_vendor
-target_cpu
-target
-host_os
-host_vendor
-host_cpu
-host
-build_os
-build_vendor
-build_cpu
-build
-mkdir_p
-target_alias
-host_alias
-build_alias
-LIBS
-ECHO_T
-ECHO_N
-ECHO_C
-DEFS
-mandir
-localedir
-libdir
-psdir
-pdfdir
-dvidir
-htmldir
-infodir
-docdir
-oldincludedir
-includedir
-localstatedir
-sharedstatedir
-sysconfdir
-datadir
-datarootdir
-libexecdir
-sbindir
-bindir
-program_transform_name
-prefix
-exec_prefix
-PACKAGE_URL
-PACKAGE_BUGREPORT
-PACKAGE_STRING
-PACKAGE_VERSION
-PACKAGE_TARNAME
-PACKAGE_NAME
-PATH_SEPARATOR
-SHELL'
-ac_subst_files=''
-ac_user_opts='
-enable_option_checking
-enable_layout
-with_apr
-with_apr_util
-with_openssl
-'
-      ac_precious_vars='build_alias
-host_alias
-target_alias
-CC
-CFLAGS
-LDFLAGS
-LIBS
-CPPFLAGS
-CPP'
-
-
-# Initialize some variables set by options.
-ac_init_help=
-ac_init_version=false
-ac_unrecognized_opts=
-ac_unrecognized_sep=
-# The variables have the same names as the options, with
-# dashes changed to underlines.
-cache_file=/dev/null
-exec_prefix=NONE
-no_create=
-no_recursion=
-prefix=NONE
-program_prefix=NONE
-program_suffix=NONE
-program_transform_name=s,x,x,
-silent=
-site=
-srcdir=
-verbose=
-x_includes=NONE
-x_libraries=NONE
-
-# Installation directory options.
-# These are left unexpanded so users can "make install exec_prefix=/foo"
-# and all the variables that are supposed to be based on exec_prefix
-# by default will actually change.
-# Use braces instead of parens because sh, perl, etc. also accept them.
-# (The list follows the same order as the GNU Coding Standards.)
-bindir='${exec_prefix}/bin'
-sbindir='${exec_prefix}/sbin'
-libexecdir='${exec_prefix}/libexec'
-datarootdir='${prefix}/share'
-datadir='${datarootdir}'
-sysconfdir='${prefix}/etc'
-sharedstatedir='${prefix}/com'
-localstatedir='${prefix}/var'
-includedir='${prefix}/include'
-oldincludedir='/usr/include'
-docdir='${datarootdir}/doc/${PACKAGE}'
-infodir='${datarootdir}/info'
-htmldir='${docdir}'
-dvidir='${docdir}'
-pdfdir='${docdir}'
-psdir='${docdir}'
-libdir='${exec_prefix}/lib'
-localedir='${datarootdir}/locale'
-mandir='${datarootdir}/man'
-
-ac_prev=
-ac_dashdash=
-for ac_option
-do
-  # If the previous option needs an argument, assign it.
-  if test -n "$ac_prev"; then
-    eval $ac_prev=\$ac_option
-    ac_prev=
-    continue
-  fi
-
-  case $ac_option in
-  *=*)	ac_optarg=`expr "X$ac_option" : '[^=]*=\(.*\)'` ;;
-  *)	ac_optarg=yes ;;
-  esac
-
-  # Accept the important Cygnus configure options, so we can diagnose typos.
-
-  case $ac_dashdash$ac_option in
-  --)
-    ac_dashdash=yes ;;
-
-  -bindir | --bindir | --bindi | --bind | --bin | --bi)
-    ac_prev=bindir ;;
-  -bindir=* | --bindir=* | --bindi=* | --bind=* | --bin=* | --bi=*)
-    bindir=$ac_optarg ;;
-
-  -build | --build | --buil | --bui | --bu)
-    ac_prev=build_alias ;;
-  -build=* | --build=* | --buil=* | --bui=* | --bu=*)
-    build_alias=$ac_optarg ;;
-
-  -cache-file | --cache-file | --cache-fil | --cache-fi \
-  | --cache-f | --cache- | --cache | --cach | --cac | --ca | --c)
-    ac_prev=cache_file ;;
-  -cache-file=* | --cache-file=* | --cache-fil=* | --cache-fi=* \
-  | --cache-f=* | --cache-=* | --cache=* | --cach=* | --cac=* | --ca=* | --c=*)
-    cache_file=$ac_optarg ;;
-
-  --config-cache | -C)
-    cache_file=config.cache ;;
-
-  -datadir | --datadir | --datadi | --datad)
-    ac_prev=datadir ;;
-  -datadir=* | --datadir=* | --datadi=* | --datad=*)
-    datadir=$ac_optarg ;;
-
-  -datarootdir | --datarootdir | --datarootdi | --datarootd | --dataroot \
-  | --dataroo | --dataro | --datar)
-    ac_prev=datarootdir ;;
-  -datarootdir=* | --datarootdir=* | --datarootdi=* | --datarootd=* \
-  | --dataroot=* | --dataroo=* | --dataro=* | --datar=*)
-    datarootdir=$ac_optarg ;;
-
-  -disable-* | --disable-*)
-    ac_useropt=`expr "x$ac_option" : 'x-*disable-\(.*\)'`
-    # Reject names that are not valid shell variable names.
-    expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error "invalid feature name: $ac_useropt"
-    ac_useropt_orig=$ac_useropt
-    ac_useropt=`$as_echo "$ac_useropt" | sed 's/[-+.]/_/g'`
-    case $ac_user_opts in
-      *"
-"enable_$ac_useropt"
-"*) ;;
-      *) ac_unrecognized_opts="$ac_unrecognized_opts$ac_unrecognized_sep--disable-$ac_useropt_orig"
-	 ac_unrecognized_sep=', ';;
-    esac
-    eval enable_$ac_useropt=no ;;
-
-  -docdir | --docdir | --docdi | --doc | --do)
-    ac_prev=docdir ;;
-  -docdir=* | --docdir=* | --docdi=* | --doc=* | --do=*)
-    docdir=$ac_optarg ;;
-
-  -dvidir | --dvidir | --dvidi | --dvid | --dvi | --dv)
-    ac_prev=dvidir ;;
-  -dvidir=* | --dvidir=* | --dvidi=* | --dvid=* | --dvi=* | --dv=*)
-    dvidir=$ac_optarg ;;
-
-  -enable-* | --enable-*)
-    ac_useropt=`expr "x$ac_option" : 'x-*enable-\([^=]*\)'`
-    # Reject names that are not valid shell variable names.
-    expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error "invalid feature name: $ac_useropt"
-    ac_useropt_orig=$ac_useropt
-    ac_useropt=`$as_echo "$ac_useropt" | sed 's/[-+.]/_/g'`
-    case $ac_user_opts in
-      *"
-"enable_$ac_useropt"
-"*) ;;
-      *) ac_unrecognized_opts="$ac_unrecognized_opts$ac_unrecognized_sep--enable-$ac_useropt_orig"
-	 ac_unrecognized_sep=', ';;
-    esac
-    eval enable_$ac_useropt=\$ac_optarg ;;
-
-  -exec-prefix | --exec_prefix | --exec-prefix | --exec-prefi \
-  | --exec-pref | --exec-pre | --exec-pr | --exec-p | --exec- \
-  | --exec | --exe | --ex)
-    ac_prev=exec_prefix ;;
-  -exec-prefix=* | --exec_prefix=* | --exec-prefix=* | --exec-prefi=* \
-  | --exec-pref=* | --exec-pre=* | --exec-pr=* | --exec-p=* | --exec-=* \
-  | --exec=* | --exe=* | --ex=*)
-    exec_prefix=$ac_optarg ;;
-
-  -gas | --gas | --ga | --g)
-    # Obsolete; use --with-gas.
-    with_gas=yes ;;
-
-  -help | --help | --hel | --he | -h)
-    ac_init_help=long ;;
-  -help=r* | --help=r* | --hel=r* | --he=r* | -hr*)
-    ac_init_help=recursive ;;
-  -help=s* | --help=s* | --hel=s* | --he=s* | -hs*)
-    ac_init_help=short ;;
-
-  -host | --host | --hos | --ho)
-    ac_prev=host_alias ;;
-  -host=* | --host=* | --hos=* | --ho=*)
-    host_alias=$ac_optarg ;;
-
-  -htmldir | --htmldir | --htmldi | --htmld | --html | --htm | --ht)
-    ac_prev=htmldir ;;
-  -htmldir=* | --htmldir=* | --htmldi=* | --htmld=* | --html=* | --htm=* \
-  | --ht=*)
-    htmldir=$ac_optarg ;;
-
-  -includedir | --includedir | --includedi | --included | --include \
-  | --includ | --inclu | --incl | --inc)
-    ac_prev=includedir ;;
-  -includedir=* | --includedir=* | --includedi=* | --included=* | --include=* \
-  | --includ=* | --inclu=* | --incl=* | --inc=*)
-    includedir=$ac_optarg ;;
-
-  -infodir | --infodir | --infodi | --infod | --info | --inf)
-    ac_prev=infodir ;;
-  -infodir=* | --infodir=* | --infodi=* | --infod=* | --info=* | --inf=*)
-    infodir=$ac_optarg ;;
-
-  -libdir | --libdir | --libdi | --libd)
-    ac_prev=libdir ;;
-  -libdir=* | --libdir=* | --libdi=* | --libd=*)
-    libdir=$ac_optarg ;;
-
-  -libexecdir | --libexecdir | --libexecdi | --libexecd | --libexec \
-  | --libexe | --libex | --libe)
-    ac_prev=libexecdir ;;
-  -libexecdir=* | --libexecdir=* | --libexecdi=* | --libexecd=* | --libexec=* \
-  | --libexe=* | --libex=* | --libe=*)
-    libexecdir=$ac_optarg ;;
-
-  -localedir | --localedir | --localedi | --localed | --locale)
-    ac_prev=localedir ;;
-  -localedir=* | --localedir=* | --localedi=* | --localed=* | --locale=*)
-    localedir=$ac_optarg ;;
-
-  -localstatedir | --localstatedir | --localstatedi | --localstated \
-  | --localstate | --localstat | --localsta | --localst | --locals)
-    ac_prev=localstatedir ;;
-  -localstatedir=* | --localstatedir=* | --localstatedi=* | --localstated=* \
-  | --localstate=* | --localstat=* | --localsta=* | --localst=* | --locals=*)
-    localstatedir=$ac_optarg ;;
-
-  -mandir | --mandir | --mandi | --mand | --man | --ma | --m)
-    ac_prev=mandir ;;
-  -mandir=* | --mandir=* | --mandi=* | --mand=* | --man=* | --ma=* | --m=*)
-    mandir=$ac_optarg ;;
-
-  -nfp | --nfp | --nf)
-    # Obsolete; use --without-fp.
-    with_fp=no ;;
-
-  -no-create | --no-create | --no-creat | --no-crea | --no-cre \
-  | --no-cr | --no-c | -n)
-    no_create=yes ;;
-
-  -no-recursion | --no-recursion | --no-recursio | --no-recursi \
-  | --no-recurs | --no-recur | --no-recu | --no-rec | --no-re | --no-r)
-    no_recursion=yes ;;
-
-  -oldincludedir | --oldincludedir | --oldincludedi | --oldincluded \
-  | --oldinclude | --oldinclud | --oldinclu | --oldincl | --oldinc \
-  | --oldin | --oldi | --old | --ol | --o)
-    ac_prev=oldincludedir ;;
-  -oldincludedir=* | --oldincludedir=* | --oldincludedi=* | --oldincluded=* \
-  | --oldinclude=* | --oldinclud=* | --oldinclu=* | --oldincl=* | --oldinc=* \
-  | --oldin=* | --oldi=* | --old=* | --ol=* | --o=*)
-    oldincludedir=$ac_optarg ;;
-
-  -prefix | --prefix | --prefi | --pref | --pre | --pr | --p)
-    ac_prev=prefix ;;
-  -prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=* | --pr=* | --p=*)
-    prefix=$ac_optarg ;;
-
-  -program-prefix | --program-prefix | --program-prefi | --program-pref \
-  | --program-pre | --program-pr | --program-p)
-    ac_prev=program_prefix ;;
-  -program-prefix=* | --program-prefix=* | --program-prefi=* \
-  | --program-pref=* | --program-pre=* | --program-pr=* | --program-p=*)
-    program_prefix=$ac_optarg ;;
-
-  -program-suffix | --program-suffix | --program-suffi | --program-suff \
-  | --program-suf | --program-su | --program-s)
-    ac_prev=program_suffix ;;
-  -program-suffix=* | --program-suffix=* | --program-suffi=* \
-  | --program-suff=* | --program-suf=* | --program-su=* | --program-s=*)
-    program_suffix=$ac_optarg ;;
-
-  -program-transform-name | --program-transform-name \
-  | --program-transform-nam | --program-transform-na \
-  | --program-transform-n | --program-transform- \
-  | --program-transform | --program-transfor \
-  | --program-transfo | --program-transf \
-  | --program-trans | --program-tran \
-  | --progr-tra | --program-tr | --program-t)
-    ac_prev=program_transform_name ;;
-  -program-transform-name=* | --program-transform-name=* \
-  | --program-transform-nam=* | --program-transform-na=* \
-  | --program-transform-n=* | --program-transform-=* \
-  | --program-transform=* | --program-transfor=* \
-  | --program-transfo=* | --program-transf=* \
-  | --program-trans=* | --program-tran=* \
-  | --progr-tra=* | --program-tr=* | --program-t=*)
-    program_transform_name=$ac_optarg ;;
-
-  -pdfdir | --pdfdir | --pdfdi | --pdfd | --pdf | --pd)
-    ac_prev=pdfdir ;;
-  -pdfdir=* | --pdfdir=* | --pdfdi=* | --pdfd=* | --pdf=* | --pd=*)
-    pdfdir=$ac_optarg ;;
-
-  -psdir | --psdir | --psdi | --psd | --ps)
-    ac_prev=psdir ;;
-  -psdir=* | --psdir=* | --psdi=* | --psd=* | --ps=*)
-    psdir=$ac_optarg ;;
-
-  -q | -quiet | --quiet | --quie | --qui | --qu | --q \
-  | -silent | --silent | --silen | --sile | --sil)
-    silent=yes ;;
-
-  -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
-    ac_prev=sbindir ;;
-  -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
-  | --sbi=* | --sb=*)
-    sbindir=$ac_optarg ;;
-
-  -sharedstatedir | --sharedstatedir | --sharedstatedi \
-  | --sharedstated | --sharedstate | --sharedstat | --sharedsta \
-  | --sharedst | --shareds | --shared | --share | --shar \
-  | --sha | --sh)
-    ac_prev=sharedstatedir ;;
-  -sharedstatedir=* | --sharedstatedir=* | --sharedstatedi=* \
-  | --sharedstated=* | --sharedstate=* | --sharedstat=* | --sharedsta=* \
-  | --sharedst=* | --shareds=* | --shared=* | --share=* | --shar=* \
-  | --sha=* | --sh=*)
-    sharedstatedir=$ac_optarg ;;
-
-  -site | --site | --sit)
-    ac_prev=site ;;
-  -site=* | --site=* | --sit=*)
-    site=$ac_optarg ;;
-
-  -srcdir | --srcdir | --srcdi | --srcd | --src | --sr)
-    ac_prev=srcdir ;;
-  -srcdir=* | --srcdir=* | --srcdi=* | --srcd=* | --src=* | --sr=*)
-    srcdir=$ac_optarg ;;
-
-  -sysconfdir | --sysconfdir | --sysconfdi | --sysconfd | --sysconf \
-  | --syscon | --sysco | --sysc | --sys | --sy)
-    ac_prev=sysconfdir ;;
-  -sysconfdir=* | --sysconfdir=* | --sysconfdi=* | --sysconfd=* | --sysconf=* \
-  | --syscon=* | --sysco=* | --sysc=* | --sys=* | --sy=*)
-    sysconfdir=$ac_optarg ;;
-
-  -target | --target | --targe | --targ | --tar | --ta | --t)
-    ac_prev=target_alias ;;
-  -target=* | --target=* | --targe=* | --targ=* | --tar=* | --ta=* | --t=*)
-    target_alias=$ac_optarg ;;
-
-  -v | -verbose | --verbose | --verbos | --verbo | --verb)
-    verbose=yes ;;
-
-  -version | --version | --versio | --versi | --vers | -V)
-    ac_init_version=: ;;
-
-  -with-* | --with-*)
-    ac_useropt=`expr "x$ac_option" : 'x-*with-\([^=]*\)'`
-    # Reject names that are not valid shell variable names.
-    expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error "invalid package name: $ac_useropt"
-    ac_useropt_orig=$ac_useropt
-    ac_useropt=`$as_echo "$ac_useropt" | sed 's/[-+.]/_/g'`
-    case $ac_user_opts in
-      *"
-"with_$ac_useropt"
-"*) ;;
-      *) ac_unrecognized_opts="$ac_unrecognized_opts$ac_unrecognized_sep--with-$ac_useropt_orig"
-	 ac_unrecognized_sep=', ';;
-    esac
-    eval with_$ac_useropt=\$ac_optarg ;;
-
-  -without-* | --without-*)
-    ac_useropt=`expr "x$ac_option" : 'x-*without-\(.*\)'`
-    # Reject names that are not valid shell variable names.
-    expr "x$ac_useropt" : ".*[^-+._$as_cr_alnum]" >/dev/null &&
-      as_fn_error "invalid package name: $ac_useropt"
-    ac_useropt_orig=$ac_useropt
-    ac_useropt=`$as_echo "$ac_useropt" | sed 's/[-+.]/_/g'`
-    case $ac_user_opts in
-      *"
-"with_$ac_useropt"
-"*) ;;
-      *) ac_unrecognized_opts="$ac_unrecognized_opts$ac_unrecognized_sep--without-$ac_useropt_orig"
-	 ac_unrecognized_sep=', ';;
-    esac
-    eval with_$ac_useropt=no ;;
-
-  --x)
-    # Obsolete; use --with-x.
-    with_x=yes ;;
-
-  -x-includes | --x-includes | --x-include | --x-includ | --x-inclu \
-  | --x-incl | --x-inc | --x-in | --x-i)
-    ac_prev=x_includes ;;
-  -x-includes=* | --x-includes=* | --x-include=* | --x-includ=* | --x-inclu=* \
-  | --x-incl=* | --x-inc=* | --x-in=* | --x-i=*)
-    x_includes=$ac_optarg ;;
-
-  -x-libraries | --x-libraries | --x-librarie | --x-librari \
-  | --x-librar | --x-libra | --x-libr | --x-lib | --x-li | --x-l)
-    ac_prev=x_libraries ;;
-  -x-libraries=* | --x-libraries=* | --x-librarie=* | --x-librari=* \
-  | --x-librar=* | --x-libra=* | --x-libr=* | --x-lib=* | --x-li=* | --x-l=*)
-    x_libraries=$ac_optarg ;;
-
-  -*) as_fn_error "unrecognized option: \`$ac_option'
-Try \`$0 --help' for more information."
-    ;;
-
-  *=*)
-    ac_envvar=`expr "x$ac_option" : 'x\([^=]*\)='`
-    # Reject names that are not valid shell variable names.
-    case $ac_envvar in #(
-      '' | [0-9]* | *[!_$as_cr_alnum]* )
-      as_fn_error "invalid variable name: \`$ac_envvar'" ;;
-    esac
-    eval $ac_envvar=\$ac_optarg
-    export $ac_envvar ;;
-
-  *)
-    # FIXME: should be removed in autoconf 3.0.
-    $as_echo "$as_me: WARNING: you should use --build, --host, --target" >&2
-    expr "x$ac_option" : ".*[^-._$as_cr_alnum]" >/dev/null &&
-      $as_echo "$as_me: WARNING: invalid host type: $ac_option" >&2
-    : ${build_alias=$ac_option} ${host_alias=$ac_option} ${target_alias=$ac_option}
-    ;;
-
-  esac
-done
-
-if test -n "$ac_prev"; then
-  ac_option=--`echo $ac_prev | sed 's/_/-/g'`
-  as_fn_error "missing argument to $ac_option"
-fi
-
-if test -n "$ac_unrecognized_opts"; then
-  case $enable_option_checking in
-    no) ;;
-    fatal) as_fn_error "unrecognized options: $ac_unrecognized_opts" ;;
-    *)     $as_echo "$as_me: WARNING: unrecognized options: $ac_unrecognized_opts" >&2 ;;
-  esac
-fi
-
-# Check all directory arguments for consistency.
-for ac_var in	exec_prefix prefix bindir sbindir libexecdir datarootdir \
-		datadir sysconfdir sharedstatedir localstatedir includedir \
-		oldincludedir docdir infodir htmldir dvidir pdfdir psdir \
-		libdir localedir mandir
-do
-  eval ac_val=\$$ac_var
-  # Remove trailing slashes.
-  case $ac_val in
-    */ )
-      ac_val=`expr "X$ac_val" : 'X\(.*[^/]\)' \| "X$ac_val" : 'X\(.*\)'`
-      eval $ac_var=\$ac_val;;
-  esac
-  # Be sure to have absolute directory names.
-  case $ac_val in
-    [\\/$]* | ?:[\\/]* )  continue;;
-    NONE | '' ) case $ac_var in *prefix ) continue;; esac;;
-  esac
-  as_fn_error "expected an absolute directory name for --$ac_var: $ac_val"
-done
-
-# There might be people who depend on the old broken behavior: `$host'
-# used to hold the argument of --host etc.
-# FIXME: To remove some day.
-build=$build_alias
-host=$host_alias
-target=$target_alias
-
-# FIXME: To remove some day.
-if test "x$host_alias" != x; then
-  if test "x$build_alias" = x; then
-    cross_compiling=maybe
-    $as_echo "$as_me: WARNING: If you wanted to set the --build type, don't use --host.
-    If a cross compiler is detected then cross compile mode will be used." >&2
-  elif test "x$build_alias" != "x$host_alias"; then
-    cross_compiling=yes
-  fi
-fi
-
-ac_tool_prefix=
-test -n "$host_alias" && ac_tool_prefix=$host_alias-
-
-test "$silent" = yes && exec 6>/dev/null
-
-
-ac_pwd=`pwd` && test -n "$ac_pwd" &&
-ac_ls_di=`ls -di .` &&
-ac_pwd_ls_di=`cd "$ac_pwd" && ls -di .` ||
-  as_fn_error "working directory cannot be determined"
-test "X$ac_ls_di" = "X$ac_pwd_ls_di" ||
-  as_fn_error "pwd does not report name of working directory"
-
-
-# Find the source files, if location was not specified.
-if test -z "$srcdir"; then
-  ac_srcdir_defaulted=yes
-  # Try the directory containing this script, then the parent directory.
-  ac_confdir=`$as_dirname -- "$as_myself" ||
-$as_expr X"$as_myself" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
-	 X"$as_myself" : 'X\(//\)[^/]' \| \
-	 X"$as_myself" : 'X\(//\)$' \| \
-	 X"$as_myself" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X"$as_myself" |
-    sed '/^X\(.*[^/]\)\/\/*[^/][^/]*\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)[^/].*/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-  srcdir=$ac_confdir
-  if test ! -r "$srcdir/$ac_unique_file"; then
-    srcdir=..
-  fi
-else
-  ac_srcdir_defaulted=no
-fi
-if test ! -r "$srcdir/$ac_unique_file"; then
-  test "$ac_srcdir_defaulted" = yes && srcdir="$ac_confdir or .."
-  as_fn_error "cannot find sources ($ac_unique_file) in $srcdir"
-fi
-ac_msg="sources are in $srcdir, but \`cd $srcdir' does not work"
-ac_abs_confdir=`(
-	cd "$srcdir" && test -r "./$ac_unique_file" || as_fn_error "$ac_msg"
-	pwd)`
-# When building in place, set srcdir=.
-if test "$ac_abs_confdir" = "$ac_pwd"; then
-  srcdir=.
-fi
-# Remove unnecessary trailing slashes from srcdir.
-# Double slashes in file names in object file debugging info
-# mess up M-x gdb in Emacs.
-case $srcdir in
-*/) srcdir=`expr "X$srcdir" : 'X\(.*[^/]\)' \| "X$srcdir" : 'X\(.*\)'`;;
-esac
-for ac_var in $ac_precious_vars; do
-  eval ac_env_${ac_var}_set=\${${ac_var}+set}
-  eval ac_env_${ac_var}_value=\$${ac_var}
-  eval ac_cv_env_${ac_var}_set=\${${ac_var}+set}
-  eval ac_cv_env_${ac_var}_value=\$${ac_var}
-done
-
-#
-# Report the --help message.
-#
-if test "$ac_init_help" = "long"; then
-  # Omit some internal or obsolete options to make the list less imposing.
-  # This message is too long to be a string in the A/UX 3.1 sh.
-  cat <<_ACEOF
-\`configure' configures this package to adapt to many kinds of systems.
-
-Usage: $0 [OPTION]... [VAR=VALUE]...
-
-To assign environment variables (e.g., CC, CFLAGS...), specify them as
-VAR=VALUE.  See below for descriptions of some of the useful variables.
-
-Defaults for the options are specified in brackets.
-
-Configuration:
-  -h, --help              display this help and exit
-      --help=short        display options specific to this package
-      --help=recursive    display the short help of all the included packages
-  -V, --version           display version information and exit
-  -q, --quiet, --silent   do not print \`checking...' messages
-      --cache-file=FILE   cache test results in FILE [disabled]
-  -C, --config-cache      alias for \`--cache-file=config.cache'
-  -n, --no-create         do not create output files
-      --srcdir=DIR        find the sources in DIR [configure dir or \`..']
-
-Installation directories:
-  --prefix=PREFIX         install architecture-independent files in PREFIX
-                          [$ac_default_prefix]
-  --exec-prefix=EPREFIX   install architecture-dependent files in EPREFIX
-                          [PREFIX]
-
-By default, \`make install' will install all the files in
-\`$ac_default_prefix/bin', \`$ac_default_prefix/lib' etc.  You can specify
-an installation prefix other than \`$ac_default_prefix' using \`--prefix',
-for instance \`--prefix=\$HOME'.
-
-For better control, use the options below.
-
-Fine tuning of the installation directories:
-  --bindir=DIR            user executables [EPREFIX/bin]
-  --sbindir=DIR           system admin executables [EPREFIX/sbin]
-  --libexecdir=DIR        program executables [EPREFIX/libexec]
-  --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
-  --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
-  --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
-  --libdir=DIR            object code libraries [EPREFIX/lib]
-  --includedir=DIR        C header files [PREFIX/include]
-  --oldincludedir=DIR     C header files for non-gcc [/usr/include]
-  --datarootdir=DIR       read-only arch.-independent data root [PREFIX/share]
-  --datadir=DIR           read-only architecture-independent data [DATAROOTDIR]
-  --infodir=DIR           info documentation [DATAROOTDIR/info]
-  --localedir=DIR         locale-dependent data [DATAROOTDIR/locale]
-  --mandir=DIR            man documentation [DATAROOTDIR/man]
-  --docdir=DIR            documentation root [DATAROOTDIR/doc/PACKAGE]
-  --htmldir=DIR           html documentation [DOCDIR]
-  --dvidir=DIR            dvi documentation [DOCDIR]
-  --pdfdir=DIR            pdf documentation [DOCDIR]
-  --psdir=DIR             ps documentation [DOCDIR]
-_ACEOF
-
-  cat <<\_ACEOF
-
-System types:
-  --build=BUILD     configure for building on BUILD [guessed]
-  --host=HOST       cross-compile to build programs to run on HOST [BUILD]
-  --target=TARGET   configure for building compilers for TARGET [HOST]
-_ACEOF
-fi
-
-if test -n "$ac_init_help"; then
-
-  cat <<\_ACEOF
-
-Optional Features:
-  --disable-option-checking  ignore unrecognized --enable/--with options
-  --disable-FEATURE       do not include FEATURE (same as --enable-FEATURE=no)
-  --enable-FEATURE[=ARG]  include FEATURE [ARG=yes]
-  --enable-layout=LAYOUT
-
-Optional Packages:
-  --with-PACKAGE[=ARG]    use PACKAGE [ARG=yes]
-  --without-PACKAGE       do not use PACKAGE (same as --with-PACKAGE=no)
-  --with-apr=PATH         prefix for installed APR or the full path to
-                             apr-config
-  --with-apr-util=PATH    prefix for installed APU or the full path to
-                             apu-config
-  --with-openssl=PATH     Path to OpenSSL (eg. /usr/local/ssl)
-
-Some influential environment variables:
-  CC          C compiler command
-  CFLAGS      C compiler flags
-  LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
-              nonstandard directory <lib dir>
-  LIBS        libraries to pass to the linker, e.g. -l<library>
-  CPPFLAGS    (Objective) C/C++ preprocessor flags, e.g. -I<include dir> if
-              you have headers in a nonstandard directory <include dir>
-  CPP         C preprocessor
-
-Use these variables to override the choices made by `configure' or to help
-it to find libraries and programs with nonstandard names/locations.
-
-Report bugs to the package provider.
-_ACEOF
-ac_status=$?
-fi
-
-if test "$ac_init_help" = "recursive"; then
-  # If there are subdirs, report their specific --help.
-  for ac_dir in : $ac_subdirs_all; do test "x$ac_dir" = x: && continue
-    test -d "$ac_dir" ||
-      { cd "$srcdir" && ac_pwd=`pwd` && srcdir=. && test -d "$ac_dir"; } ||
-      continue
-    ac_builddir=.
-
-case "$ac_dir" in
-.) ac_dir_suffix= ac_top_builddir_sub=. ac_top_build_prefix= ;;
-*)
-  ac_dir_suffix=/`$as_echo "$ac_dir" | sed 's|^\.[\\/]||'`
-  # A ".." for each directory in $ac_dir_suffix.
-  ac_top_builddir_sub=`$as_echo "$ac_dir_suffix" | sed 's|/[^\\/]*|/..|g;s|/||'`
-  case $ac_top_builddir_sub in
-  "") ac_top_builddir_sub=. ac_top_build_prefix= ;;
-  *)  ac_top_build_prefix=$ac_top_builddir_sub/ ;;
-  esac ;;
-esac
-ac_abs_top_builddir=$ac_pwd
-ac_abs_builddir=$ac_pwd$ac_dir_suffix
-# for backward compatibility:
-ac_top_builddir=$ac_top_build_prefix
-
-case $srcdir in
-  .)  # We are building in place.
-    ac_srcdir=.
-    ac_top_srcdir=$ac_top_builddir_sub
-    ac_abs_top_srcdir=$ac_pwd ;;
-  [\\/]* | ?:[\\/]* )  # Absolute name.
-    ac_srcdir=$srcdir$ac_dir_suffix;
-    ac_top_srcdir=$srcdir
-    ac_abs_top_srcdir=$srcdir ;;
-  *) # Relative name.
-    ac_srcdir=$ac_top_build_prefix$srcdir$ac_dir_suffix
-    ac_top_srcdir=$ac_top_build_prefix$srcdir
-    ac_abs_top_srcdir=$ac_pwd/$srcdir ;;
-esac
-ac_abs_srcdir=$ac_abs_top_srcdir$ac_dir_suffix
-
-    cd "$ac_dir" || { ac_status=$?; continue; }
-    # Check for guested configure.
-    if test -f "$ac_srcdir/configure.gnu"; then
-      echo &&
-      $SHELL "$ac_srcdir/configure.gnu" --help=recursive
-    elif test -f "$ac_srcdir/configure"; then
-      echo &&
-      $SHELL "$ac_srcdir/configure" --help=recursive
-    else
-      $as_echo "$as_me: WARNING: no configuration information is in $ac_dir" >&2
-    fi || ac_status=$?
-    cd "$ac_pwd" || { ac_status=$?; break; }
-  done
-fi
-
-test -n "$ac_init_help" && exit $ac_status
-if $ac_init_version; then
-  cat <<\_ACEOF
-configure
-generated by GNU Autoconf 2.65
-
-Copyright (C) 2009 Free Software Foundation, Inc.
-This configure script is free software; the Free Software Foundation
-gives unlimited permission to copy, distribute and modify it.
-_ACEOF
-  exit
-fi
-
-## ------------------------ ##
-## Autoconf initialization. ##
-## ------------------------ ##
-
-# ac_fn_c_try_compile LINENO
-# --------------------------
-# Try to compile conftest.$ac_ext, and return whether this succeeded.
-ac_fn_c_try_compile ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  rm -f conftest.$ac_objext
-  if { { ac_try="$ac_compile"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_compile") 2>conftest.err
-  ac_status=$?
-  if test -s conftest.err; then
-    grep -v '^ *+' conftest.err >conftest.er1
-    cat conftest.er1 >&5
-    mv -f conftest.er1 conftest.err
-  fi
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; } && {
-	 test -z "$ac_c_werror_flag" ||
-	 test ! -s conftest.err
-       } && test -s conftest.$ac_objext; then :
-  ac_retval=0
-else
-  $as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-	ac_retval=1
-fi
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-  as_fn_set_status $ac_retval
-
-} # ac_fn_c_try_compile
-
-# ac_fn_c_try_cpp LINENO
-# ----------------------
-# Try to preprocess conftest.$ac_ext, and return whether this succeeded.
-ac_fn_c_try_cpp ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  if { { ac_try="$ac_cpp conftest.$ac_ext"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_cpp conftest.$ac_ext") 2>conftest.err
-  ac_status=$?
-  if test -s conftest.err; then
-    grep -v '^ *+' conftest.err >conftest.er1
-    cat conftest.er1 >&5
-    mv -f conftest.er1 conftest.err
-  fi
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; } >/dev/null && {
-	 test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
-	 test ! -s conftest.err
-       }; then :
-  ac_retval=0
-else
-  $as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-    ac_retval=1
-fi
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-  as_fn_set_status $ac_retval
-
-} # ac_fn_c_try_cpp
-
-# ac_fn_c_check_header_mongrel LINENO HEADER VAR INCLUDES
-# -------------------------------------------------------
-# Tests whether HEADER exists, giving a warning if it cannot be compiled using
-# the include files in INCLUDES and setting the cache variable VAR
-# accordingly.
-ac_fn_c_check_header_mongrel ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  if { as_var=$3; eval "test \"\${$as_var+set}\" = set"; }; then :
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for $2" >&5
-$as_echo_n "checking for $2... " >&6; }
-if { as_var=$3; eval "test \"\${$as_var+set}\" = set"; }; then :
-  $as_echo_n "(cached) " >&6
-fi
-eval ac_res=\$$3
-	       { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
-$as_echo "$ac_res" >&6; }
-else
-  # Is the header compilable?
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking $2 usability" >&5
-$as_echo_n "checking $2 usability... " >&6; }
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-$4
-#include <$2>
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  ac_header_compiler=yes
-else
-  ac_header_compiler=no
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_header_compiler" >&5
-$as_echo "$ac_header_compiler" >&6; }
-
-# Is the header present?
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking $2 presence" >&5
-$as_echo_n "checking $2 presence... " >&6; }
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <$2>
-_ACEOF
-if ac_fn_c_try_cpp "$LINENO"; then :
-  ac_header_preproc=yes
-else
-  ac_header_preproc=no
-fi
-rm -f conftest.err conftest.$ac_ext
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_header_preproc" >&5
-$as_echo "$ac_header_preproc" >&6; }
-
-# So?  What about this header?
-case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in #((
-  yes:no: )
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2: accepted by the compiler, rejected by the preprocessor!" >&5
-$as_echo "$as_me: WARNING: $2: accepted by the compiler, rejected by the preprocessor!" >&2;}
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2: proceeding with the compiler's result" >&5
-$as_echo "$as_me: WARNING: $2: proceeding with the compiler's result" >&2;}
-    ;;
-  no:yes:* )
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2: present but cannot be compiled" >&5
-$as_echo "$as_me: WARNING: $2: present but cannot be compiled" >&2;}
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2:     check for missing prerequisite headers?" >&5
-$as_echo "$as_me: WARNING: $2:     check for missing prerequisite headers?" >&2;}
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2: see the Autoconf documentation" >&5
-$as_echo "$as_me: WARNING: $2: see the Autoconf documentation" >&2;}
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2:     section \"Present But Cannot Be Compiled\"" >&5
-$as_echo "$as_me: WARNING: $2:     section \"Present But Cannot Be Compiled\"" >&2;}
-    { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $2: proceeding with the compiler's result" >&5
-$as_echo "$as_me: WARNING: $2: proceeding with the compiler's result" >&2;}
-    ;;
-esac
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for $2" >&5
-$as_echo_n "checking for $2... " >&6; }
-if { as_var=$3; eval "test \"\${$as_var+set}\" = set"; }; then :
-  $as_echo_n "(cached) " >&6
-else
-  eval "$3=\$ac_header_compiler"
-fi
-eval ac_res=\$$3
-	       { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
-$as_echo "$ac_res" >&6; }
-fi
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-
-} # ac_fn_c_check_header_mongrel
-
-# ac_fn_c_try_run LINENO
-# ----------------------
-# Try to link conftest.$ac_ext, and return whether this succeeded. Assumes
-# that executables *can* be run.
-ac_fn_c_try_run ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  if { { ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_link") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; } && { ac_try='./conftest$ac_exeext'
-  { { case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_try") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; }; then :
-  ac_retval=0
-else
-  $as_echo "$as_me: program exited with status $ac_status" >&5
-       $as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-       ac_retval=$ac_status
-fi
-  rm -rf conftest.dSYM conftest_ipa8_conftest.oo
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-  as_fn_set_status $ac_retval
-
-} # ac_fn_c_try_run
-
-# ac_fn_c_check_header_compile LINENO HEADER VAR INCLUDES
-# -------------------------------------------------------
-# Tests whether HEADER exists and can be compiled using the include files in
-# INCLUDES, setting the cache variable VAR accordingly.
-ac_fn_c_check_header_compile ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for $2" >&5
-$as_echo_n "checking for $2... " >&6; }
-if { as_var=$3; eval "test \"\${$as_var+set}\" = set"; }; then :
-  $as_echo_n "(cached) " >&6
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-$4
-#include <$2>
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  eval "$3=yes"
-else
-  eval "$3=no"
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-fi
-eval ac_res=\$$3
-	       { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_res" >&5
-$as_echo "$ac_res" >&6; }
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-
-} # ac_fn_c_check_header_compile
-
-# ac_fn_c_try_link LINENO
-# -----------------------
-# Try to link conftest.$ac_ext, and return whether this succeeded.
-ac_fn_c_try_link ()
-{
-  as_lineno=${as_lineno-"$1"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-  rm -f conftest.$ac_objext conftest$ac_exeext
-  if { { ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_link") 2>conftest.err
-  ac_status=$?
-  if test -s conftest.err; then
-    grep -v '^ *+' conftest.err >conftest.er1
-    cat conftest.er1 >&5
-    mv -f conftest.er1 conftest.err
-  fi
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; } && {
-	 test -z "$ac_c_werror_flag" ||
-	 test ! -s conftest.err
-       } && test -s conftest$ac_exeext && {
-	 test "$cross_compiling" = yes ||
-	 $as_test_x conftest$ac_exeext
-       }; then :
-  ac_retval=0
-else
-  $as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-	ac_retval=1
-fi
-  # Delete the IPA/IPO (Inter Procedural Analysis/Optimization) information
-  # created by the PGI compiler (conftest_ipa8_conftest.oo), as it would
-  # interfere with the next link command; also delete a directory that is
-  # left behind by Apple's compiler.  We do this before executing the actions.
-  rm -rf conftest.dSYM conftest_ipa8_conftest.oo
-  eval $as_lineno_stack; test "x$as_lineno_stack" = x && { as_lineno=; unset as_lineno;}
-  as_fn_set_status $ac_retval
-
-} # ac_fn_c_try_link
-cat >config.log <<_ACEOF
-This file contains any messages produced by compilers while
-running configure, to aid debugging if configure makes a mistake.
-
-It was created by $as_me, which was
-generated by GNU Autoconf 2.65.  Invocation command line was
-
-  $ $0 $@
-
-_ACEOF
-exec 5>>config.log
-{
-cat <<_ASUNAME
-## --------- ##
-## Platform. ##
-## --------- ##
-
-hostname = `(hostname || uname -n) 2>/dev/null | sed 1q`
-uname -m = `(uname -m) 2>/dev/null || echo unknown`
-uname -r = `(uname -r) 2>/dev/null || echo unknown`
-uname -s = `(uname -s) 2>/dev/null || echo unknown`
-uname -v = `(uname -v) 2>/dev/null || echo unknown`
-
-/usr/bin/uname -p = `(/usr/bin/uname -p) 2>/dev/null || echo unknown`
-/bin/uname -X     = `(/bin/uname -X) 2>/dev/null     || echo unknown`
-
-/bin/arch              = `(/bin/arch) 2>/dev/null              || echo unknown`
-/usr/bin/arch -k       = `(/usr/bin/arch -k) 2>/dev/null       || echo unknown`
-/usr/convex/getsysinfo = `(/usr/convex/getsysinfo) 2>/dev/null || echo unknown`
-/usr/bin/hostinfo      = `(/usr/bin/hostinfo) 2>/dev/null      || echo unknown`
-/bin/machine           = `(/bin/machine) 2>/dev/null           || echo unknown`
-/usr/bin/oslevel       = `(/usr/bin/oslevel) 2>/dev/null       || echo unknown`
-/bin/universe          = `(/bin/universe) 2>/dev/null          || echo unknown`
-
-_ASUNAME
-
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    $as_echo "PATH: $as_dir"
-  done
-IFS=$as_save_IFS
-
-} >&5
-
-cat >&5 <<_ACEOF
-
-
-## ----------- ##
-## Core tests. ##
-## ----------- ##
-
-_ACEOF
-
-
-# Keep a trace of the command line.
-# Strip out --no-create and --no-recursion so they do not pile up.
-# Strip out --silent because we don't want to record it for future runs.
-# Also quote any args containing shell meta-characters.
-# Make two passes to allow for proper duplicate-argument suppression.
-ac_configure_args=
-ac_configure_args0=
-ac_configure_args1=
-ac_must_keep_next=false
-for ac_pass in 1 2
-do
-  for ac_arg
-  do
-    case $ac_arg in
-    -no-create | --no-c* | -n | -no-recursion | --no-r*) continue ;;
-    -q | -quiet | --quiet | --quie | --qui | --qu | --q \
-    | -silent | --silent | --silen | --sile | --sil)
-      continue ;;
-    *\'*)
-      ac_arg=`$as_echo "$ac_arg" | sed "s/'/'\\\\\\\\''/g"` ;;
-    esac
-    case $ac_pass in
-    1) as_fn_append ac_configure_args0 " '$ac_arg'" ;;
-    2)
-      as_fn_append ac_configure_args1 " '$ac_arg'"
-      if test $ac_must_keep_next = true; then
-	ac_must_keep_next=false # Got value, back to normal.
-      else
-	case $ac_arg in
-	  *=* | --config-cache | -C | -disable-* | --disable-* \
-	  | -enable-* | --enable-* | -gas | --g* | -nfp | --nf* \
-	  | -q | -quiet | --q* | -silent | --sil* | -v | -verb* \
-	  | -with-* | --with-* | -without-* | --without-* | --x)
-	    case "$ac_configure_args0 " in
-	      "$ac_configure_args1"*" '$ac_arg' "* ) continue ;;
-	    esac
-	    ;;
-	  -* ) ac_must_keep_next=true ;;
-	esac
-      fi
-      as_fn_append ac_configure_args " '$ac_arg'"
-      ;;
-    esac
-  done
-done
-{ ac_configure_args0=; unset ac_configure_args0;}
-{ ac_configure_args1=; unset ac_configure_args1;}
-
-# When interrupted or exit'd, cleanup temporary files, and complete
-# config.log.  We remove comments because anyway the quotes in there
-# would cause problems or look ugly.
-# WARNING: Use '\'' to represent an apostrophe within the trap.
-# WARNING: Do not start the trap code with a newline, due to a FreeBSD 4.0 bug.
-trap 'exit_status=$?
-  # Save into config.log some information that might help in debugging.
-  {
-    echo
-
-    cat <<\_ASBOX
-## ---------------- ##
-## Cache variables. ##
-## ---------------- ##
-_ASBOX
-    echo
-    # The following way of writing the cache mishandles newlines in values,
-(
-  for ac_var in `(set) 2>&1 | sed -n '\''s/^\([a-zA-Z_][a-zA-Z0-9_]*\)=.*/\1/p'\''`; do
-    eval ac_val=\$$ac_var
-    case $ac_val in #(
-    *${as_nl}*)
-      case $ac_var in #(
-      *_cv_*) { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: cache variable $ac_var contains a newline" >&5
-$as_echo "$as_me: WARNING: cache variable $ac_var contains a newline" >&2;} ;;
-      esac
-      case $ac_var in #(
-      _ | IFS | as_nl) ;; #(
-      BASH_ARGV | BASH_SOURCE) eval $ac_var= ;; #(
-      *) { eval $ac_var=; unset $ac_var;} ;;
-      esac ;;
-    esac
-  done
-  (set) 2>&1 |
-    case $as_nl`(ac_space='\'' '\''; set) 2>&1` in #(
-    *${as_nl}ac_space=\ *)
-      sed -n \
-	"s/'\''/'\''\\\\'\'''\''/g;
-	  s/^\\([_$as_cr_alnum]*_cv_[_$as_cr_alnum]*\\)=\\(.*\\)/\\1='\''\\2'\''/p"
-      ;; #(
-    *)
-      sed -n "/^[_$as_cr_alnum]*_cv_[_$as_cr_alnum]*=/p"
-      ;;
-    esac |
-    sort
-)
-    echo
-
-    cat <<\_ASBOX
-## ----------------- ##
-## Output variables. ##
-## ----------------- ##
-_ASBOX
-    echo
-    for ac_var in $ac_subst_vars
-    do
-      eval ac_val=\$$ac_var
-      case $ac_val in
-      *\'\''*) ac_val=`$as_echo "$ac_val" | sed "s/'\''/'\''\\\\\\\\'\'''\''/g"`;;
-      esac
-      $as_echo "$ac_var='\''$ac_val'\''"
-    done | sort
-    echo
-
-    if test -n "$ac_subst_files"; then
-      cat <<\_ASBOX
-## ------------------- ##
-## File substitutions. ##
-## ------------------- ##
-_ASBOX
-      echo
-      for ac_var in $ac_subst_files
-      do
-	eval ac_val=\$$ac_var
-	case $ac_val in
-	*\'\''*) ac_val=`$as_echo "$ac_val" | sed "s/'\''/'\''\\\\\\\\'\'''\''/g"`;;
-	esac
-	$as_echo "$ac_var='\''$ac_val'\''"
-      done | sort
-      echo
-    fi
-
-    if test -s confdefs.h; then
-      cat <<\_ASBOX
-## ----------- ##
-## confdefs.h. ##
-## ----------- ##
-_ASBOX
-      echo
-      cat confdefs.h
-      echo
-    fi
-    test "$ac_signal" != 0 &&
-      $as_echo "$as_me: caught signal $ac_signal"
-    $as_echo "$as_me: exit $exit_status"
-  } >&5
-  rm -f core *.core core.conftest.* &&
-    rm -f -r conftest* confdefs* conf$$* $ac_clean_files &&
-    exit $exit_status
-' 0
-for ac_signal in 1 2 13 15; do
-  trap 'ac_signal='$ac_signal'; as_fn_exit 1' $ac_signal
-done
-ac_signal=0
-
-# confdefs.h avoids OS command line length limits that DEFS can exceed.
-rm -f -r conftest* confdefs.h
-
-$as_echo "/* confdefs.h */" > confdefs.h
-
-# Predefined preprocessor variables.
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_NAME "$PACKAGE_NAME"
-_ACEOF
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_TARNAME "$PACKAGE_TARNAME"
-_ACEOF
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_VERSION "$PACKAGE_VERSION"
-_ACEOF
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_STRING "$PACKAGE_STRING"
-_ACEOF
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_BUGREPORT "$PACKAGE_BUGREPORT"
-_ACEOF
-
-cat >>confdefs.h <<_ACEOF
-#define PACKAGE_URL "$PACKAGE_URL"
-_ACEOF
-
-
-# Let the site file select an alternate cache file if it wants to.
-# Prefer an explicitly selected file to automatically selected ones.
-ac_site_file1=NONE
-ac_site_file2=NONE
-if test -n "$CONFIG_SITE"; then
-  ac_site_file1=$CONFIG_SITE
-elif test "x$prefix" != xNONE; then
-  ac_site_file1=$prefix/share/config.site
-  ac_site_file2=$prefix/etc/config.site
-else
-  ac_site_file1=$ac_default_prefix/share/config.site
-  ac_site_file2=$ac_default_prefix/etc/config.site
-fi
-for ac_site_file in "$ac_site_file1" "$ac_site_file2"
-do
-  test "x$ac_site_file" = xNONE && continue
-  if test /dev/null != "$ac_site_file" && test -r "$ac_site_file"; then
-    { $as_echo "$as_me:${as_lineno-$LINENO}: loading site script $ac_site_file" >&5
-$as_echo "$as_me: loading site script $ac_site_file" >&6;}
-    sed 's/^/| /' "$ac_site_file" >&5
-    . "$ac_site_file"
-  fi
-done
-
-if test -r "$cache_file"; then
-  # Some versions of bash will fail to source /dev/null (special files
-  # actually), so we avoid doing that.  DJGPP emulates it as a regular file.
-  if test /dev/null != "$cache_file" && test -f "$cache_file"; then
-    { $as_echo "$as_me:${as_lineno-$LINENO}: loading cache $cache_file" >&5
-$as_echo "$as_me: loading cache $cache_file" >&6;}
-    case $cache_file in
-      [\\/]* | ?:[\\/]* ) . "$cache_file";;
-      *)                      . "./$cache_file";;
-    esac
-  fi
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: creating cache $cache_file" >&5
-$as_echo "$as_me: creating cache $cache_file" >&6;}
-  >$cache_file
-fi
-
-# Check that the precious variables saved in the cache have kept the same
-# value.
-ac_cache_corrupted=false
-for ac_var in $ac_precious_vars; do
-  eval ac_old_set=\$ac_cv_env_${ac_var}_set
-  eval ac_new_set=\$ac_env_${ac_var}_set
-  eval ac_old_val=\$ac_cv_env_${ac_var}_value
-  eval ac_new_val=\$ac_env_${ac_var}_value
-  case $ac_old_set,$ac_new_set in
-    set,)
-      { $as_echo "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&5
-$as_echo "$as_me: error: \`$ac_var' was set to \`$ac_old_val' in the previous run" >&2;}
-      ac_cache_corrupted=: ;;
-    ,set)
-      { $as_echo "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' was not set in the previous run" >&5
-$as_echo "$as_me: error: \`$ac_var' was not set in the previous run" >&2;}
-      ac_cache_corrupted=: ;;
-    ,);;
-    *)
-      if test "x$ac_old_val" != "x$ac_new_val"; then
-	# differences in whitespace do not lead to failure.
-	ac_old_val_w=`echo x $ac_old_val`
-	ac_new_val_w=`echo x $ac_new_val`
-	if test "$ac_old_val_w" != "$ac_new_val_w"; then
-	  { $as_echo "$as_me:${as_lineno-$LINENO}: error: \`$ac_var' has changed since the previous run:" >&5
-$as_echo "$as_me: error: \`$ac_var' has changed since the previous run:" >&2;}
-	  ac_cache_corrupted=:
-	else
-	  { $as_echo "$as_me:${as_lineno-$LINENO}: warning: ignoring whitespace changes in \`$ac_var' since the previous run:" >&5
-$as_echo "$as_me: warning: ignoring whitespace changes in \`$ac_var' since the previous run:" >&2;}
-	  eval $ac_var=\$ac_old_val
-	fi
-	{ $as_echo "$as_me:${as_lineno-$LINENO}:   former value:  \`$ac_old_val'" >&5
-$as_echo "$as_me:   former value:  \`$ac_old_val'" >&2;}
-	{ $as_echo "$as_me:${as_lineno-$LINENO}:   current value: \`$ac_new_val'" >&5
-$as_echo "$as_me:   current value: \`$ac_new_val'" >&2;}
-      fi;;
-  esac
-  # Pass precious variables to config.status.
-  if test "$ac_new_set" = set; then
-    case $ac_new_val in
-    *\'*) ac_arg=$ac_var=`$as_echo "$ac_new_val" | sed "s/'/'\\\\\\\\''/g"` ;;
-    *) ac_arg=$ac_var=$ac_new_val ;;
-    esac
-    case " $ac_configure_args " in
-      *" '$ac_arg' "*) ;; # Avoid dups.  Use of quotes ensures accuracy.
-      *) as_fn_append ac_configure_args " '$ac_arg'" ;;
-    esac
-  fi
-done
-if $ac_cache_corrupted; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-  { $as_echo "$as_me:${as_lineno-$LINENO}: error: changes in the environment can compromise the build" >&5
-$as_echo "$as_me: error: changes in the environment can compromise the build" >&2;}
-  as_fn_error "run \`make distclean' and/or \`rm $cache_file' and start over" "$LINENO" 5
-fi
-## -------------------- ##
-## Main body of script. ##
-## -------------------- ##
-
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
-
-
-ac_aux_dir=
-for ac_dir in build "$srcdir"/build; do
-  for ac_t in install-sh install.sh shtool; do
-    if test -f "$ac_dir/$ac_t"; then
-      ac_aux_dir=$ac_dir
-      ac_install_sh="$ac_aux_dir/$ac_t -c"
-      break 2
-    fi
-  done
-done
-if test -z "$ac_aux_dir"; then
-  as_fn_error "cannot find install-sh, install.sh, or shtool in build \"$srcdir\"/build" "$LINENO" 5
-fi
-
-# These three variables are undocumented and unsupported,
-# and are intended to be withdrawn in a future Autoconf release.
-# They can cause serious problems if a builder's source tree is in a directory
-# whose full name contains unusual characters.
-ac_config_guess="$SHELL $ac_aux_dir/config.guess"  # Please don't use this var.
-ac_config_sub="$SHELL $ac_aux_dir/config.sub"  # Please don't use this var.
-ac_configure="$SHELL $ac_aux_dir/configure"  # Please don't use this var.
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-# Check whether --enable-layout was given.
-if test "${enable_layout+set}" = set; then :
-  enableval=$enable_layout;
-  LAYOUT=$enableval
-
-fi
-
-
-if test -z "$LAYOUT"; then
-  LAYOUT="Serf"
-fi
-
-  if test ! -f $srcdir/config.layout; then
-    echo "** Error: Layout file $srcdir/config.layout not found"
-    echo "** Error: Cannot use undefined layout '$LAYOUT'"
-    exit 1
-  fi
-  # Catch layout names including a slash which will otherwise
-  # confuse the heck out of the sed script.
-  case $LAYOUT in
-  */*)
-    echo "** Error: $LAYOUT is not a valid layout name"
-    exit 1 ;;
-  esac
-  pldconf=./config.pld
-
-  sed -e "1s/[ 	]*<[lL]ayout[ 	]*$LAYOUT[ 	]*>[ 	]*//;1t" \
-      -e "1,/[ 	]*<[lL]ayout[ 	]*$LAYOUT[ 	]*>[ 	]*/d" \
-      -e '/[ 	]*<\/Layout>[ 	]*/,$d' \
-      -e "s/^[ 	]*//g" \
-      -e "s/:[ 	]*/=\'/g" \
-      -e "s/[ 	]*$/'/g" \
-      $srcdir/config.layout > $pldconf
-  layout_name=$LAYOUT
-  if test ! -s $pldconf; then
-    echo "** Error: unable to find layout $layout_name"
-    exit 1
-  fi
-  . $pldconf
-  rm $pldconf
-  for var in prefix exec_prefix bindir sbindir libexecdir mandir \
-             sysconfdir datadir includedir localstatedir runtimedir \
-             logfiledir libdir installbuilddir libsuffix ; do
-    eval "val=\"\$$var\""
-    case $val in
-      *+)
-        val=`echo $val | sed -e 's;\+$;;'`
-        eval "$var=\"\$val\""
-        autosuffix=yes
-        ;;
-      *)
-        autosuffix=no
-        ;;
-    esac
-    val=`echo $val | sed -e 's:\(.\)/*$:\1:'`
-    val=`echo $val | sed -e 's:[\$]\([a-z_]*\):$\1:g'`
-    if test "$autosuffix" = "yes"; then
-      if echo $val | grep apache >/dev/null; then
-        addtarget=no
-      else
-        addtarget=yes
-      fi
-      if test "$addtarget" = "yes"; then
-        val="$val/apache2"
-      fi
-    fi
-    eval "$var='$val'"
-  done
-
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for chosen layout" >&5
-$as_echo_n "checking for chosen layout... " >&6; }
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $layout_name" >&5
-$as_echo "$layout_name" >&6; }
-
-
-
-ac_prev=
-# Retrieve the command-line arguments.  The eval is needed because
-# the arguments are quoted to preserve accuracy.
-eval "set x $ac_configure_args"
-shift
-for ac_option
-do
-  # If the previous option needs an argument, assign it.
-  if test -n "$ac_prev"; then
-    eval "$ac_prev=\$ac_option"
-    ac_prev=
-    continue
-  fi
-
-  ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
-
-  case $ac_option in
-
-  -bindir | --bindir | --bindi | --bind | --bin | --bi)
-    ac_prev=bindir ;;
-  -bindir=* | --bindir=* | --bindi=* | --bind=* | --bin=* | --bi=*)
-    bindir="$ac_optarg" ;;
-
-  -datadir | --datadir | --datadi | --datad | --data | --dat | --da)
-    ac_prev=datadir ;;
-  -datadir=* | --datadir=* | --datadi=* | --datad=* | --data=* | --dat=* \
-  | --da=*)
-    datadir="$ac_optarg" ;;
-
-  -exec-prefix | --exec_prefix | --exec-prefix | --exec-prefi \
-  | --exec-pref | --exec-pre | --exec-pr | --exec-p | --exec- \
-  | --exec | --exe | --ex)
-    ac_prev=exec_prefix ;;
-  -exec-prefix=* | --exec_prefix=* | --exec-prefix=* | --exec-prefi=* \
-  | --exec-pref=* | --exec-pre=* | --exec-pr=* | --exec-p=* | --exec-=* \
-  | --exec=* | --exe=* | --ex=*)
-    exec_prefix="$ac_optarg" ;;
-
-  -includedir | --includedir | --includedi | --included | --include \
-  | --includ | --inclu | --incl | --inc)
-    ac_prev=includedir ;;
-  -includedir=* | --includedir=* | --includedi=* | --included=* | --include=* \
-  | --includ=* | --inclu=* | --incl=* | --inc=*)
-    includedir="$ac_optarg" ;;
-
-  -infodir | --infodir | --infodi | --infod | --info | --inf)
-    ac_prev=infodir ;;
-  -infodir=* | --infodir=* | --infodi=* | --infod=* | --info=* | --inf=*)
-    infodir="$ac_optarg" ;;
-
-  -libdir | --libdir | --libdi | --libd)
-    ac_prev=libdir ;;
-  -libdir=* | --libdir=* | --libdi=* | --libd=*)
-    libdir="$ac_optarg" ;;
-
-  -libexecdir | --libexecdir | --libexecdi | --libexecd | --libexec \
-  | --libexe | --libex | --libe)
-    ac_prev=libexecdir ;;
-  -libexecdir=* | --libexecdir=* | --libexecdi=* | --libexecd=* | --libexec=* \
-  | --libexe=* | --libex=* | --libe=*)
-    libexecdir="$ac_optarg" ;;
-
-  -localstatedir | --localstatedir | --localstatedi | --localstated \
-  | --localstate | --localstat | --localsta | --localst \
-  | --locals | --local | --loca | --loc | --lo)
-    ac_prev=localstatedir ;;
-  -localstatedir=* | --localstatedir=* | --localstatedi=* | --localstated=* \
-  | --localstate=* | --localstat=* | --localsta=* | --localst=* \
-  | --locals=* | --local=* | --loca=* | --loc=* | --lo=*)
-    localstatedir="$ac_optarg" ;;
-
-  -mandir | --mandir | --mandi | --mand | --man | --ma | --m)
-    ac_prev=mandir ;;
-  -mandir=* | --mandir=* | --mandi=* | --mand=* | --man=* | --ma=* | --m=*)
-    mandir="$ac_optarg" ;;
-
-  -prefix | --prefix | --prefi | --pref | --pre | --pr | --p)
-    ac_prev=prefix ;;
-  -prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=* | --pr=* | --p=*)
-    prefix="$ac_optarg" ;;
-
-  -sbindir | --sbindir | --sbindi | --sbind | --sbin | --sbi | --sb)
-    ac_prev=sbindir ;;
-  -sbindir=* | --sbindir=* | --sbindi=* | --sbind=* | --sbin=* \
-  | --sbi=* | --sb=*)
-    sbindir="$ac_optarg" ;;
-
-  -sharedstatedir | --sharedstatedir | --sharedstatedi \
-  | --sharedstated | --sharedstate | --sharedstat | --sharedsta \
-  | --sharedst | --shareds | --shared | --share | --shar \
-  | --sha | --sh)
-    ac_prev=sharedstatedir ;;
-  -sharedstatedir=* | --sharedstatedir=* | --sharedstatedi=* \
-  | --sharedstated=* | --sharedstate=* | --sharedstat=* | --sharedsta=* \
-  | --sharedst=* | --shareds=* | --shared=* | --share=* | --shar=* \
-  | --sha=* | --sh=*)
-    sharedstatedir="$ac_optarg" ;;
-
-  -sysconfdir | --sysconfdir | --sysconfdi | --sysconfd | --sysconf \
-  | --syscon | --sysco | --sysc | --sys | --sy)
-    ac_prev=sysconfdir ;;
-  -sysconfdir=* | --sysconfdir=* | --sysconfdi=* | --sysconfd=* | --sysconf=* \
-  | --syscon=* | --sysco=* | --sysc=* | --sys=* | --sy=*)
-    sysconfdir="$ac_optarg" ;;
-
-  esac
-done
-
-# Be sure to have absolute paths.
-for ac_var in exec_prefix prefix
-do
-  eval ac_val=$`echo $ac_var`
-  case $ac_val in
-    [\\/$]* | ?:[\\/]* | NONE | '' ) ;;
-    *)  as_fn_error "expected an absolute path for --$ac_var: $ac_val" "$LINENO" 5;;
-  esac
-done
-
-
-
-
-  apr_ste_save_CPPFLAGS="$CPPFLAGS"
-
-
-  apr_ste_save_CFLAGS="$CFLAGS"
-
-
-  apr_ste_save_CXXFLAGS="$CXXFLAGS"
-
-
-  apr_ste_save_LDFLAGS="$LDFLAGS"
-
-
-  apr_ste_save_LIBS="$LIBS"
-
-
-  apr_ste_save_INCLUDES="$INCLUDES"
-
-
-
-  rm -f config.nice
-  cat >config.nice<<EOF
-#! /bin/sh
-#
-# Created by configure
-
-EOF
-  if test -n "$CC"; then
-    echo "CC=\"$CC\"; export CC" >> config.nice
-  fi
-  if test -n "$CFLAGS"; then
-    echo "CFLAGS=\"$CFLAGS\"; export CFLAGS" >> config.nice
-  fi
-  if test -n "$CPPFLAGS"; then
-    echo "CPPFLAGS=\"$CPPFLAGS\"; export CPPFLAGS" >> config.nice
-  fi
-  if test -n "$LDFLAGS"; then
-    echo "LDFLAGS=\"$LDFLAGS\"; export LDFLAGS" >> config.nice
-  fi
-  if test -n "$LTFLAGS"; then
-    echo "LTFLAGS=\"$LTFLAGS\"; export LTFLAGS" >> config.nice
-  fi
-  if test -n "$LIBS"; then
-    echo "LIBS=\"$LIBS\"; export LIBS" >> config.nice
-  fi
-  if test -n "$INCLUDES"; then
-    echo "INCLUDES=\"$INCLUDES\"; export INCLUDES" >> config.nice
-  fi
-  if test -n "$NOTEST_CFLAGS"; then
-    echo "NOTEST_CFLAGS=\"$NOTEST_CFLAGS\"; export NOTEST_CFLAGS" >> config.nice
-  fi
-  if test -n "$NOTEST_CPPFLAGS"; then
-    echo "NOTEST_CPPFLAGS=\"$NOTEST_CPPFLAGS\"; export NOTEST_CPPFLAGS" >> config.nice
-  fi
-  if test -n "$NOTEST_LDFLAGS"; then
-    echo "NOTEST_LDFLAGS=\"$NOTEST_LDFLAGS\"; export NOTEST_LDFLAGS" >> config.nice
-  fi
-  if test -n "$NOTEST_LIBS"; then
-    echo "NOTEST_LIBS=\"$NOTEST_LIBS\"; export NOTEST_LIBS" >> config.nice
-  fi
-
-  # Retrieve command-line arguments.
-  eval "set x $0 $ac_configure_args"
-  shift
-
-  for arg
-  do
-
-ap_last=
-ap_cur="$arg"
-while test "x${ap_cur}" != "x${ap_last}";
-do
-  ap_last="${ap_cur}"
-  ap_cur=`eval "echo ${ap_cur}"`
-done
-arg="${ap_cur}"
-
-    echo "\"$arg\" \\" >> config.nice
-  done
-  echo '"$@"' >> config.nice
-  chmod +x config.nice
-
-
-nl='
-'
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for working mkdir -p" >&5
-$as_echo_n "checking for working mkdir -p... " >&6; }
-if test "${ac_cv_mkdir_p+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-
-    test -d conftestdir && rm -rf conftestdir
-    mkdir -p conftestdir/somedir >/dev/null 2>&1
-    if test -d conftestdir/somedir; then
-      ac_cv_mkdir_p=yes
-    else
-      ac_cv_mkdir_p=no
-    fi
-    rm -rf conftestdir
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_mkdir_p" >&5
-$as_echo "$ac_cv_mkdir_p" >&6; }
-  if test "$ac_cv_mkdir_p" = "yes"; then
-      mkdir_p="mkdir -p"
-  else
-      mkdir_p="$top_srcdir/build/mkdir.sh"
-  fi
-
-
-
-
-
-# Make sure we can run config.sub.
-$SHELL "$ac_aux_dir/config.sub" sun4 >/dev/null 2>&1 ||
-  as_fn_error "cannot run $SHELL $ac_aux_dir/config.sub" "$LINENO" 5
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking build system type" >&5
-$as_echo_n "checking build system type... " >&6; }
-if test "${ac_cv_build+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_build_alias=$build_alias
-test "x$ac_build_alias" = x &&
-  ac_build_alias=`$SHELL "$ac_aux_dir/config.guess"`
-test "x$ac_build_alias" = x &&
-  as_fn_error "cannot guess build type; you must specify one" "$LINENO" 5
-ac_cv_build=`$SHELL "$ac_aux_dir/config.sub" $ac_build_alias` ||
-  as_fn_error "$SHELL $ac_aux_dir/config.sub $ac_build_alias failed" "$LINENO" 5
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_build" >&5
-$as_echo "$ac_cv_build" >&6; }
-case $ac_cv_build in
-*-*-*) ;;
-*) as_fn_error "invalid value of canonical build" "$LINENO" 5;;
-esac
-build=$ac_cv_build
-ac_save_IFS=$IFS; IFS='-'
-set x $ac_cv_build
-shift
-build_cpu=$1
-build_vendor=$2
-shift; shift
-# Remember, the first character of IFS is used to create $*,
-# except with old shells:
-build_os=$*
-IFS=$ac_save_IFS
-case $build_os in *\ *) build_os=`echo "$build_os" | sed 's/ /-/g'`;; esac
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking host system type" >&5
-$as_echo_n "checking host system type... " >&6; }
-if test "${ac_cv_host+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test "x$host_alias" = x; then
-  ac_cv_host=$ac_cv_build
-else
-  ac_cv_host=`$SHELL "$ac_aux_dir/config.sub" $host_alias` ||
-    as_fn_error "$SHELL $ac_aux_dir/config.sub $host_alias failed" "$LINENO" 5
-fi
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_host" >&5
-$as_echo "$ac_cv_host" >&6; }
-case $ac_cv_host in
-*-*-*) ;;
-*) as_fn_error "invalid value of canonical host" "$LINENO" 5;;
-esac
-host=$ac_cv_host
-ac_save_IFS=$IFS; IFS='-'
-set x $ac_cv_host
-shift
-host_cpu=$1
-host_vendor=$2
-shift; shift
-# Remember, the first character of IFS is used to create $*,
-# except with old shells:
-host_os=$*
-IFS=$ac_save_IFS
-case $host_os in *\ *) host_os=`echo "$host_os" | sed 's/ /-/g'`;; esac
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking target system type" >&5
-$as_echo_n "checking target system type... " >&6; }
-if test "${ac_cv_target+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test "x$target_alias" = x; then
-  ac_cv_target=$ac_cv_host
-else
-  ac_cv_target=`$SHELL "$ac_aux_dir/config.sub" $target_alias` ||
-    as_fn_error "$SHELL $ac_aux_dir/config.sub $target_alias failed" "$LINENO" 5
-fi
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_target" >&5
-$as_echo "$ac_cv_target" >&6; }
-case $ac_cv_target in
-*-*-*) ;;
-*) as_fn_error "invalid value of canonical target" "$LINENO" 5;;
-esac
-target=$ac_cv_target
-ac_save_IFS=$IFS; IFS='-'
-set x $ac_cv_target
-shift
-target_cpu=$1
-target_vendor=$2
-shift; shift
-# Remember, the first character of IFS is used to create $*,
-# except with old shells:
-target_os=$*
-IFS=$ac_save_IFS
-case $target_os in *\ *) target_os=`echo "$target_os" | sed 's/ /-/g'`;; esac
-
-
-# The aliases save the names the user supplied, while $host etc.
-# will get canonicalized.
-test -n "$target_alias" &&
-  test "$program_prefix$program_suffix$program_transform_name" = \
-    NONENONEs,x,x, &&
-  program_prefix=${target_alias}-
-
-
-orig_prefix="$prefix"
-
-echo $ac_n "${nl}Configuring Apache Portable Runtime library...${nl}"
-
-
-  apr_found="no"
-
-  if test "$target_os" = "os2-emx"; then
-    # Scripts don't pass test -x on OS/2
-    TEST_X="test -f"
-  else
-    TEST_X="test -x"
-  fi
-
-  acceptable_majors="0 1 2"
-
-  apr_temp_acceptable_apr_config=""
-  for apr_temp_major in $acceptable_majors
-  do
-    case $apr_temp_major in
-      0)
-      apr_temp_acceptable_apr_config="$apr_temp_acceptable_apr_config apr-config"
-      ;;
-      *)
-      apr_temp_acceptable_apr_config="$apr_temp_acceptable_apr_config apr-$apr_temp_major-config"
-      ;;
-    esac
-  done
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for APR" >&5
-$as_echo_n "checking for APR... " >&6; }
-
-# Check whether --with-apr was given.
-if test "${with_apr+set}" = set; then :
-  withval=$with_apr;
-    if test "$withval" = "no" || test "$withval" = "yes"; then
-      as_fn_error "--with-apr requires a directory or file to be provided" "$LINENO" 5
-    fi
-
-    for apr_temp_apr_config_file in $apr_temp_acceptable_apr_config
-    do
-      for lookdir in "$withval/bin" "$withval"
-      do
-        if $TEST_X "$lookdir/$apr_temp_apr_config_file"; then
-          apr_config="$lookdir/$apr_temp_apr_config_file"
-
-          apr_found="yes"
-          break 2
-        fi
-      done
-    done
-
-    if test "$apr_found" != "yes" && $TEST_X "$withval" && $withval --help > /dev/null 2>&1 ; then
-      apr_config="$withval"
-      apr_found="yes"
-    fi
-
-            if test "$apr_found" != "yes"; then
-      as_fn_error "the --with-apr parameter is incorrect. It must specify an install prefix, a build directory, or an apr-config file." "$LINENO" 5
-    fi
-
-else
-
-        if test -n "1" && test "1" = "1"; then
-      for apr_temp_apr_config_file in $apr_temp_acceptable_apr_config
-      do
-        if $apr_temp_apr_config_file --help > /dev/null 2>&1 ; then
-          apr_config="$apr_temp_apr_config_file"
-
-          apr_found="yes"
-          break
-        else
-                    for lookdir in /usr /usr/local /usr/local/apr /opt/apr; do
-            if $TEST_X "$lookdir/bin/$apr_temp_apr_config_file"; then
-              apr_config="$lookdir/bin/$apr_temp_apr_config_file"
-
-              apr_found="yes"
-              break 2
-            fi
-          done
-        fi
-      done
-    fi
-        if test "$apr_found" = "no" && test -d ""$srcdir/apr""; then
-      apr_temp_abs_srcdir="`cd "$srcdir/apr" && pwd`"
-      apr_found="reconfig"
-      apr_bundled_major="`sed -n '/#define.*APR_MAJOR_VERSION/s/^[^0-9]*\([0-9]*\).*$/\1/p' \""$srcdir/apr"/include/apr_version.h\"`"
-      case $apr_bundled_major in
-        "")
-          as_fn_error "failed to find major version of bundled APR" "$LINENO" 5
-        ;;
-        0)
-          apr_temp_apr_config_file="apr-config"
-        ;;
-        *)
-          apr_temp_apr_config_file="apr-$apr_bundled_major-config"
-        ;;
-      esac
-      if test -n ""./apr""; then
-        apr_config=""./apr"/$apr_temp_apr_config_file"
-      else
-        apr_config=""$srcdir/apr"/$apr_temp_apr_config_file"
-      fi
-    fi
-
-fi
-
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $apr_found" >&5
-$as_echo "$apr_found" >&6; }
-
-
-if test "$apr_found" = "no"; then
-  as_fn_error "APR not found.  Please read the documentation." "$LINENO" 5
-fi
-
-if test "$apr_found" = "reconfig"; then
-
-  # save our work to this point; this allows the sub-package to use it
-  cat >confcache <<\_ACEOF
-# This file is a shell script that caches the results of configure
-# tests run on this system so they can be shared between configure
-# scripts and configure runs, see configure's option --config-cache.
-# It is not useful on other systems.  If it contains results you don't
-# want to keep, you may remove or edit it.
-#
-# config.status only pays attention to the cache file if you give it
-# the --recheck option to rerun configure.
-#
-# `ac_cv_env_foo' variables (set or unset) will be overridden when
-# loading this file, other *unset* `ac_cv_foo' will be assigned the
-# following values.
-
-_ACEOF
-
-# The following way of writing the cache mishandles newlines in values,
-# but we know of no workaround that is simple, portable, and efficient.
-# So, we kill variables containing newlines.
-# Ultrix sh set writes to stderr and can't be redirected directly,
-# and sets the high bit in the cache file unless we assign to the vars.
-(
-  for ac_var in `(set) 2>&1 | sed -n 's/^\([a-zA-Z_][a-zA-Z0-9_]*\)=.*/\1/p'`; do
-    eval ac_val=\$$ac_var
-    case $ac_val in #(
-    *${as_nl}*)
-      case $ac_var in #(
-      *_cv_*) { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: cache variable $ac_var contains a newline" >&5
-$as_echo "$as_me: WARNING: cache variable $ac_var contains a newline" >&2;} ;;
-      esac
-      case $ac_var in #(
-      _ | IFS | as_nl) ;; #(
-      BASH_ARGV | BASH_SOURCE) eval $ac_var= ;; #(
-      *) { eval $ac_var=; unset $ac_var;} ;;
-      esac ;;
-    esac
-  done
-
-  (set) 2>&1 |
-    case $as_nl`(ac_space=' '; set) 2>&1` in #(
-    *${as_nl}ac_space=\ *)
-      # `set' does not quote correctly, so add quotes: double-quote
-      # substitution turns \\\\ into \\, and sed turns \\ into \.
-      sed -n \
-	"s/'/'\\\\''/g;
-	  s/^\\([_$as_cr_alnum]*_cv_[_$as_cr_alnum]*\\)=\\(.*\\)/\\1='\\2'/p"
-      ;; #(
-    *)
-      # `set' quotes correctly as required by POSIX, so do not add quotes.
-      sed -n "/^[_$as_cr_alnum]*_cv_[_$as_cr_alnum]*=/p"
-      ;;
-    esac |
-    sort
-) |
-  sed '
-     /^ac_cv_env_/b end
-     t clear
-     :clear
-     s/^\([^=]*\)=\(.*[{}].*\)$/test "${\1+set}" = set || &/
-     t end
-     s/^\([^=]*\)=\(.*\)$/\1=${\1=\2}/
-     :end' >>confcache
-if diff "$cache_file" confcache >/dev/null 2>&1; then :; else
-  if test -w "$cache_file"; then
-    test "x$cache_file" != "x/dev/null" &&
-      { $as_echo "$as_me:${as_lineno-$LINENO}: updating cache $cache_file" >&5
-$as_echo "$as_me: updating cache $cache_file" >&6;}
-    cat confcache >$cache_file
-  else
-    { $as_echo "$as_me:${as_lineno-$LINENO}: not updating unwritable cache $cache_file" >&5
-$as_echo "$as_me: not updating unwritable cache $cache_file" >&6;}
-  fi
-fi
-rm -f confcache
-
-  echo "configuring package in apr now"
-  ac_popdir=`pwd`
-  apr_config_subdirs="apr"
-  test -d apr || $mkdir_p apr
-  ac_abs_srcdir=`(cd $srcdir/apr && pwd)`
-  cd apr
-
-      # A "../" for each directory in /$config_subdirs.
-      ac_dots=`echo $apr_config_subdirs|sed -e 's%^\./%%' -e 's%[^/]$%&/%' -e 's%[^/]*/%../%g'`
-
-  # Make the cache file pathname absolute for the subdirs
-  # required to correctly handle subdirs that might actually
-  # be symlinks
-  case "$cache_file" in
-  /*) # already absolute
-    ac_sub_cache_file=$cache_file ;;
-  *)  # Was relative path.
-    ac_sub_cache_file="$ac_popdir/$cache_file" ;;
-  esac
-
-
-  apr_configure_args=
-  apr_sep=
-  for apr_configure_arg in $ac_configure_args
-  do
-    case "$apr_configure_arg" in
-      --enable-layout=*|\'--enable-layout=*)
-        continue ;;
-    esac
-    apr_configure_args="$apr_configure_args$apr_sep'$apr_configure_arg'"
-    apr_sep=" "
-  done
-
-
-    test "x$silent" = "xyes" && apr_configure_args="$apr_configure_args --silent"
-
-    apr_configure_args="--disable-option-checking $apr_configure_args"
-
-              if eval $SHELL $ac_abs_srcdir/configure $apr_configure_args --cache-file=$ac_sub_cache_file --srcdir=$ac_abs_srcdir --prefix=$prefix --exec-prefix=$exec_prefix --libdir=$libdir --includedir=$includedir --bindir=$bindir --datadir=$datadir --with-installbuilddir=$installbuilddir
-  then :
-    echo "apr configured properly"
-  else
-    echo "configure failed for apr"
-    exit 1
-  fi
-
-  cd $ac_popdir
-
-  # grab any updates from the sub-package
-  if test -r "$cache_file"; then
-  # Some versions of bash will fail to source /dev/null (special files
-  # actually), so we avoid doing that.  DJGPP emulates it as a regular file.
-  if test /dev/null != "$cache_file" && test -f "$cache_file"; then
-    { $as_echo "$as_me:${as_lineno-$LINENO}: loading cache $cache_file" >&5
-$as_echo "$as_me: loading cache $cache_file" >&6;}
-    case $cache_file in
-      [\\/]* | ?:[\\/]* ) . "$cache_file";;
-      *)                      . "./$cache_file";;
-    esac
-  fi
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: creating cache $cache_file" >&5
-$as_echo "$as_me: creating cache $cache_file" >&6;}
-  >$cache_file
-fi
-
-
-    SERF_BUILD_SRCLIB_DIRS="apr $SERF_BUILD_SRCLIB_DIRS"
-  SERF_CLEAN_SRCLIB_DIRS="$SERF_CLEAN_SRCLIB_DIRS apr"
-fi
-
-
-  if test -z "$CC"; then
-    test "x$silent" != "xyes" && echo "  setting CC to \"`$apr_config --cc`\""
-    CC="`$apr_config --cc`"
-  fi
-
-
-  if test -z "$CPP"; then
-    test "x$silent" != "xyes" && echo "  setting CPP to \"`$apr_config --cpp`\""
-    CPP="`$apr_config --cpp`"
-  fi
-
-
-  if test -z "$APR_LIBTOOL"; then
-    test "x$silent" != "xyes" && echo "  setting APR_LIBTOOL to \"`$apr_config --apr-libtool`\""
-    APR_LIBTOOL="`$apr_config --apr-libtool`"
-  fi
-
-
-  if test "x$CFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting CFLAGS to \"`$apr_config --cflags`\""
-    CFLAGS="`$apr_config --cflags`"
-  else
-    apr_addto_bugger="`$apr_config --cflags`"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $CFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to CFLAGS"
-        CFLAGS="$CFLAGS $i"
-      fi
-    done
-  fi
-
-
-  if test "x$CPPFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting CPPFLAGS to \"`$apr_config --cppflags`\""
-    CPPFLAGS="`$apr_config --cppflags`"
-  else
-    apr_addto_bugger="`$apr_config --cppflags`"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $CPPFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to CPPFLAGS"
-        CPPFLAGS="$CPPFLAGS $i"
-      fi
-    done
-  fi
-
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \"`$apr_config --ldflags`\""
-    LDFLAGS="`$apr_config --ldflags`"
-  else
-    apr_addto_bugger="`$apr_config --ldflags`"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-SHLIBPATH_VAR=`$apr_config --shlib-path-var`
-APR_BINDIR=`$apr_config --bindir`
-APR_INCLUDES=`$apr_config --includes`
-APR_VERSION=`$apr_config --version`
-APR_CONFIG="$apr_config"
-
-
-  if test -z "$LTFLAGS"; then
-    test "x$silent" != "xyes" && echo "  setting LTFLAGS to \""--silent"\""
-    LTFLAGS=""--silent""
-  fi
-
-
-
-
-
-
-
-
-
-APR_VERSION_MAJOR="`echo \"$APR_VERSION\" | sed 's,\..*,,'`"
-APR_VERSION_NUM="`echo \"$APR_VERSION\" | \
-                sed -e 's/[^0-9\.].*$//' \
-                    -e 's/\.\([0-9]\)$/.0\1/' \
-                    -e 's/\.\([0-9][0-9]\)$/.0\1/' \
-                    -e 's/\.\([0-9]\)\./0\1/; s/\.//g;'`"
-
-if test "$APR_VERSION_NUM" -ge "200000"; then
-
-  APU_BINDIR=""
-  APU_INCLUDES=""
-  APU_VERSION=""
-  APU_CONFIG=""
-
-else
-
-
-
-
-
-  echo $ac_n "${nl}Configuring Apache Portable Runtime Utility library...${nl}"
-
-
-
-  apu_found="no"
-
-  if test "$target_os" = "os2-emx"; then
-    # Scripts don't pass test -x on OS/2
-    TEST_X="test -f"
-  else
-    TEST_X="test -x"
-  fi
-
-  acceptable_majors="$APR_VERSION_MAJOR"
-
-  apu_temp_acceptable_apu_config=""
-  for apu_temp_major in $acceptable_majors
-  do
-    case $apu_temp_major in
-      0)
-      apu_temp_acceptable_apu_config="$apu_temp_acceptable_apu_config apu-config"
-      ;;
-      *)
-      apu_temp_acceptable_apu_config="$apu_temp_acceptable_apu_config apu-$apu_temp_major-config"
-      ;;
-    esac
-  done
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: checking for APR-util" >&5
-$as_echo_n "checking for APR-util... " >&6; }
-
-# Check whether --with-apr-util was given.
-if test "${with_apr_util+set}" = set; then :
-  withval=$with_apr_util;
-    if test "$withval" = "no" || test "$withval" = "yes"; then
-      as_fn_error "--with-apr-util requires a directory or file to be provided" "$LINENO" 5
-    fi
-
-    for apu_temp_apu_config_file in $apu_temp_acceptable_apu_config
-    do
-      for lookdir in "$withval/bin" "$withval"
-      do
-        if $TEST_X "$lookdir/$apu_temp_apu_config_file"; then
-          apu_config="$lookdir/$apu_temp_apu_config_file"
-
-          apu_found="yes"
-          break 2
-        fi
-      done
-    done
-
-    if test "$apu_found" != "yes" && $TEST_X "$withval" && $withval --help > /dev/null 2>&1 ; then
-      apu_config="$withval"
-      apu_found="yes"
-    fi
-
-            if test "$apu_found" != "yes"; then
-      as_fn_error "the --with-apr-util parameter is incorrect. It must specify an install prefix, a build directory, or an apu-config file." "$LINENO" 5
-    fi
-
-else
-
-    if test -n "1" && test "1" = "1"; then
-      for apu_temp_apu_config_file in $apu_temp_acceptable_apu_config
-      do
-        if $apu_temp_apu_config_file --help > /dev/null 2>&1 ; then
-          apu_config="$apu_temp_apu_config_file"
-
-          apu_found="yes"
-          break
-        else
-                    for lookdir in /usr /usr/local /usr/local/apr /opt/apr; do
-            if $TEST_X "$lookdir/bin/$apu_temp_apu_config_file"; then
-              apu_config="$lookdir/bin/$apu_temp_apu_config_file"
-
-              apu_found="yes"
-              break 2
-            fi
-          done
-        fi
-      done
-    fi
-        if test "$apu_found" = "no" && test -d ""$srcdir/apr-util""; then
-      apu_temp_abs_srcdir="`cd "$srcdir/apr-util" && pwd`"
-      apu_found="reconfig"
-      apu_bundled_major="`sed -n '/#define.*APU_MAJOR_VERSION/s/^[^0-9]*\([0-9]*\).*$/\1/p' \""$srcdir/apr-util"/include/apu_version.h\"`"
-      case $apu_bundled_major in
-        "")
-          as_fn_error "failed to find major version of bundled APU" "$LINENO" 5
-        ;;
-        0)
-          apu_temp_apu_config_file="apu-config"
-        ;;
-        *)
-          apu_temp_apu_config_file="apu-$apu_bundled_major-config"
-        ;;
-      esac
-      if test -n ""./apr-util""; then
-        apu_config=""./apr-util"/$apu_temp_apu_config_file"
-      else
-        apu_config=""$srcdir/apr-util"/$apu_temp_apu_config_file"
-      fi
-    fi
-
-fi
-
-
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $apu_found" >&5
-$as_echo "$apu_found" >&6; }
-
-
-
-  if test "$apu_found" = "no"; then
-    as_fn_error "APR-util not found.  Please read the documentation." "$LINENO" 5
-  fi
-
-  # Catch some misconfigurations:
-  case ${apr_found}.${apu_found} in
-    reconfig.yes)
-      as_fn_error "Cannot use an external APR-util with the bundled APR" "$LINENO" 5
-      ;;
-    yes.reconfig)
-      as_fn_error "Cannot use an external APR with the bundled APR-util" "$LINENO" 5
-      ;;
-  esac
-
-  if test "$apu_found" = "reconfig"; then
-
-  # save our work to this point; this allows the sub-package to use it
-  cat >confcache <<\_ACEOF
-# This file is a shell script that caches the results of configure
-# tests run on this system so they can be shared between configure
-# scripts and configure runs, see configure's option --config-cache.
-# It is not useful on other systems.  If it contains results you don't
-# want to keep, you may remove or edit it.
-#
-# config.status only pays attention to the cache file if you give it
-# the --recheck option to rerun configure.
-#
-# `ac_cv_env_foo' variables (set or unset) will be overridden when
-# loading this file, other *unset* `ac_cv_foo' will be assigned the
-# following values.
-
-_ACEOF
-
-# The following way of writing the cache mishandles newlines in values,
-# but we know of no workaround that is simple, portable, and efficient.
-# So, we kill variables containing newlines.
-# Ultrix sh set writes to stderr and can't be redirected directly,
-# and sets the high bit in the cache file unless we assign to the vars.
-(
-  for ac_var in `(set) 2>&1 | sed -n 's/^\([a-zA-Z_][a-zA-Z0-9_]*\)=.*/\1/p'`; do
-    eval ac_val=\$$ac_var
-    case $ac_val in #(
-    *${as_nl}*)
-      case $ac_var in #(
-      *_cv_*) { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: cache variable $ac_var contains a newline" >&5
-$as_echo "$as_me: WARNING: cache variable $ac_var contains a newline" >&2;} ;;
-      esac
-      case $ac_var in #(
-      _ | IFS | as_nl) ;; #(
-      BASH_ARGV | BASH_SOURCE) eval $ac_var= ;; #(
-      *) { eval $ac_var=; unset $ac_var;} ;;
-      esac ;;
-    esac
-  done
-
-  (set) 2>&1 |
-    case $as_nl`(ac_space=' '; set) 2>&1` in #(
-    *${as_nl}ac_space=\ *)
-      # `set' does not quote correctly, so add quotes: double-quote
-      # substitution turns \\\\ into \\, and sed turns \\ into \.
-      sed -n \
-	"s/'/'\\\\''/g;
-	  s/^\\([_$as_cr_alnum]*_cv_[_$as_cr_alnum]*\\)=\\(.*\\)/\\1='\\2'/p"
-      ;; #(
-    *)
-      # `set' quotes correctly as required by POSIX, so do not add quotes.
-      sed -n "/^[_$as_cr_alnum]*_cv_[_$as_cr_alnum]*=/p"
-      ;;
-    esac |
-    sort
-) |
-  sed '
-     /^ac_cv_env_/b end
-     t clear
-     :clear
-     s/^\([^=]*\)=\(.*[{}].*\)$/test "${\1+set}" = set || &/
-     t end
-     s/^\([^=]*\)=\(.*\)$/\1=${\1=\2}/
-     :end' >>confcache
-if diff "$cache_file" confcache >/dev/null 2>&1; then :; else
-  if test -w "$cache_file"; then
-    test "x$cache_file" != "x/dev/null" &&
-      { $as_echo "$as_me:${as_lineno-$LINENO}: updating cache $cache_file" >&5
-$as_echo "$as_me: updating cache $cache_file" >&6;}
-    cat confcache >$cache_file
-  else
-    { $as_echo "$as_me:${as_lineno-$LINENO}: not updating unwritable cache $cache_file" >&5
-$as_echo "$as_me: not updating unwritable cache $cache_file" >&6;}
-  fi
-fi
-rm -f confcache
-
-  echo "configuring package in apr-util now"
-  ac_popdir=`pwd`
-  apr_config_subdirs="apr-util"
-  test -d apr-util || $mkdir_p apr-util
-  ac_abs_srcdir=`(cd $srcdir/apr-util && pwd)`
-  cd apr-util
-
-      # A "../" for each directory in /$config_subdirs.
-      ac_dots=`echo $apr_config_subdirs|sed -e 's%^\./%%' -e 's%[^/]$%&/%' -e 's%[^/]*/%../%g'`
-
-  # Make the cache file pathname absolute for the subdirs
-  # required to correctly handle subdirs that might actually
-  # be symlinks
-  case "$cache_file" in
-  /*) # already absolute
-    ac_sub_cache_file=$cache_file ;;
-  *)  # Was relative path.
-    ac_sub_cache_file="$ac_popdir/$cache_file" ;;
-  esac
-
-
-  apr_configure_args=
-  apr_sep=
-  for apr_configure_arg in $ac_configure_args
-  do
-    case "$apr_configure_arg" in
-      --enable-layout=*|\'--enable-layout=*)
-        continue ;;
-    esac
-    apr_configure_args="$apr_configure_args$apr_sep'$apr_configure_arg'"
-    apr_sep=" "
-  done
-
-
-    test "x$silent" = "xyes" && apr_configure_args="$apr_configure_args --silent"
-
-    apr_configure_args="--disable-option-checking $apr_configure_args"
-
-              if eval $SHELL $ac_abs_srcdir/configure $apr_configure_args --cache-file=$ac_sub_cache_file --srcdir=$ac_abs_srcdir --with-apr=../apr --prefix=$prefix --exec-prefix=$exec_prefix --libdir=$libdir --includedir=$includedir --bindir=$bindir
-  then :
-    echo "apr-util configured properly"
-  else
-    echo "configure failed for apr-util"
-    exit 1
-  fi
-
-  cd $ac_popdir
-
-  # grab any updates from the sub-package
-  if test -r "$cache_file"; then
-  # Some versions of bash will fail to source /dev/null (special files
-  # actually), so we avoid doing that.  DJGPP emulates it as a regular file.
-  if test /dev/null != "$cache_file" && test -f "$cache_file"; then
-    { $as_echo "$as_me:${as_lineno-$LINENO}: loading cache $cache_file" >&5
-$as_echo "$as_me: loading cache $cache_file" >&6;}
-    case $cache_file in
-      [\\/]* | ?:[\\/]* ) . "$cache_file";;
-      *)                      . "./$cache_file";;
-    esac
-  fi
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: creating cache $cache_file" >&5
-$as_echo "$as_me: creating cache $cache_file" >&6;}
-  >$cache_file
-fi
-
-
-        SERF_BUILD_SRCLIB_DIRS="$SERF_BUILD_SRCLIB_DIRS apr-util"
-    SERF_CLEAN_SRCLIB_DIRS="apr-util $SERF_CLEAN_SRCLIB_DIRS"
-  fi
-
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \"`$apu_config --ldflags`\""
-    LDFLAGS="`$apu_config --ldflags`"
-  else
-    apr_addto_bugger="`$apu_config --ldflags`"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-  APU_BINDIR=`$apu_config --bindir`
-  APU_INCLUDES=`$apu_config --includes`
-  APU_VERSION=`$apu_config --version`
-  APU_CONFIG="$APU_BINDIR/apu-`echo ${APU_VERSION} | sed 's,\..*,,'`-config"
-fi
-
-
-
-
-
-
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-if test -n "$ac_tool_prefix"; then
-  # Extract the first word of "${ac_tool_prefix}gcc", so it can be a program name with args.
-set dummy ${ac_tool_prefix}gcc; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$CC"; then
-  ac_cv_prog_CC="$CC" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_CC="${ac_tool_prefix}gcc"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-CC=$ac_cv_prog_CC
-if test -n "$CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $CC" >&5
-$as_echo "$CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-fi
-if test -z "$ac_cv_prog_CC"; then
-  ac_ct_CC=$CC
-  # Extract the first word of "gcc", so it can be a program name with args.
-set dummy gcc; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_ac_ct_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$ac_ct_CC"; then
-  ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_ac_ct_CC="gcc"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-ac_ct_CC=$ac_cv_prog_ac_ct_CC
-if test -n "$ac_ct_CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_ct_CC" >&5
-$as_echo "$ac_ct_CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-  if test "x$ac_ct_CC" = x; then
-    CC=""
-  else
-    case $cross_compiling:$ac_tool_warned in
-yes:)
-{ $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: using cross tools not prefixed with host triplet" >&5
-$as_echo "$as_me: WARNING: using cross tools not prefixed with host triplet" >&2;}
-ac_tool_warned=yes ;;
-esac
-    CC=$ac_ct_CC
-  fi
-else
-  CC="$ac_cv_prog_CC"
-fi
-
-if test -z "$CC"; then
-          if test -n "$ac_tool_prefix"; then
-    # Extract the first word of "${ac_tool_prefix}cc", so it can be a program name with args.
-set dummy ${ac_tool_prefix}cc; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$CC"; then
-  ac_cv_prog_CC="$CC" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_CC="${ac_tool_prefix}cc"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-CC=$ac_cv_prog_CC
-if test -n "$CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $CC" >&5
-$as_echo "$CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-  fi
-fi
-if test -z "$CC"; then
-  # Extract the first word of "cc", so it can be a program name with args.
-set dummy cc; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$CC"; then
-  ac_cv_prog_CC="$CC" # Let the user override the test.
-else
-  ac_prog_rejected=no
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    if test "$as_dir/$ac_word$ac_exec_ext" = "/usr/ucb/cc"; then
-       ac_prog_rejected=yes
-       continue
-     fi
-    ac_cv_prog_CC="cc"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-if test $ac_prog_rejected = yes; then
-  # We found a bogon in the path, so make sure we never use it.
-  set dummy $ac_cv_prog_CC
-  shift
-  if test $# != 0; then
-    # We chose a different compiler from the bogus one.
-    # However, it has the same basename, so the bogon will be chosen
-    # first if we set CC to just the basename; use the full file name.
-    shift
-    ac_cv_prog_CC="$as_dir/$ac_word${1+' '}$@"
-  fi
-fi
-fi
-fi
-CC=$ac_cv_prog_CC
-if test -n "$CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $CC" >&5
-$as_echo "$CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-fi
-if test -z "$CC"; then
-  if test -n "$ac_tool_prefix"; then
-  for ac_prog in cl.exe
-  do
-    # Extract the first word of "$ac_tool_prefix$ac_prog", so it can be a program name with args.
-set dummy $ac_tool_prefix$ac_prog; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$CC"; then
-  ac_cv_prog_CC="$CC" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_CC="$ac_tool_prefix$ac_prog"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-CC=$ac_cv_prog_CC
-if test -n "$CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $CC" >&5
-$as_echo "$CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-    test -n "$CC" && break
-  done
-fi
-if test -z "$CC"; then
-  ac_ct_CC=$CC
-  for ac_prog in cl.exe
-do
-  # Extract the first word of "$ac_prog", so it can be a program name with args.
-set dummy $ac_prog; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_ac_ct_CC+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$ac_ct_CC"; then
-  ac_cv_prog_ac_ct_CC="$ac_ct_CC" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_ac_ct_CC="$ac_prog"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-ac_ct_CC=$ac_cv_prog_ac_ct_CC
-if test -n "$ac_ct_CC"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_ct_CC" >&5
-$as_echo "$ac_ct_CC" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-  test -n "$ac_ct_CC" && break
-done
-
-  if test "x$ac_ct_CC" = x; then
-    CC=""
-  else
-    case $cross_compiling:$ac_tool_warned in
-yes:)
-{ $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: using cross tools not prefixed with host triplet" >&5
-$as_echo "$as_me: WARNING: using cross tools not prefixed with host triplet" >&2;}
-ac_tool_warned=yes ;;
-esac
-    CC=$ac_ct_CC
-  fi
-fi
-
-fi
-
-
-test -z "$CC" && { { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error "no acceptable C compiler found in \$PATH
-See \`config.log' for more details." "$LINENO" 5; }
-
-# Provide some information about the compiler.
-$as_echo "$as_me:${as_lineno-$LINENO}: checking for C compiler version" >&5
-set X $ac_compile
-ac_compiler=$2
-for ac_option in --version -v -V -qversion; do
-  { { ac_try="$ac_compiler $ac_option >&5"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_compiler $ac_option >&5") 2>conftest.err
-  ac_status=$?
-  if test -s conftest.err; then
-    sed '10a\
-... rest of stderr output deleted ...
-         10q' conftest.err >conftest.er1
-    cat conftest.er1 >&5
-  fi
-  rm -f conftest.er1 conftest.err
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }
-done
-
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-ac_clean_files_save=$ac_clean_files
-ac_clean_files="$ac_clean_files a.out a.out.dSYM a.exe b.out"
-# Try to create an executable without -o first, disregard a.out.
-# It will help us diagnose broken compilers, and finding out an intuition
-# of exeext.
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether the C compiler works" >&5
-$as_echo_n "checking whether the C compiler works... " >&6; }
-ac_link_default=`$as_echo "$ac_link" | sed 's/ -o *conftest[^ ]*//'`
-
-# The possible output files:
-ac_files="a.out conftest.exe conftest a.exe a_out.exe b.out conftest.*"
-
-ac_rmfiles=
-for ac_file in $ac_files
-do
-  case $ac_file in
-    *.$ac_ext | *.xcoff | *.tds | *.d | *.pdb | *.xSYM | *.bb | *.bbg | *.map | *.inf | *.dSYM | *.o | *.obj ) ;;
-    * ) ac_rmfiles="$ac_rmfiles $ac_file";;
-  esac
-done
-rm -f $ac_rmfiles
-
-if { { ac_try="$ac_link_default"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_link_default") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then :
-  # Autoconf-2.13 could set the ac_cv_exeext variable to `no'.
-# So ignore a value of `no', otherwise this would lead to `EXEEXT = no'
-# in a Makefile.  We should not override ac_cv_exeext if it was cached,
-# so that the user can short-circuit this test for compilers unknown to
-# Autoconf.
-for ac_file in $ac_files ''
-do
-  test -f "$ac_file" || continue
-  case $ac_file in
-    *.$ac_ext | *.xcoff | *.tds | *.d | *.pdb | *.xSYM | *.bb | *.bbg | *.map | *.inf | *.dSYM | *.o | *.obj )
-	;;
-    [ab].out )
-	# We found the default executable, but exeext='' is most
-	# certainly right.
-	break;;
-    *.* )
-	if test "${ac_cv_exeext+set}" = set && test "$ac_cv_exeext" != no;
-	then :; else
-	   ac_cv_exeext=`expr "$ac_file" : '[^.]*\(\..*\)'`
-	fi
-	# We set ac_cv_exeext here because the later test for it is not
-	# safe: cross compilers may not add the suffix if given an `-o'
-	# argument, so we may need to know it at that point already.
-	# Even if this section looks crufty: it has the advantage of
-	# actually working.
-	break;;
-    * )
-	break;;
-  esac
-done
-test "$ac_cv_exeext" = no && ac_cv_exeext=
-
-else
-  ac_file=''
-fi
-if test -z "$ac_file"; then :
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-$as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-{ { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-{ as_fn_set_status 77
-as_fn_error "C compiler cannot create executables
-See \`config.log' for more details." "$LINENO" 5; }; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: yes" >&5
-$as_echo "yes" >&6; }
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for C compiler default output file name" >&5
-$as_echo_n "checking for C compiler default output file name... " >&6; }
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_file" >&5
-$as_echo "$ac_file" >&6; }
-ac_exeext=$ac_cv_exeext
-
-rm -f -r a.out a.out.dSYM a.exe conftest$ac_cv_exeext b.out
-ac_clean_files=$ac_clean_files_save
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for suffix of executables" >&5
-$as_echo_n "checking for suffix of executables... " >&6; }
-if { { ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_link") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then :
-  # If both `conftest.exe' and `conftest' are `present' (well, observable)
-# catch `conftest.exe'.  For instance with Cygwin, `ls conftest' will
-# work properly (i.e., refer to `conftest.exe'), while it won't with
-# `rm'.
-for ac_file in conftest.exe conftest conftest.*; do
-  test -f "$ac_file" || continue
-  case $ac_file in
-    *.$ac_ext | *.xcoff | *.tds | *.d | *.pdb | *.xSYM | *.bb | *.bbg | *.map | *.inf | *.dSYM | *.o | *.obj ) ;;
-    *.* ) ac_cv_exeext=`expr "$ac_file" : '[^.]*\(\..*\)'`
-	  break;;
-    * ) break;;
-  esac
-done
-else
-  { { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error "cannot compute suffix of executables: cannot compile and link
-See \`config.log' for more details." "$LINENO" 5; }
-fi
-rm -f conftest conftest$ac_cv_exeext
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_exeext" >&5
-$as_echo "$ac_cv_exeext" >&6; }
-
-rm -f conftest.$ac_ext
-EXEEXT=$ac_cv_exeext
-ac_exeext=$EXEEXT
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <stdio.h>
-int
-main ()
-{
-FILE *f = fopen ("conftest.out", "w");
- return ferror (f) || fclose (f) != 0;
-
-  ;
-  return 0;
-}
-_ACEOF
-ac_clean_files="$ac_clean_files conftest.out"
-# Check that the compiler produces executables we can run.  If not, either
-# the compiler is broken, or we cross compile.
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether we are cross compiling" >&5
-$as_echo_n "checking whether we are cross compiling... " >&6; }
-if test "$cross_compiling" != yes; then
-  { { ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_link") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }
-  if { ac_try='./conftest$ac_cv_exeext'
-  { { case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_try") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; }; then
-    cross_compiling=no
-  else
-    if test "$cross_compiling" = maybe; then
-	cross_compiling=yes
-    else
-	{ { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error "cannot run C compiled programs.
-If you meant to cross compile, use \`--host'.
-See \`config.log' for more details." "$LINENO" 5; }
-    fi
-  fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $cross_compiling" >&5
-$as_echo "$cross_compiling" >&6; }
-
-rm -f conftest.$ac_ext conftest$ac_cv_exeext conftest.out
-ac_clean_files=$ac_clean_files_save
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for suffix of object files" >&5
-$as_echo_n "checking for suffix of object files... " >&6; }
-if test "${ac_cv_objext+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-rm -f conftest.o conftest.obj
-if { { ac_try="$ac_compile"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:${as_lineno-$LINENO}: $ac_try_echo\""
-$as_echo "$ac_try_echo"; } >&5
-  (eval "$ac_compile") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:${as_lineno-$LINENO}: \$? = $ac_status" >&5
-  test $ac_status = 0; }; then :
-  for ac_file in conftest.o conftest.obj conftest.*; do
-  test -f "$ac_file" || continue;
-  case $ac_file in
-    *.$ac_ext | *.xcoff | *.tds | *.d | *.pdb | *.xSYM | *.bb | *.bbg | *.map | *.inf | *.dSYM ) ;;
-    *) ac_cv_objext=`expr "$ac_file" : '.*\.\(.*\)'`
-       break;;
-  esac
-done
-else
-  $as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-{ { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error "cannot compute suffix of object files: cannot compile
-See \`config.log' for more details." "$LINENO" 5; }
-fi
-rm -f conftest.$ac_cv_objext conftest.$ac_ext
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_objext" >&5
-$as_echo "$ac_cv_objext" >&6; }
-OBJEXT=$ac_cv_objext
-ac_objext=$OBJEXT
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether we are using the GNU C compiler" >&5
-$as_echo_n "checking whether we are using the GNU C compiler... " >&6; }
-if test "${ac_cv_c_compiler_gnu+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-#ifndef __GNUC__
-       choke me
-#endif
-
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  ac_compiler_gnu=yes
-else
-  ac_compiler_gnu=no
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-ac_cv_c_compiler_gnu=$ac_compiler_gnu
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_c_compiler_gnu" >&5
-$as_echo "$ac_cv_c_compiler_gnu" >&6; }
-if test $ac_compiler_gnu = yes; then
-  GCC=yes
-else
-  GCC=
-fi
-ac_test_CFLAGS=${CFLAGS+set}
-ac_save_CFLAGS=$CFLAGS
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking whether $CC accepts -g" >&5
-$as_echo_n "checking whether $CC accepts -g... " >&6; }
-if test "${ac_cv_prog_cc_g+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_save_c_werror_flag=$ac_c_werror_flag
-   ac_c_werror_flag=yes
-   ac_cv_prog_cc_g=no
-   CFLAGS="-g"
-   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  ac_cv_prog_cc_g=yes
-else
-  CFLAGS=""
-      cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-
-else
-  ac_c_werror_flag=$ac_save_c_werror_flag
-	 CFLAGS="-g"
-	 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  ac_cv_prog_cc_g=yes
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-   ac_c_werror_flag=$ac_save_c_werror_flag
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_g" >&5
-$as_echo "$ac_cv_prog_cc_g" >&6; }
-if test "$ac_test_CFLAGS" = set; then
-  CFLAGS=$ac_save_CFLAGS
-elif test $ac_cv_prog_cc_g = yes; then
-  if test "$GCC" = yes; then
-    CFLAGS="-g -O2"
-  else
-    CFLAGS="-g"
-  fi
-else
-  if test "$GCC" = yes; then
-    CFLAGS="-O2"
-  else
-    CFLAGS=
-  fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $CC option to accept ISO C89" >&5
-$as_echo_n "checking for $CC option to accept ISO C89... " >&6; }
-if test "${ac_cv_prog_cc_c89+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_cv_prog_cc_c89=no
-ac_save_CC=$CC
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <stdarg.h>
-#include <stdio.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-/* Most of the following tests are stolen from RCS 5.7's src/conf.sh.  */
-struct buf { int x; };
-FILE * (*rcsopen) (struct buf *, struct stat *, int);
-static char *e (p, i)
-     char **p;
-     int i;
-{
-  return p[i];
-}
-static char *f (char * (*g) (char **, int), char **p, ...)
-{
-  char *s;
-  va_list v;
-  va_start (v,p);
-  s = g (p, va_arg (v,int));
-  va_end (v);
-  return s;
-}
-
-/* OSF 4.0 Compaq cc is some sort of almost-ANSI by default.  It has
-   function prototypes and stuff, but not '\xHH' hex character constants.
-   These don't provoke an error unfortunately, instead are silently treated
-   as 'x'.  The following induces an error, until -std is added to get
-   proper ANSI mode.  Curiously '\x00'!='x' always comes out true, for an
-   array size at least.  It's necessary to write '\x00'==0 to get something
-   that's true only with -std.  */
-int osf4_cc_array ['\x00' == 0 ? 1 : -1];
-
-/* IBM C 6 for AIX is almost-ANSI by default, but it replaces macro parameters
-   inside strings and character constants.  */
-#define FOO(x) 'x'
-int xlc6_cc_array[FOO(a) == 'x' ? 1 : -1];
-
-int test (int i, double x);
-struct s1 {int (*f) (int a);};
-struct s2 {int (*f) (double a);};
-int pairnames (int, char **, FILE *(*)(struct buf *, struct stat *, int), int, int);
-int argc;
-char **argv;
-int
-main ()
-{
-return f (e, argv, 0) != argv[0]  ||  f (e, argv, 1) != argv[1];
-  ;
-  return 0;
-}
-_ACEOF
-for ac_arg in '' -qlanglvl=extc89 -qlanglvl=ansi -std \
-	-Ae "-Aa -D_HPUX_SOURCE" "-Xc -D__EXTENSIONS__"
-do
-  CC="$ac_save_CC $ac_arg"
-  if ac_fn_c_try_compile "$LINENO"; then :
-  ac_cv_prog_cc_c89=$ac_arg
-fi
-rm -f core conftest.err conftest.$ac_objext
-  test "x$ac_cv_prog_cc_c89" != "xno" && break
-done
-rm -f conftest.$ac_ext
-CC=$ac_save_CC
-
-fi
-# AC_CACHE_VAL
-case "x$ac_cv_prog_cc_c89" in
-  x)
-    { $as_echo "$as_me:${as_lineno-$LINENO}: result: none needed" >&5
-$as_echo "none needed" >&6; } ;;
-  xno)
-    { $as_echo "$as_me:${as_lineno-$LINENO}: result: unsupported" >&5
-$as_echo "unsupported" >&6; } ;;
-  *)
-    CC="$CC $ac_cv_prog_cc_c89"
-    { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_prog_cc_c89" >&5
-$as_echo "$ac_cv_prog_cc_c89" >&6; } ;;
-esac
-if test "x$ac_cv_prog_cc_c89" != xno; then :
-
-fi
-
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking how to run the C preprocessor" >&5
-$as_echo_n "checking how to run the C preprocessor... " >&6; }
-# On Suns, sometimes $CPP names a directory.
-if test -n "$CPP" && test -d "$CPP"; then
-  CPP=
-fi
-if test -z "$CPP"; then
-  if test "${ac_cv_prog_CPP+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-      # Double quotes because CPP needs to be expanded
-    for CPP in "$CC -E" "$CC -E -traditional-cpp" "/lib/cpp"
-    do
-      ac_preproc_ok=false
-for ac_c_preproc_warn_flag in '' yes
-do
-  # Use a header file that comes with gcc, so configuring glibc
-  # with a fresh cross-compiler works.
-  # Prefer <limits.h> to <assert.h> if __STDC__ is defined, since
-  # <limits.h> exists even on freestanding compilers.
-  # On the NeXT, cc -E runs the code through the compiler's parser,
-  # not just through cpp. "Syntax error" is here to catch this case.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#ifdef __STDC__
-# include <limits.h>
-#else
-# include <assert.h>
-#endif
-		     Syntax error
-_ACEOF
-if ac_fn_c_try_cpp "$LINENO"; then :
-
-else
-  # Broken: fails on valid input.
-continue
-fi
-rm -f conftest.err conftest.$ac_ext
-
-  # OK, works on sane cases.  Now check whether nonexistent headers
-  # can be detected and how.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <ac_nonexistent.h>
-_ACEOF
-if ac_fn_c_try_cpp "$LINENO"; then :
-  # Broken: success on invalid input.
-continue
-else
-  # Passes both tests.
-ac_preproc_ok=:
-break
-fi
-rm -f conftest.err conftest.$ac_ext
-
-done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
-rm -f conftest.err conftest.$ac_ext
-if $ac_preproc_ok; then :
-  break
-fi
-
-    done
-    ac_cv_prog_CPP=$CPP
-
-fi
-  CPP=$ac_cv_prog_CPP
-else
-  ac_cv_prog_CPP=$CPP
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $CPP" >&5
-$as_echo "$CPP" >&6; }
-ac_preproc_ok=false
-for ac_c_preproc_warn_flag in '' yes
-do
-  # Use a header file that comes with gcc, so configuring glibc
-  # with a fresh cross-compiler works.
-  # Prefer <limits.h> to <assert.h> if __STDC__ is defined, since
-  # <limits.h> exists even on freestanding compilers.
-  # On the NeXT, cc -E runs the code through the compiler's parser,
-  # not just through cpp. "Syntax error" is here to catch this case.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#ifdef __STDC__
-# include <limits.h>
-#else
-# include <assert.h>
-#endif
-		     Syntax error
-_ACEOF
-if ac_fn_c_try_cpp "$LINENO"; then :
-
-else
-  # Broken: fails on valid input.
-continue
-fi
-rm -f conftest.err conftest.$ac_ext
-
-  # OK, works on sane cases.  Now check whether nonexistent headers
-  # can be detected and how.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <ac_nonexistent.h>
-_ACEOF
-if ac_fn_c_try_cpp "$LINENO"; then :
-  # Broken: success on invalid input.
-continue
-else
-  # Passes both tests.
-ac_preproc_ok=:
-break
-fi
-rm -f conftest.err conftest.$ac_ext
-
-done
-# Because of `break', _AC_PREPROC_IFELSE's cleaning code was skipped.
-rm -f conftest.err conftest.$ac_ext
-if $ac_preproc_ok; then :
-
-else
-  { { $as_echo "$as_me:${as_lineno-$LINENO}: error: in \`$ac_pwd':" >&5
-$as_echo "$as_me: error: in \`$ac_pwd':" >&2;}
-as_fn_error "C preprocessor \"$CPP\" fails sanity check
-See \`config.log' for more details." "$LINENO" 5; }
-fi
-
-ac_ext=c
-ac_cpp='$CPP $CPPFLAGS'
-ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_c_compiler_gnu
-
-# Find a good install program.  We prefer a C program (faster),
-# so one script is as good as another.  But avoid the broken or
-# incompatible versions:
-# SysV /etc/install, /usr/sbin/install
-# SunOS /usr/etc/install
-# IRIX /sbin/install
-# AIX /bin/install
-# AmigaOS /C/install, which installs bootblocks on floppy discs
-# AIX 4 /usr/bin/installbsd, which doesn't work without a -g flag
-# AFS /usr/afsws/bin/install, which mishandles nonexistent args
-# SVR4 /usr/ucb/install, which tries to use the nonexistent group "staff"
-# OS/2's system install, which has a completely different semantic
-# ./install, which can be erroneously created by make from ./install.sh.
-# Reject install programs that cannot install multiple files.
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for a BSD-compatible install" >&5
-$as_echo_n "checking for a BSD-compatible install... " >&6; }
-if test -z "$INSTALL"; then
-if test "${ac_cv_path_install+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    # Account for people who put trailing slashes in PATH elements.
-case $as_dir/ in #((
-  ./ | .// | /[cC]/* | \
-  /etc/* | /usr/sbin/* | /usr/etc/* | /sbin/* | /usr/afsws/bin/* | \
-  ?:[\\/]os2[\\/]install[\\/]* | ?:[\\/]OS2[\\/]INSTALL[\\/]* | \
-  /usr/ucb/* ) ;;
-  *)
-    # OSF1 and SCO ODT 3.0 have their own names for install.
-    # Don't use installbsd from OSF since it installs stuff as root
-    # by default.
-    for ac_prog in ginstall scoinst install; do
-      for ac_exec_ext in '' $ac_executable_extensions; do
-	if { test -f "$as_dir/$ac_prog$ac_exec_ext" && $as_test_x "$as_dir/$ac_prog$ac_exec_ext"; }; then
-	  if test $ac_prog = install &&
-	    grep dspmsg "$as_dir/$ac_prog$ac_exec_ext" >/dev/null 2>&1; then
-	    # AIX install.  It has an incompatible calling convention.
-	    :
-	  elif test $ac_prog = install &&
-	    grep pwplus "$as_dir/$ac_prog$ac_exec_ext" >/dev/null 2>&1; then
-	    # program-specific install script used by HP pwplus--don't use.
-	    :
-	  else
-	    rm -rf conftest.one conftest.two conftest.dir
-	    echo one > conftest.one
-	    echo two > conftest.two
-	    mkdir conftest.dir
-	    if "$as_dir/$ac_prog$ac_exec_ext" -c conftest.one conftest.two "`pwd`/conftest.dir" &&
-	      test -s conftest.one && test -s conftest.two &&
-	      test -s conftest.dir/conftest.one &&
-	      test -s conftest.dir/conftest.two
-	    then
-	      ac_cv_path_install="$as_dir/$ac_prog$ac_exec_ext -c"
-	      break 3
-	    fi
-	  fi
-	fi
-      done
-    done
-    ;;
-esac
-
-  done
-IFS=$as_save_IFS
-
-rm -rf conftest.one conftest.two conftest.dir
-
-fi
-  if test "${ac_cv_path_install+set}" = set; then
-    INSTALL=$ac_cv_path_install
-  else
-    # As a last resort, use the slow shell script.  Don't cache a
-    # value for INSTALL within a source directory, because that will
-    # break other packages using the cache if that directory is
-    # removed, or if the value is a relative name.
-    INSTALL=$ac_install_sh
-  fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $INSTALL" >&5
-$as_echo "$INSTALL" >&6; }
-
-# Use test -z because SunOS4 sh mishandles braces in ${var-val}.
-# It thinks the first close brace ends the variable substitution.
-test -z "$INSTALL_PROGRAM" && INSTALL_PROGRAM='${INSTALL}'
-
-test -z "$INSTALL_SCRIPT" && INSTALL_SCRIPT='${INSTALL}'
-
-test -z "$INSTALL_DATA" && INSTALL_DATA='${INSTALL} -m 644'
-
-
-if test "x${cache_file}" = "x/dev/null"; then
-  # Likewise, ensure that CC and CPP are passed through to the pcre
-  # configure script iff caching is disabled (the autoconf 2.5x default).
-  export CC; export CPP
-fi
-
-echo $ac_n "Configuring Serf...${nl}"
-
-abs_srcdir=`(cd $srcdir && pwd)`
-abs_builddir=`pwd`
-
-get_version="$abs_srcdir/build/get-version.sh"
-version_hdr="$abs_srcdir/serf.h"
-SERF_MAJOR_VERSION="`$get_version major $version_hdr SERF`"
-SERF_DOTTED_VERSION="`$get_version all $version_hdr SERF`"
-
-
-
-
-
-
-
-
-# Check whether --with-openssl was given.
-if test "${with_openssl+set}" = set; then :
-  withval=$with_openssl;
-  if test "$withval" = "yes"; then
-    as_fn_error "--with-openssl requires a path" "$LINENO" 5
-  else
-    openssl_prefix=$withval
-
-    if test "x$openssl_prefix" != "x" -a ! -d "$openssl_prefix"; then
-      as_fn_error "'--with-openssl requires a path to a directory'" "$LINENO" 5
-    fi
-
-
-  if test "x$CPPFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting CPPFLAGS to \""-I${openssl_prefix}/include"\""
-    CPPFLAGS=""-I${openssl_prefix}/include""
-  else
-    apr_addto_bugger=""-I${openssl_prefix}/include""
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $CPPFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to CPPFLAGS"
-        CPPFLAGS="$CPPFLAGS $i"
-      fi
-    done
-  fi
-
-    if test -e "${openssl_prefix}/Makefile"; then
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \""-L${openssl_prefix}"\""
-    LDFLAGS=""-L${openssl_prefix}""
-  else
-    apr_addto_bugger=""-L${openssl_prefix}""
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \""-R${openssl_prefix}"\""
-    LDFLAGS=""-R${openssl_prefix}""
-  else
-    apr_addto_bugger=""-R${openssl_prefix}""
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-    else
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \""-L${openssl_prefix}/lib"\""
-    LDFLAGS=""-L${openssl_prefix}/lib""
-  else
-    apr_addto_bugger=""-L${openssl_prefix}/lib""
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-
-  if test "x$LDFLAGS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting LDFLAGS to \""-R${openssl_prefix}/lib"\""
-    LDFLAGS=""-R${openssl_prefix}/lib""
-  else
-    apr_addto_bugger=""-R${openssl_prefix}/lib""
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $LDFLAGS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to LDFLAGS"
-        LDFLAGS="$LDFLAGS $i"
-      fi
-    done
-  fi
-
-    fi
-  fi
-
-fi
-
-
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for grep that handles long lines and -e" >&5
-$as_echo_n "checking for grep that handles long lines and -e... " >&6; }
-if test "${ac_cv_path_GREP+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -z "$GREP"; then
-  ac_path_GREP_found=false
-  # Loop through the user's path and test for each of PROGNAME-LIST
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH$PATH_SEPARATOR/usr/xpg4/bin
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_prog in grep ggrep; do
-    for ac_exec_ext in '' $ac_executable_extensions; do
-      ac_path_GREP="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_GREP" && $as_test_x "$ac_path_GREP"; } || continue
-# Check for GNU ac_path_GREP and select it if it is found.
-  # Check for GNU $ac_path_GREP
-case `"$ac_path_GREP" --version 2>&1` in
-*GNU*)
-  ac_cv_path_GREP="$ac_path_GREP" ac_path_GREP_found=:;;
-*)
-  ac_count=0
-  $as_echo_n 0123456789 >"conftest.in"
-  while :
-  do
-    cat "conftest.in" "conftest.in" >"conftest.tmp"
-    mv "conftest.tmp" "conftest.in"
-    cp "conftest.in" "conftest.nl"
-    $as_echo 'GREP' >> "conftest.nl"
-    "$ac_path_GREP" -e 'GREP$' -e '-(cannot match)-' < "conftest.nl" >"conftest.out" 2>/dev/null || break
-    diff "conftest.out" "conftest.nl" >/dev/null 2>&1 || break
-    as_fn_arith $ac_count + 1 && ac_count=$as_val
-    if test $ac_count -gt ${ac_path_GREP_max-0}; then
-      # Best one so far, save it but keep looking for a better one
-      ac_cv_path_GREP="$ac_path_GREP"
-      ac_path_GREP_max=$ac_count
-    fi
-    # 10*(2^10) chars as input seems more than enough
-    test $ac_count -gt 10 && break
-  done
-  rm -f conftest.in conftest.tmp conftest.nl conftest.out;;
-esac
-
-      $ac_path_GREP_found && break 3
-    done
-  done
-  done
-IFS=$as_save_IFS
-  if test -z "$ac_cv_path_GREP"; then
-    as_fn_error "no acceptable grep could be found in $PATH$PATH_SEPARATOR/usr/xpg4/bin" "$LINENO" 5
-  fi
-else
-  ac_cv_path_GREP=$GREP
-fi
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_GREP" >&5
-$as_echo "$ac_cv_path_GREP" >&6; }
- GREP="$ac_cv_path_GREP"
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for egrep" >&5
-$as_echo_n "checking for egrep... " >&6; }
-if test "${ac_cv_path_EGREP+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if echo a | $GREP -E '(a|b)' >/dev/null 2>&1
-   then ac_cv_path_EGREP="$GREP -E"
-   else
-     if test -z "$EGREP"; then
-  ac_path_EGREP_found=false
-  # Loop through the user's path and test for each of PROGNAME-LIST
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH$PATH_SEPARATOR/usr/xpg4/bin
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_prog in egrep; do
-    for ac_exec_ext in '' $ac_executable_extensions; do
-      ac_path_EGREP="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_EGREP" && $as_test_x "$ac_path_EGREP"; } || continue
-# Check for GNU ac_path_EGREP and select it if it is found.
-  # Check for GNU $ac_path_EGREP
-case `"$ac_path_EGREP" --version 2>&1` in
-*GNU*)
-  ac_cv_path_EGREP="$ac_path_EGREP" ac_path_EGREP_found=:;;
-*)
-  ac_count=0
-  $as_echo_n 0123456789 >"conftest.in"
-  while :
-  do
-    cat "conftest.in" "conftest.in" >"conftest.tmp"
-    mv "conftest.tmp" "conftest.in"
-    cp "conftest.in" "conftest.nl"
-    $as_echo 'EGREP' >> "conftest.nl"
-    "$ac_path_EGREP" 'EGREP$' < "conftest.nl" >"conftest.out" 2>/dev/null || break
-    diff "conftest.out" "conftest.nl" >/dev/null 2>&1 || break
-    as_fn_arith $ac_count + 1 && ac_count=$as_val
-    if test $ac_count -gt ${ac_path_EGREP_max-0}; then
-      # Best one so far, save it but keep looking for a better one
-      ac_cv_path_EGREP="$ac_path_EGREP"
-      ac_path_EGREP_max=$ac_count
-    fi
-    # 10*(2^10) chars as input seems more than enough
-    test $ac_count -gt 10 && break
-  done
-  rm -f conftest.in conftest.tmp conftest.nl conftest.out;;
-esac
-
-      $ac_path_EGREP_found && break 3
-    done
-  done
-  done
-IFS=$as_save_IFS
-  if test -z "$ac_cv_path_EGREP"; then
-    as_fn_error "no acceptable egrep could be found in $PATH$PATH_SEPARATOR/usr/xpg4/bin" "$LINENO" 5
-  fi
-else
-  ac_cv_path_EGREP=$EGREP
-fi
-
-   fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_EGREP" >&5
-$as_echo "$ac_cv_path_EGREP" >&6; }
- EGREP="$ac_cv_path_EGREP"
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for ANSI C header files" >&5
-$as_echo_n "checking for ANSI C header files... " >&6; }
-if test "${ac_cv_header_stdc+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <stdlib.h>
-#include <stdarg.h>
-#include <string.h>
-#include <float.h>
-
-int
-main ()
-{
-
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_compile "$LINENO"; then :
-  ac_cv_header_stdc=yes
-else
-  ac_cv_header_stdc=no
-fi
-rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
-
-if test $ac_cv_header_stdc = yes; then
-  # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <string.h>
-
-_ACEOF
-if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
-  $EGREP "memchr" >/dev/null 2>&1; then :
-
-else
-  ac_cv_header_stdc=no
-fi
-rm -f conftest*
-
-fi
-
-if test $ac_cv_header_stdc = yes; then
-  # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <stdlib.h>
-
-_ACEOF
-if (eval "$ac_cpp conftest.$ac_ext") 2>&5 |
-  $EGREP "free" >/dev/null 2>&1; then :
-
-else
-  ac_cv_header_stdc=no
-fi
-rm -f conftest*
-
-fi
-
-if test $ac_cv_header_stdc = yes; then
-  # /bin/cc in Irix-4.0.5 gets non-ANSI ctype macros unless using -ansi.
-  if test "$cross_compiling" = yes; then :
-  :
-else
-  cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <ctype.h>
-#include <stdlib.h>
-#if ((' ' & 0x0FF) == 0x020)
-# define ISLOWER(c) ('a' <= (c) && (c) <= 'z')
-# define TOUPPER(c) (ISLOWER(c) ? 'A' + ((c) - 'a') : (c))
-#else
-# define ISLOWER(c) \
-		   (('a' <= (c) && (c) <= 'i') \
-		     || ('j' <= (c) && (c) <= 'r') \
-		     || ('s' <= (c) && (c) <= 'z'))
-# define TOUPPER(c) (ISLOWER(c) ? ((c) | 0x40) : (c))
-#endif
-
-#define XOR(e, f) (((e) && !(f)) || (!(e) && (f)))
-int
-main ()
-{
-  int i;
-  for (i = 0; i < 256; i++)
-    if (XOR (islower (i), ISLOWER (i))
-	|| toupper (i) != TOUPPER (i))
-      return 2;
-  return 0;
-}
-_ACEOF
-if ac_fn_c_try_run "$LINENO"; then :
-
-else
-  ac_cv_header_stdc=no
-fi
-rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext \
-  conftest.$ac_objext conftest.beam conftest.$ac_ext
-fi
-
-fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_header_stdc" >&5
-$as_echo "$ac_cv_header_stdc" >&6; }
-if test $ac_cv_header_stdc = yes; then
-
-$as_echo "#define STDC_HEADERS 1" >>confdefs.h
-
-fi
-
-# On IRIX 5.3, sys/types and inttypes.h are conflicting.
-for ac_header in sys/types.h sys/stat.h stdlib.h string.h memory.h strings.h \
-		  inttypes.h stdint.h unistd.h
-do :
-  as_ac_Header=`$as_echo "ac_cv_header_$ac_header" | $as_tr_sh`
-ac_fn_c_check_header_compile "$LINENO" "$ac_header" "$as_ac_Header" "$ac_includes_default
-"
-eval as_val=\$$as_ac_Header
-   if test "x$as_val" = x""yes; then :
-  cat >>confdefs.h <<_ACEOF
-#define `$as_echo "HAVE_$ac_header" | $as_tr_cpp` 1
-_ACEOF
-
-fi
-
-done
-
-
-ac_fn_c_check_header_mongrel "$LINENO" "openssl/opensslv.h" "ac_cv_header_openssl_opensslv_h" "$ac_includes_default"
-if test "x$ac_cv_header_openssl_opensslv_h" = x""yes; then :
-
-else
-  as_fn_error "We require OpenSSL; try --with-openssl" "$LINENO" 5
-fi
-
-
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for library containing fabs" >&5
-$as_echo_n "checking for library containing fabs... " >&6; }
-if test "${ac_cv_search_fabs+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  ac_func_search_save_LIBS=$LIBS
-cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char fabs ();
-int
-main ()
-{
-return fabs ();
-  ;
-  return 0;
-}
-_ACEOF
-for ac_lib in '' m; do
-  if test -z "$ac_lib"; then
-    ac_res="none required"
-  else
-    ac_res=-l$ac_lib
-    LIBS="-l$ac_lib  $ac_func_search_save_LIBS"
-  fi
-  if ac_fn_c_try_link "$LINENO"; then :
-  ac_cv_search_fabs=$ac_res
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext
-  if test "${ac_cv_search_fabs+set}" = set; then :
-  break
-fi
-done
-if test "${ac_cv_search_fabs+set}" = set; then :
-
-else
-  ac_cv_search_fabs=no
-fi
-rm conftest.$ac_ext
-LIBS=$ac_func_search_save_LIBS
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_search_fabs" >&5
-$as_echo "$ac_cv_search_fabs" >&6; }
-ac_res=$ac_cv_search_fabs
-if test "$ac_res" != no; then :
-  test "$ac_res" = "none required" || LIBS="$ac_res $LIBS"
-
-fi
-
-
-libs=""
-if test -n "$apu_config"; then
-
-  if test "x$libs" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting libs to \"`$apu_config --link-libtool --libs`\""
-    libs="`$apu_config --link-libtool --libs`"
-  else
-    apr_addto_bugger="`$apu_config --link-libtool --libs`"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $libs; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to libs"
-        libs="$libs $i"
-      fi
-    done
-  fi
-
-fi
-
-  if test "x$libs" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting libs to \"`$apr_config --link-libtool --libs` $LIBS\""
-    libs="`$apr_config --link-libtool --libs` $LIBS"
-  else
-    apr_addto_bugger="`$apr_config --link-libtool --libs` $LIBS"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $libs; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to libs"
-        libs="$libs $i"
-      fi
-    done
-  fi
-
-
-
-  if test "x$SERF_LIBS" = "x"; then
-    test "x$silent" != "xyes" && echo "  setting SERF_LIBS to \"$libs\""
-    SERF_LIBS="$libs"
-  else
-    apr_addto_bugger="$libs"
-    for i in $apr_addto_bugger; do
-      apr_addto_duplicate="0"
-      for j in $SERF_LIBS; do
-        if test "x$i" = "x$j"; then
-          apr_addto_duplicate="1"
-          break
-        fi
-      done
-      if test $apr_addto_duplicate = "0"; then
-        test "x$silent" != "xyes" && echo "  adding \"$i\" to SERF_LIBS"
-        SERF_LIBS="$SERF_LIBS $i"
-      fi
-    done
-  fi
-
-
-
-
-if test "x$apr_ste_save_CPPFLAGS" = "x"; then
-  EXTRA_CPPFLAGS="$CPPFLAGS"
-  CPPFLAGS=
-else
-  if test "x$apr_ste_save_CPPFLAGS" = "x$CPPFLAGS"; then
-    EXTRA_CPPFLAGS=
-  else
-    EXTRA_CPPFLAGS=`echo $CPPFLAGS | sed -e "s%${apr_ste_save_CPPFLAGS}%%"`
-    CPPFLAGS="$apr_ste_save_CPPFLAGS"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring CPPFLAGS to \"$CPPFLAGS\""
-  echo "  setting EXTRA_CPPFLAGS to \"$EXTRA_CPPFLAGS\""
-fi
-
-
-
-if test "x$apr_ste_save_CFLAGS" = "x"; then
-  EXTRA_CFLAGS="$CFLAGS"
-  CFLAGS=
-else
-  if test "x$apr_ste_save_CFLAGS" = "x$CFLAGS"; then
-    EXTRA_CFLAGS=
-  else
-    EXTRA_CFLAGS=`echo $CFLAGS | sed -e "s%${apr_ste_save_CFLAGS}%%"`
-    CFLAGS="$apr_ste_save_CFLAGS"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring CFLAGS to \"$CFLAGS\""
-  echo "  setting EXTRA_CFLAGS to \"$EXTRA_CFLAGS\""
-fi
-
-
-
-if test "x$apr_ste_save_CXXFLAGS" = "x"; then
-  EXTRA_CXXFLAGS="$CXXFLAGS"
-  CXXFLAGS=
-else
-  if test "x$apr_ste_save_CXXFLAGS" = "x$CXXFLAGS"; then
-    EXTRA_CXXFLAGS=
-  else
-    EXTRA_CXXFLAGS=`echo $CXXFLAGS | sed -e "s%${apr_ste_save_CXXFLAGS}%%"`
-    CXXFLAGS="$apr_ste_save_CXXFLAGS"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring CXXFLAGS to \"$CXXFLAGS\""
-  echo "  setting EXTRA_CXXFLAGS to \"$EXTRA_CXXFLAGS\""
-fi
-
-
-
-if test "x$apr_ste_save_LDFLAGS" = "x"; then
-  EXTRA_LDFLAGS="$LDFLAGS"
-  LDFLAGS=
-else
-  if test "x$apr_ste_save_LDFLAGS" = "x$LDFLAGS"; then
-    EXTRA_LDFLAGS=
-  else
-    EXTRA_LDFLAGS=`echo $LDFLAGS | sed -e "s%${apr_ste_save_LDFLAGS}%%"`
-    LDFLAGS="$apr_ste_save_LDFLAGS"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring LDFLAGS to \"$LDFLAGS\""
-  echo "  setting EXTRA_LDFLAGS to \"$EXTRA_LDFLAGS\""
-fi
-
-
-
-if test "x$apr_ste_save_LIBS" = "x"; then
-  EXTRA_LIBS="$LIBS"
-  LIBS=
-else
-  if test "x$apr_ste_save_LIBS" = "x$LIBS"; then
-    EXTRA_LIBS=
-  else
-    EXTRA_LIBS=`echo $LIBS | sed -e "s%${apr_ste_save_LIBS}%%"`
-    LIBS="$apr_ste_save_LIBS"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring LIBS to \"$LIBS\""
-  echo "  setting EXTRA_LIBS to \"$EXTRA_LIBS\""
-fi
-
-
-
-if test "x$apr_ste_save_INCLUDES" = "x"; then
-  EXTRA_INCLUDES="$INCLUDES"
-  INCLUDES=
-else
-  if test "x$apr_ste_save_INCLUDES" = "x$INCLUDES"; then
-    EXTRA_INCLUDES=
-  else
-    EXTRA_INCLUDES=`echo $INCLUDES | sed -e "s%${apr_ste_save_INCLUDES}%%"`
-    INCLUDES="$apr_ste_save_INCLUDES"
-  fi
-fi
-if test "x$silent" != "xyes"; then
-  echo "  restoring INCLUDES to \"$INCLUDES\""
-  echo "  setting EXTRA_INCLUDES to \"$EXTRA_INCLUDES\""
-fi
-
-
-
-ac_config_files="$ac_config_files Makefile"
-
-ac_config_commands="$ac_config_commands mkdir-vpath"
-
-
-cat >confcache <<\_ACEOF
-# This file is a shell script that caches the results of configure
-# tests run on this system so they can be shared between configure
-# scripts and configure runs, see configure's option --config-cache.
-# It is not useful on other systems.  If it contains results you don't
-# want to keep, you may remove or edit it.
-#
-# config.status only pays attention to the cache file if you give it
-# the --recheck option to rerun configure.
-#
-# `ac_cv_env_foo' variables (set or unset) will be overridden when
-# loading this file, other *unset* `ac_cv_foo' will be assigned the
-# following values.
-
-_ACEOF
-
-# The following way of writing the cache mishandles newlines in values,
-# but we know of no workaround that is simple, portable, and efficient.
-# So, we kill variables containing newlines.
-# Ultrix sh set writes to stderr and can't be redirected directly,
-# and sets the high bit in the cache file unless we assign to the vars.
-(
-  for ac_var in `(set) 2>&1 | sed -n 's/^\([a-zA-Z_][a-zA-Z0-9_]*\)=.*/\1/p'`; do
-    eval ac_val=\$$ac_var
-    case $ac_val in #(
-    *${as_nl}*)
-      case $ac_var in #(
-      *_cv_*) { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: cache variable $ac_var contains a newline" >&5
-$as_echo "$as_me: WARNING: cache variable $ac_var contains a newline" >&2;} ;;
-      esac
-      case $ac_var in #(
-      _ | IFS | as_nl) ;; #(
-      BASH_ARGV | BASH_SOURCE) eval $ac_var= ;; #(
-      *) { eval $ac_var=; unset $ac_var;} ;;
-      esac ;;
-    esac
-  done
-
-  (set) 2>&1 |
-    case $as_nl`(ac_space=' '; set) 2>&1` in #(
-    *${as_nl}ac_space=\ *)
-      # `set' does not quote correctly, so add quotes: double-quote
-      # substitution turns \\\\ into \\, and sed turns \\ into \.
-      sed -n \
-	"s/'/'\\\\''/g;
-	  s/^\\([_$as_cr_alnum]*_cv_[_$as_cr_alnum]*\\)=\\(.*\\)/\\1='\\2'/p"
-      ;; #(
-    *)
-      # `set' quotes correctly as required by POSIX, so do not add quotes.
-      sed -n "/^[_$as_cr_alnum]*_cv_[_$as_cr_alnum]*=/p"
-      ;;
-    esac |
-    sort
-) |
-  sed '
-     /^ac_cv_env_/b end
-     t clear
-     :clear
-     s/^\([^=]*\)=\(.*[{}].*\)$/test "${\1+set}" = set || &/
-     t end
-     s/^\([^=]*\)=\(.*\)$/\1=${\1=\2}/
-     :end' >>confcache
-if diff "$cache_file" confcache >/dev/null 2>&1; then :; else
-  if test -w "$cache_file"; then
-    test "x$cache_file" != "x/dev/null" &&
-      { $as_echo "$as_me:${as_lineno-$LINENO}: updating cache $cache_file" >&5
-$as_echo "$as_me: updating cache $cache_file" >&6;}
-    cat confcache >$cache_file
-  else
-    { $as_echo "$as_me:${as_lineno-$LINENO}: not updating unwritable cache $cache_file" >&5
-$as_echo "$as_me: not updating unwritable cache $cache_file" >&6;}
-  fi
-fi
-rm -f confcache
-
-test "x$prefix" = xNONE && prefix=$ac_default_prefix
-# Let make expand exec_prefix.
-test "x$exec_prefix" = xNONE && exec_prefix='${prefix}'
-
-# Transform confdefs.h into DEFS.
-# Protect against shell expansion while executing Makefile rules.
-# Protect against Makefile macro expansion.
-#
-# If the first sed substitution is executed (which looks for macros that
-# take arguments), then branch to the quote section.  Otherwise,
-# look for a macro that doesn't take arguments.
-ac_script='
-:mline
-/\\$/{
- N
- s,\\\n,,
- b mline
-}
-t clear
-:clear
-s/^[	 ]*#[	 ]*define[	 ][	 ]*\([^	 (][^	 (]*([^)]*)\)[	 ]*\(.*\)/-D\1=\2/g
-t quote
-s/^[	 ]*#[	 ]*define[	 ][	 ]*\([^	 ][^	 ]*\)[	 ]*\(.*\)/-D\1=\2/g
-t quote
-b any
-:quote
-s/[	 `~#$^&*(){}\\|;'\''"<>?]/\\&/g
-s/\[/\\&/g
-s/\]/\\&/g
-s/\$/$$/g
-H
-:any
-${
-	g
-	s/^\n//
-	s/\n/ /g
-	p
-}
-'
-DEFS=`sed -n "$ac_script" confdefs.h`
-
-
-ac_libobjs=
-ac_ltlibobjs=
-for ac_i in : $LIBOBJS; do test "x$ac_i" = x: && continue
-  # 1. Remove the extension, and $U if already installed.
-  ac_script='s/\$U\././;s/\.o$//;s/\.obj$//'
-  ac_i=`$as_echo "$ac_i" | sed "$ac_script"`
-  # 2. Prepend LIBOBJDIR.  When used with automake>=1.10 LIBOBJDIR
-  #    will be set to the directory where LIBOBJS objects are built.
-  as_fn_append ac_libobjs " \${LIBOBJDIR}$ac_i\$U.$ac_objext"
-  as_fn_append ac_ltlibobjs " \${LIBOBJDIR}$ac_i"'$U.lo'
-done
-LIBOBJS=$ac_libobjs
-
-LTLIBOBJS=$ac_ltlibobjs
-
-
-
-: ${CONFIG_STATUS=./config.status}
-ac_write_fail=0
-ac_clean_files_save=$ac_clean_files
-ac_clean_files="$ac_clean_files $CONFIG_STATUS"
-{ $as_echo "$as_me:${as_lineno-$LINENO}: creating $CONFIG_STATUS" >&5
-$as_echo "$as_me: creating $CONFIG_STATUS" >&6;}
-as_write_fail=0
-cat >$CONFIG_STATUS <<_ASEOF || as_write_fail=1
-#! $SHELL
-# Generated by $as_me.
-# Run this file to recreate the current configuration.
-# Compiler output produced by configure, useful for debugging
-# configure, is in config.log if it exists.
-
-debug=false
-ac_cs_recheck=false
-ac_cs_silent=false
-
-SHELL=\${CONFIG_SHELL-$SHELL}
-export SHELL
-_ASEOF
-cat >>$CONFIG_STATUS <<\_ASEOF || as_write_fail=1
-## -------------------- ##
-## M4sh Initialization. ##
-## -------------------- ##
-
-# Be more Bourne compatible
-DUALCASE=1; export DUALCASE # for MKS sh
-if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then :
-  emulate sh
-  NULLCMD=:
-  # Pre-4.2 versions of Zsh do word splitting on ${1+"$@"}, which
-  # is contrary to our usage.  Disable this feature.
-  alias -g '${1+"$@"}'='"$@"'
-  setopt NO_GLOB_SUBST
-else
-  case `(set -o) 2>/dev/null` in #(
-  *posix*) :
-    set -o posix ;; #(
-  *) :
-     ;;
-esac
-fi
-
-
-as_nl='
-'
-export as_nl
-# Printing a long string crashes Solaris 7 /usr/bin/printf.
-as_echo='\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\'
-as_echo=$as_echo$as_echo$as_echo$as_echo$as_echo
-as_echo=$as_echo$as_echo$as_echo$as_echo$as_echo$as_echo
-# Prefer a ksh shell builtin over an external printf program on Solaris,
-# but without wasting forks for bash or zsh.
-if test -z "$BASH_VERSION$ZSH_VERSION" \
-    && (test "X`print -r -- $as_echo`" = "X$as_echo") 2>/dev/null; then
-  as_echo='print -r --'
-  as_echo_n='print -rn --'
-elif (test "X`printf %s $as_echo`" = "X$as_echo") 2>/dev/null; then
-  as_echo='printf %s\n'
-  as_echo_n='printf %s'
-else
-  if test "X`(/usr/ucb/echo -n -n $as_echo) 2>/dev/null`" = "X-n $as_echo"; then
-    as_echo_body='eval /usr/ucb/echo -n "$1$as_nl"'
-    as_echo_n='/usr/ucb/echo -n'
-  else
-    as_echo_body='eval expr "X$1" : "X\\(.*\\)"'
-    as_echo_n_body='eval
-      arg=$1;
-      case $arg in #(
-      *"$as_nl"*)
-	expr "X$arg" : "X\\(.*\\)$as_nl";
-	arg=`expr "X$arg" : ".*$as_nl\\(.*\\)"`;;
-      esac;
-      expr "X$arg" : "X\\(.*\\)" | tr -d "$as_nl"
-    '
-    export as_echo_n_body
-    as_echo_n='sh -c $as_echo_n_body as_echo'
-  fi
-  export as_echo_body
-  as_echo='sh -c $as_echo_body as_echo'
-fi
-
-# The user is always right.
-if test "${PATH_SEPARATOR+set}" != set; then
-  PATH_SEPARATOR=:
-  (PATH='/bin;/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 && {
-    (PATH='/bin:/bin'; FPATH=$PATH; sh -c :) >/dev/null 2>&1 ||
-      PATH_SEPARATOR=';'
-  }
-fi
-
-
-# IFS
-# We need space, tab and new line, in precisely that order.  Quoting is
-# there to prevent editors from complaining about space-tab.
-# (If _AS_PATH_WALK were called with IFS unset, it would disable word
-# splitting by setting IFS to empty value.)
-IFS=" ""	$as_nl"
-
-# Find who we are.  Look in the path if we contain no directory separator.
-case $0 in #((
-  *[\\/]* ) as_myself=$0 ;;
-  *) as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    test -r "$as_dir/$0" && as_myself=$as_dir/$0 && break
-  done
-IFS=$as_save_IFS
-
-     ;;
-esac
-# We did not find ourselves, most probably we were run as `sh COMMAND'
-# in which case we are not to be found in the path.
-if test "x$as_myself" = x; then
-  as_myself=$0
-fi
-if test ! -f "$as_myself"; then
-  $as_echo "$as_myself: error: cannot find myself; rerun with an absolute file name" >&2
-  exit 1
-fi
-
-# Unset variables that we do not need and which cause bugs (e.g. in
-# pre-3.0 UWIN ksh).  But do not cause bugs in bash 2.01; the "|| exit 1"
-# suppresses any "Segmentation fault" message there.  '((' could
-# trigger a bug in pdksh 5.2.14.
-for as_var in BASH_ENV ENV MAIL MAILPATH
-do eval test x\${$as_var+set} = xset \
-  && ( (unset $as_var) || exit 1) >/dev/null 2>&1 && unset $as_var || :
-done
-PS1='$ '
-PS2='> '
-PS4='+ '
-
-# NLS nuisances.
-LC_ALL=C
-export LC_ALL
-LANGUAGE=C
-export LANGUAGE
-
-# CDPATH.
-(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
-
-
-# as_fn_error ERROR [LINENO LOG_FD]
-# ---------------------------------
-# Output "`basename $0`: error: ERROR" to stderr. If LINENO and LOG_FD are
-# provided, also output the error to LOG_FD, referencing LINENO. Then exit the
-# script with status $?, using 1 if that was 0.
-as_fn_error ()
-{
-  as_status=$?; test $as_status -eq 0 && as_status=1
-  if test "$3"; then
-    as_lineno=${as_lineno-"$2"} as_lineno_stack=as_lineno_stack=$as_lineno_stack
-    $as_echo "$as_me:${as_lineno-$LINENO}: error: $1" >&$3
-  fi
-  $as_echo "$as_me: error: $1" >&2
-  as_fn_exit $as_status
-} # as_fn_error
-
-
-# as_fn_set_status STATUS
-# -----------------------
-# Set $? to STATUS, without forking.
-as_fn_set_status ()
-{
-  return $1
-} # as_fn_set_status
-
-# as_fn_exit STATUS
-# -----------------
-# Exit the shell with STATUS, even in a "trap 0" or "set -e" context.
-as_fn_exit ()
-{
-  set +e
-  as_fn_set_status $1
-  exit $1
-} # as_fn_exit
-
-# as_fn_unset VAR
-# ---------------
-# Portably unset VAR.
-as_fn_unset ()
-{
-  { eval $1=; unset $1;}
-}
-as_unset=as_fn_unset
-# as_fn_append VAR VALUE
-# ----------------------
-# Append the text in VALUE to the end of the definition contained in VAR. Take
-# advantage of any shell optimizations that allow amortized linear growth over
-# repeated appends, instead of the typical quadratic growth present in naive
-# implementations.
-if (eval "as_var=1; as_var+=2; test x\$as_var = x12") 2>/dev/null; then :
-  eval 'as_fn_append ()
-  {
-    eval $1+=\$2
-  }'
-else
-  as_fn_append ()
-  {
-    eval $1=\$$1\$2
-  }
-fi # as_fn_append
-
-# as_fn_arith ARG...
-# ------------------
-# Perform arithmetic evaluation on the ARGs, and store the result in the
-# global $as_val. Take advantage of shells that can avoid forks. The arguments
-# must be portable across $(()) and expr.
-if (eval "test \$(( 1 + 1 )) = 2") 2>/dev/null; then :
-  eval 'as_fn_arith ()
-  {
-    as_val=$(( $* ))
-  }'
-else
-  as_fn_arith ()
-  {
-    as_val=`expr "$@" || test $? -eq 1`
-  }
-fi # as_fn_arith
-
-
-if expr a : '\(a\)' >/dev/null 2>&1 &&
-   test "X`expr 00001 : '.*\(...\)'`" = X001; then
-  as_expr=expr
-else
-  as_expr=false
-fi
-
-if (basename -- /) >/dev/null 2>&1 && test "X`basename -- / 2>&1`" = "X/"; then
-  as_basename=basename
-else
-  as_basename=false
-fi
-
-if (as_dir=`dirname -- /` && test "X$as_dir" = X/) >/dev/null 2>&1; then
-  as_dirname=dirname
-else
-  as_dirname=false
-fi
-
-as_me=`$as_basename -- "$0" ||
-$as_expr X/"$0" : '.*/\([^/][^/]*\)/*$' \| \
-	 X"$0" : 'X\(//\)$' \| \
-	 X"$0" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X/"$0" |
-    sed '/^.*\/\([^/][^/]*\)\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\/\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\/\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-
-# Avoid depending upon Character Ranges.
-as_cr_letters='abcdefghijklmnopqrstuvwxyz'
-as_cr_LETTERS='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
-as_cr_Letters=$as_cr_letters$as_cr_LETTERS
-as_cr_digits='0123456789'
-as_cr_alnum=$as_cr_Letters$as_cr_digits
-
-ECHO_C= ECHO_N= ECHO_T=
-case `echo -n x` in #(((((
--n*)
-  case `echo 'xy\c'` in
-  *c*) ECHO_T='	';;	# ECHO_T is single tab character.
-  xy)  ECHO_C='\c';;
-  *)   echo `echo ksh88 bug on AIX 6.1` > /dev/null
-       ECHO_T='	';;
-  esac;;
-*)
-  ECHO_N='-n';;
-esac
-
-rm -f conf$$ conf$$.exe conf$$.file
-if test -d conf$$.dir; then
-  rm -f conf$$.dir/conf$$.file
-else
-  rm -f conf$$.dir
-  mkdir conf$$.dir 2>/dev/null
-fi
-if (echo >conf$$.file) 2>/dev/null; then
-  if ln -s conf$$.file conf$$ 2>/dev/null; then
-    as_ln_s='ln -s'
-    # ... but there are two gotchas:
-    # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
-    # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -p'.
-    ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
-      as_ln_s='cp -p'
-  elif ln conf$$.file conf$$ 2>/dev/null; then
-    as_ln_s=ln
-  else
-    as_ln_s='cp -p'
-  fi
-else
-  as_ln_s='cp -p'
-fi
-rm -f conf$$ conf$$.exe conf$$.dir/conf$$.file conf$$.file
-rmdir conf$$.dir 2>/dev/null
-
-
-# as_fn_mkdir_p
-# -------------
-# Create "$as_dir" as a directory, including parents if necessary.
-as_fn_mkdir_p ()
-{
-
-  case $as_dir in #(
-  -*) as_dir=./$as_dir;;
-  esac
-  test -d "$as_dir" || eval $as_mkdir_p || {
-    as_dirs=
-    while :; do
-      case $as_dir in #(
-      *\'*) as_qdir=`$as_echo "$as_dir" | sed "s/'/'\\\\\\\\''/g"`;; #'(
-      *) as_qdir=$as_dir;;
-      esac
-      as_dirs="'$as_qdir' $as_dirs"
-      as_dir=`$as_dirname -- "$as_dir" ||
-$as_expr X"$as_dir" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
-	 X"$as_dir" : 'X\(//\)[^/]' \| \
-	 X"$as_dir" : 'X\(//\)$' \| \
-	 X"$as_dir" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X"$as_dir" |
-    sed '/^X\(.*[^/]\)\/\/*[^/][^/]*\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)[^/].*/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-      test -d "$as_dir" && break
-    done
-    test -z "$as_dirs" || eval "mkdir $as_dirs"
-  } || test -d "$as_dir" || as_fn_error "cannot create directory $as_dir"
-
-
-} # as_fn_mkdir_p
-if mkdir -p . 2>/dev/null; then
-  as_mkdir_p='mkdir -p "$as_dir"'
-else
-  test -d ./-p && rmdir ./-p
-  as_mkdir_p=false
-fi
-
-if test -x / >/dev/null 2>&1; then
-  as_test_x='test -x'
-else
-  if ls -dL / >/dev/null 2>&1; then
-    as_ls_L_option=L
-  else
-    as_ls_L_option=
-  fi
-  as_test_x='
-    eval sh -c '\''
-      if test -d "$1"; then
-	test -d "$1/.";
-      else
-	case $1 in #(
-	-*)set "./$1";;
-	esac;
-	case `ls -ld'$as_ls_L_option' "$1" 2>/dev/null` in #((
-	???[sx]*):;;*)false;;esac;fi
-    '\'' sh
-  '
-fi
-as_executable_p=$as_test_x
-
-# Sed expression to map a string onto a valid CPP name.
-as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
-
-# Sed expression to map a string onto a valid variable name.
-as_tr_sh="eval sed 'y%*+%pp%;s%[^_$as_cr_alnum]%_%g'"
-
-
-exec 6>&1
-## ----------------------------------- ##
-## Main body of $CONFIG_STATUS script. ##
-## ----------------------------------- ##
-_ASEOF
-test $as_write_fail = 0 && chmod +x $CONFIG_STATUS || ac_write_fail=1
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-# Save the log message, to keep $0 and so on meaningful, and to
-# report actual input values of CONFIG_FILES etc. instead of their
-# values after options handling.
-ac_log="
-This file was extended by $as_me, which was
-generated by GNU Autoconf 2.65.  Invocation command line was
-
-  CONFIG_FILES    = $CONFIG_FILES
-  CONFIG_HEADERS  = $CONFIG_HEADERS
-  CONFIG_LINKS    = $CONFIG_LINKS
-  CONFIG_COMMANDS = $CONFIG_COMMANDS
-  $ $0 $@
-
-on `(hostname || uname -n) 2>/dev/null | sed 1q`
-"
-
-_ACEOF
-
-case $ac_config_files in *"
-"*) set x $ac_config_files; shift; ac_config_files=$*;;
-esac
-
-
-
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-# Files that config.status was made for.
-config_files="$ac_config_files"
-config_commands="$ac_config_commands"
-
-_ACEOF
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-ac_cs_usage="\
-\`$as_me' instantiates files and other configuration actions
-from templates according to the current configuration.  Unless the files
-and actions are specified as TAGs, all are instantiated by default.
-
-Usage: $0 [OPTION]... [TAG]...
-
-  -h, --help       print this help, then exit
-  -V, --version    print version number and configuration settings, then exit
-      --config     print configuration, then exit
-  -q, --quiet, --silent
-                   do not print progress messages
-  -d, --debug      don't remove temporary files
-      --recheck    update $as_me by reconfiguring in the same conditions
-      --file=FILE[:TEMPLATE]
-                   instantiate the configuration file FILE
-
-Configuration files:
-$config_files
-
-Configuration commands:
-$config_commands
-
-Report bugs to the package provider."
-
-_ACEOF
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
-ac_cs_version="\\
-config.status
-configured by $0, generated by GNU Autoconf 2.65,
-  with options \\"\$ac_cs_config\\"
-
-Copyright (C) 2009 Free Software Foundation, Inc.
-This config.status script is free software; the Free Software Foundation
-gives unlimited permission to copy, distribute and modify it."
-
-ac_pwd='$ac_pwd'
-srcdir='$srcdir'
-INSTALL='$INSTALL'
-test -n "\$AWK" || AWK=awk
-_ACEOF
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-# The default lists apply if the user does not specify any file.
-ac_need_defaults=:
-while test $# != 0
-do
-  case $1 in
-  --*=*)
-    ac_option=`expr "X$1" : 'X\([^=]*\)='`
-    ac_optarg=`expr "X$1" : 'X[^=]*=\(.*\)'`
-    ac_shift=:
-    ;;
-  *)
-    ac_option=$1
-    ac_optarg=$2
-    ac_shift=shift
-    ;;
-  esac
-
-  case $ac_option in
-  # Handling of the options.
-  -recheck | --recheck | --rechec | --reche | --rech | --rec | --re | --r)
-    ac_cs_recheck=: ;;
-  --version | --versio | --versi | --vers | --ver | --ve | --v | -V )
-    $as_echo "$ac_cs_version"; exit ;;
-  --config | --confi | --conf | --con | --co | --c )
-    $as_echo "$ac_cs_config"; exit ;;
-  --debug | --debu | --deb | --de | --d | -d )
-    debug=: ;;
-  --file | --fil | --fi | --f )
-    $ac_shift
-    case $ac_optarg in
-    *\'*) ac_optarg=`$as_echo "$ac_optarg" | sed "s/'/'\\\\\\\\''/g"` ;;
-    esac
-    as_fn_append CONFIG_FILES " '$ac_optarg'"
-    ac_need_defaults=false;;
-  --he | --h |  --help | --hel | -h )
-    $as_echo "$ac_cs_usage"; exit ;;
-  -q | -quiet | --quiet | --quie | --qui | --qu | --q \
-  | -silent | --silent | --silen | --sile | --sil | --si | --s)
-    ac_cs_silent=: ;;
-
-  # This is an error.
-  -*) as_fn_error "unrecognized option: \`$1'
-Try \`$0 --help' for more information." ;;
-
-  *) as_fn_append ac_config_targets " $1"
-     ac_need_defaults=false ;;
-
-  esac
-  shift
-done
-
-ac_configure_extra_args=
-
-if $ac_cs_silent; then
-  exec 6>/dev/null
-  ac_configure_extra_args="$ac_configure_extra_args --silent"
-fi
-
-_ACEOF
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-if \$ac_cs_recheck; then
-  set X '$SHELL' '$0' $ac_configure_args \$ac_configure_extra_args --no-create --no-recursion
-  shift
-  \$as_echo "running CONFIG_SHELL=$SHELL \$*" >&6
-  CONFIG_SHELL='$SHELL'
-  export CONFIG_SHELL
-  exec "\$@"
-fi
-
-_ACEOF
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-exec 5>>config.log
-{
-  echo
-  sed 'h;s/./-/g;s/^.../## /;s/...$/ ##/;p;x;p;x' <<_ASBOX
-## Running $as_me. ##
-_ASBOX
-  $as_echo "$ac_log"
-} >&5
-
-_ACEOF
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-_ACEOF
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-
-# Handling of arguments.
-for ac_config_target in $ac_config_targets
-do
-  case $ac_config_target in
-    "Makefile") CONFIG_FILES="$CONFIG_FILES Makefile" ;;
-    "mkdir-vpath") CONFIG_COMMANDS="$CONFIG_COMMANDS mkdir-vpath" ;;
-
-  *) as_fn_error "invalid argument: \`$ac_config_target'" "$LINENO" 5;;
-  esac
-done
-
-
-# If the user did not use the arguments to specify the items to instantiate,
-# then the envvar interface is used.  Set only those that are not.
-# We use the long form for the default assignment because of an extremely
-# bizarre bug on SunOS 4.1.3.
-if $ac_need_defaults; then
-  test "${CONFIG_FILES+set}" = set || CONFIG_FILES=$config_files
-  test "${CONFIG_COMMANDS+set}" = set || CONFIG_COMMANDS=$config_commands
-fi
-
-# Have a temporary directory for convenience.  Make it in the build tree
-# simply because there is no reason against having it here, and in addition,
-# creating and moving files from /tmp can sometimes cause problems.
-# Hook for its removal unless debugging.
-# Note that there is a small window in which the directory will not be cleaned:
-# after its creation but before its name has been assigned to `$tmp'.
-$debug ||
-{
-  tmp=
-  trap 'exit_status=$?
-  { test -z "$tmp" || test ! -d "$tmp" || rm -fr "$tmp"; } && exit $exit_status
-' 0
-  trap 'as_fn_exit 1' 1 2 13 15
-}
-# Create a (secure) tmp directory for tmp files.
-
-{
-  tmp=`(umask 077 && mktemp -d "./confXXXXXX") 2>/dev/null` &&
-  test -n "$tmp" && test -d "$tmp"
-}  ||
-{
-  tmp=./conf$$-$RANDOM
-  (umask 077 && mkdir "$tmp")
-} || as_fn_error "cannot create a temporary directory in ." "$LINENO" 5
-
-# Set up the scripts for CONFIG_FILES section.
-# No need to generate them if there are no CONFIG_FILES.
-# This happens for instance with `./config.status config.h'.
-if test -n "$CONFIG_FILES"; then
-
-
-ac_cr=`echo X | tr X '\015'`
-# On cygwin, bash can eat \r inside `` if the user requested igncr.
-# But we know of no other shell where ac_cr would be empty at this
-# point, so we can use a bashism as a fallback.
-if test "x$ac_cr" = x; then
-  eval ac_cr=\$\'\\r\'
-fi
-ac_cs_awk_cr=`$AWK 'BEGIN { print "a\rb" }' </dev/null 2>/dev/null`
-if test "$ac_cs_awk_cr" = "a${ac_cr}b"; then
-  ac_cs_awk_cr='\r'
-else
-  ac_cs_awk_cr=$ac_cr
-fi
-
-echo 'BEGIN {' >"$tmp/subs1.awk" &&
-_ACEOF
-
-
-{
-  echo "cat >conf$$subs.awk <<_ACEOF" &&
-  echo "$ac_subst_vars" | sed 's/.*/&!$&$ac_delim/' &&
-  echo "_ACEOF"
-} >conf$$subs.sh ||
-  as_fn_error "could not make $CONFIG_STATUS" "$LINENO" 5
-ac_delim_num=`echo "$ac_subst_vars" | grep -c '$'`
-ac_delim='%!_!# '
-for ac_last_try in false false false false false :; do
-  . ./conf$$subs.sh ||
-    as_fn_error "could not make $CONFIG_STATUS" "$LINENO" 5
-
-  ac_delim_n=`sed -n "s/.*$ac_delim\$/X/p" conf$$subs.awk | grep -c X`
-  if test $ac_delim_n = $ac_delim_num; then
-    break
-  elif $ac_last_try; then
-    as_fn_error "could not make $CONFIG_STATUS" "$LINENO" 5
-  else
-    ac_delim="$ac_delim!$ac_delim _$ac_delim!! "
-  fi
-done
-rm -f conf$$subs.sh
-
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-cat >>"\$tmp/subs1.awk" <<\\_ACAWK &&
-_ACEOF
-sed -n '
-h
-s/^/S["/; s/!.*/"]=/
-p
-g
-s/^[^!]*!//
-:repl
-t repl
-s/'"$ac_delim"'$//
-t delim
-:nl
-h
-s/\(.\{148\}\)..*/\1/
-t more1
-s/["\\]/\\&/g; s/^/"/; s/$/\\n"\\/
-p
-n
-b repl
-:more1
-s/["\\]/\\&/g; s/^/"/; s/$/"\\/
-p
-g
-s/.\{148\}//
-t nl
-:delim
-h
-s/\(.\{148\}\)..*/\1/
-t more2
-s/["\\]/\\&/g; s/^/"/; s/$/"/
-p
-b
-:more2
-s/["\\]/\\&/g; s/^/"/; s/$/"\\/
-p
-g
-s/.\{148\}//
-t delim
-' <conf$$subs.awk | sed '
-/^[^""]/{
-  N
-  s/\n//
-}
-' >>$CONFIG_STATUS || ac_write_fail=1
-rm -f conf$$subs.awk
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-_ACAWK
-cat >>"\$tmp/subs1.awk" <<_ACAWK &&
-  for (key in S) S_is_set[key] = 1
-  FS = ""
-
-}
-{
-  line = $ 0
-  nfields = split(line, field, "@")
-  substed = 0
-  len = length(field[1])
-  for (i = 2; i < nfields; i++) {
-    key = field[i]
-    keylen = length(key)
-    if (S_is_set[key]) {
-      value = S[key]
-      line = substr(line, 1, len) "" value "" substr(line, len + keylen + 3)
-      len += length(value) + length(field[++i])
-      substed = 1
-    } else
-      len += 1 + keylen
-  }
-
-  print line
-}
-
-_ACAWK
-_ACEOF
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-if sed "s/$ac_cr//" < /dev/null > /dev/null 2>&1; then
-  sed "s/$ac_cr\$//; s/$ac_cr/$ac_cs_awk_cr/g"
-else
-  cat
-fi < "$tmp/subs1.awk" > "$tmp/subs.awk" \
-  || as_fn_error "could not setup config files machinery" "$LINENO" 5
-_ACEOF
-
-# VPATH may cause trouble with some makes, so we remove $(srcdir),
-# ${srcdir} and @srcdir@ from VPATH if srcdir is ".", strip leading and
-# trailing colons and then remove the whole line if VPATH becomes empty
-# (actually we leave an empty line to preserve line numbers).
-if test "x$srcdir" = x.; then
-  ac_vpsub='/^[	 ]*VPATH[	 ]*=/{
-s/:*\$(srcdir):*/:/
-s/:*\${srcdir}:*/:/
-s/:*@srcdir@:*/:/
-s/^\([^=]*=[	 ]*\):*/\1/
-s/:*$//
-s/^[^=]*=[	 ]*$//
-}'
-fi
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-fi # test -n "$CONFIG_FILES"
-
-
-eval set X "  :F $CONFIG_FILES      :C $CONFIG_COMMANDS"
-shift
-for ac_tag
-do
-  case $ac_tag in
-  :[FHLC]) ac_mode=$ac_tag; continue;;
-  esac
-  case $ac_mode$ac_tag in
-  :[FHL]*:*);;
-  :L* | :C*:*) as_fn_error "invalid tag \`$ac_tag'" "$LINENO" 5;;
-  :[FH]-) ac_tag=-:-;;
-  :[FH]*) ac_tag=$ac_tag:$ac_tag.in;;
-  esac
-  ac_save_IFS=$IFS
-  IFS=:
-  set x $ac_tag
-  IFS=$ac_save_IFS
-  shift
-  ac_file=$1
-  shift
-
-  case $ac_mode in
-  :L) ac_source=$1;;
-  :[FH])
-    ac_file_inputs=
-    for ac_f
-    do
-      case $ac_f in
-      -) ac_f="$tmp/stdin";;
-      *) # Look for the file first in the build tree, then in the source tree
-	 # (if the path is not absolute).  The absolute path cannot be DOS-style,
-	 # because $ac_f cannot contain `:'.
-	 test -f "$ac_f" ||
-	   case $ac_f in
-	   [\\/$]*) false;;
-	   *) test -f "$srcdir/$ac_f" && ac_f="$srcdir/$ac_f";;
-	   esac ||
-	   as_fn_error "cannot find input file: \`$ac_f'" "$LINENO" 5;;
-      esac
-      case $ac_f in *\'*) ac_f=`$as_echo "$ac_f" | sed "s/'/'\\\\\\\\''/g"`;; esac
-      as_fn_append ac_file_inputs " '$ac_f'"
-    done
-
-    # Let's still pretend it is `configure' which instantiates (i.e., don't
-    # use $as_me), people would be surprised to read:
-    #    /* config.h.  Generated by config.status.  */
-    configure_input='Generated from '`
-	  $as_echo "$*" | sed 's|^[^:]*/||;s|:[^:]*/|, |g'
-	`' by configure.'
-    if test x"$ac_file" != x-; then
-      configure_input="$ac_file.  $configure_input"
-      { $as_echo "$as_me:${as_lineno-$LINENO}: creating $ac_file" >&5
-$as_echo "$as_me: creating $ac_file" >&6;}
-    fi
-    # Neutralize special characters interpreted by sed in replacement strings.
-    case $configure_input in #(
-    *\&* | *\|* | *\\* )
-       ac_sed_conf_input=`$as_echo "$configure_input" |
-       sed 's/[\\\\&|]/\\\\&/g'`;; #(
-    *) ac_sed_conf_input=$configure_input;;
-    esac
-
-    case $ac_tag in
-    *:-:* | *:-) cat >"$tmp/stdin" \
-      || as_fn_error "could not create $ac_file" "$LINENO" 5 ;;
-    esac
-    ;;
-  esac
-
-  ac_dir=`$as_dirname -- "$ac_file" ||
-$as_expr X"$ac_file" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
-	 X"$ac_file" : 'X\(//\)[^/]' \| \
-	 X"$ac_file" : 'X\(//\)$' \| \
-	 X"$ac_file" : 'X\(/\)' \| . 2>/dev/null ||
-$as_echo X"$ac_file" |
-    sed '/^X\(.*[^/]\)\/\/*[^/][^/]*\/*$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)[^/].*/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\/\)$/{
-	    s//\1/
-	    q
-	  }
-	  /^X\(\/\).*/{
-	    s//\1/
-	    q
-	  }
-	  s/.*/./; q'`
-  as_dir="$ac_dir"; as_fn_mkdir_p
-  ac_builddir=.
-
-case "$ac_dir" in
-.) ac_dir_suffix= ac_top_builddir_sub=. ac_top_build_prefix= ;;
-*)
-  ac_dir_suffix=/`$as_echo "$ac_dir" | sed 's|^\.[\\/]||'`
-  # A ".." for each directory in $ac_dir_suffix.
-  ac_top_builddir_sub=`$as_echo "$ac_dir_suffix" | sed 's|/[^\\/]*|/..|g;s|/||'`
-  case $ac_top_builddir_sub in
-  "") ac_top_builddir_sub=. ac_top_build_prefix= ;;
-  *)  ac_top_build_prefix=$ac_top_builddir_sub/ ;;
-  esac ;;
-esac
-ac_abs_top_builddir=$ac_pwd
-ac_abs_builddir=$ac_pwd$ac_dir_suffix
-# for backward compatibility:
-ac_top_builddir=$ac_top_build_prefix
-
-case $srcdir in
-  .)  # We are building in place.
-    ac_srcdir=.
-    ac_top_srcdir=$ac_top_builddir_sub
-    ac_abs_top_srcdir=$ac_pwd ;;
-  [\\/]* | ?:[\\/]* )  # Absolute name.
-    ac_srcdir=$srcdir$ac_dir_suffix;
-    ac_top_srcdir=$srcdir
-    ac_abs_top_srcdir=$srcdir ;;
-  *) # Relative name.
-    ac_srcdir=$ac_top_build_prefix$srcdir$ac_dir_suffix
-    ac_top_srcdir=$ac_top_build_prefix$srcdir
-    ac_abs_top_srcdir=$ac_pwd/$srcdir ;;
-esac
-ac_abs_srcdir=$ac_abs_top_srcdir$ac_dir_suffix
-
-
-  case $ac_mode in
-  :F)
-  #
-  # CONFIG_FILE
-  #
-
-  case $INSTALL in
-  [\\/$]* | ?:[\\/]* ) ac_INSTALL=$INSTALL ;;
-  *) ac_INSTALL=$ac_top_build_prefix$INSTALL ;;
-  esac
-_ACEOF
-
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-# If the template does not know about datarootdir, expand it.
-# FIXME: This hack should be removed a few years after 2.60.
-ac_datarootdir_hack=; ac_datarootdir_seen=
-ac_sed_dataroot='
-/datarootdir/ {
-  p
-  q
-}
-/@datadir@/p
-/@docdir@/p
-/@infodir@/p
-/@localedir@/p
-/@mandir@/p'
-case `eval "sed -n \"\$ac_sed_dataroot\" $ac_file_inputs"` in
-*datarootdir*) ac_datarootdir_seen=yes;;
-*@datadir@*|*@docdir@*|*@infodir@*|*@localedir@*|*@mandir@*)
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $ac_file_inputs seems to ignore the --datarootdir setting" >&5
-$as_echo "$as_me: WARNING: $ac_file_inputs seems to ignore the --datarootdir setting" >&2;}
-_ACEOF
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-  ac_datarootdir_hack='
-  s&@datadir@&$datadir&g
-  s&@docdir@&$docdir&g
-  s&@infodir@&$infodir&g
-  s&@localedir@&$localedir&g
-  s&@mandir@&$mandir&g
-  s&\\\${datarootdir}&$datarootdir&g' ;;
-esac
-_ACEOF
-
-# Neutralize VPATH when `$srcdir' = `.'.
-# Shell code in configure.ac might set extrasub.
-# FIXME: do we really want to maintain this feature?
-cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
-ac_sed_extra="$ac_vpsub
-$extrasub
-_ACEOF
-cat >>$CONFIG_STATUS <<\_ACEOF || ac_write_fail=1
-:t
-/@[a-zA-Z_][a-zA-Z_0-9]*@/!b
-s|@configure_input@|$ac_sed_conf_input|;t t
-s&@top_builddir@&$ac_top_builddir_sub&;t t
-s&@top_build_prefix@&$ac_top_build_prefix&;t t
-s&@srcdir@&$ac_srcdir&;t t
-s&@abs_srcdir@&$ac_abs_srcdir&;t t
-s&@top_srcdir@&$ac_top_srcdir&;t t
-s&@abs_top_srcdir@&$ac_abs_top_srcdir&;t t
-s&@builddir@&$ac_builddir&;t t
-s&@abs_builddir@&$ac_abs_builddir&;t t
-s&@abs_top_builddir@&$ac_abs_top_builddir&;t t
-s&@INSTALL@&$ac_INSTALL&;t t
-$ac_datarootdir_hack
-"
-eval sed \"\$ac_sed_extra\" "$ac_file_inputs" | $AWK -f "$tmp/subs.awk" >$tmp/out \
-  || as_fn_error "could not create $ac_file" "$LINENO" 5
-
-test -z "$ac_datarootdir_hack$ac_datarootdir_seen" &&
-  { ac_out=`sed -n '/\${datarootdir}/p' "$tmp/out"`; test -n "$ac_out"; } &&
-  { ac_out=`sed -n '/^[	 ]*datarootdir[	 ]*:*=/p' "$tmp/out"`; test -z "$ac_out"; } &&
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: $ac_file contains a reference to the variable \`datarootdir'
-which seems to be undefined.  Please make sure it is defined." >&5
-$as_echo "$as_me: WARNING: $ac_file contains a reference to the variable \`datarootdir'
-which seems to be undefined.  Please make sure it is defined." >&2;}
-
-  rm -f "$tmp/stdin"
-  case $ac_file in
-  -) cat "$tmp/out" && rm -f "$tmp/out";;
-  *) rm -f "$ac_file" && mv "$tmp/out" "$ac_file";;
-  esac \
-  || as_fn_error "could not create $ac_file" "$LINENO" 5
- ;;
-
-
-  :C)  { $as_echo "$as_me:${as_lineno-$LINENO}: executing $ac_file commands" >&5
-$as_echo "$as_me: executing $ac_file commands" >&6;}
- ;;
-  esac
-
-
-  case $ac_file$ac_mode in
-    "mkdir-vpath":C) make mkdir-vpath ;;
-
-  esac
-done # for ac_tag
-
-
-as_fn_exit 0
-_ACEOF
-ac_clean_files=$ac_clean_files_save
-
-test $ac_write_fail = 0 ||
-  as_fn_error "write failure creating $CONFIG_STATUS" "$LINENO" 5
-
-
-# configure is writing to config.log, and then calls config.status.
-# config.status does its own redirection, appending to config.log.
-# Unfortunately, on DOS this fails, as config.log is still kept open
-# by configure, so config.status won't be able to write to it; its
-# output is simply discarded.  So we exec the FD to /dev/null,
-# effectively closing config.log, so it can be properly (re)opened and
-# appended to by config.status.  When coming back to configure, we
-# need to make the FD available again.
-if test "$no_create" != yes; then
-  ac_cs_success=:
-  ac_config_status_args=
-  test "$silent" = yes &&
-    ac_config_status_args="$ac_config_status_args --quiet"
-  exec 5>/dev/null
-  $SHELL $CONFIG_STATUS $ac_config_status_args || ac_cs_success=false
-  exec 5>>config.log
-  # Use ||, not &&, to avoid exiting from the if with $? = 1, which
-  # would make configure fail if this is the last instruction.
-  $ac_cs_success || as_fn_exit $?
-fi
-if test -n "$ac_unrecognized_opts" && test "$enable_option_checking" != no; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: unrecognized options: $ac_unrecognized_opts" >&5
-$as_echo "$as_me: WARNING: unrecognized options: $ac_unrecognized_opts" >&2;}
-fi
-

=== modified file 'context.c'
--- context.c	2011-06-03 03:18:07 +0000
+++ context.c	2011-06-27 18:09:28 +0000
@@ -135,7 +135,20 @@
     else {
         /* build the pollset with a (default) number of connections */
         serf_pollset_t *ps = apr_pcalloc(pool, sizeof(*ps));
+#if APR_VERSION_AT_LEAST(1,4,0) && defined(WIN32)
+        /* APR 1.4.x switched to using WSAPoll() on Win32, but it does not
+         * properly handle errors on a non-blocking sockets (such as
+         * connecting to a server where no listener is active).
+         *
+         * So, sadly, we must force using select() on Win32.
+         *
+         * http://mail-archives.apache.org/mod_mbox/apr-dev/201105.mbox/%3CBANLkTin3rBCecCBRvzUA5B-14u-NWxR_Kg@mail.gmail.com%3E
+         */
+        (void) apr_pollset_create_ex(&ps->pollset, MAX_CONN, pool, 0,
+                                     APR_POLLSET_SELECT);
+#else
         (void) apr_pollset_create(&ps->pollset, MAX_CONN, pool, 0);
+#endif
         ctx->pollset_baton = ps;
         ctx->pollset_add = pollset_add;
         ctx->pollset_rm = pollset_rm;
@@ -311,3 +324,34 @@
     *minor = SERF_MINOR_VERSION;
     *patch = SERF_PATCH_VERSION;
 }
+
+
+const char *serf_error_string(apr_status_t errcode)
+{
+    switch (errcode)
+    {
+    case SERF_ERROR_CLOSING:
+        return "The connection is closing";
+    case SERF_ERROR_REQUEST_LOST:
+        return "A request has been lost";
+    case SERF_ERROR_WAIT_CONN:
+        return "The connection is blocked, pending further action";
+    case SERF_ERROR_DECOMPRESSION_FAILED:
+        return "An error occurred during decompression";
+    case SERF_ERROR_BAD_HTTP_RESPONSE:
+        return "The server sent an improper HTTP response";
+    case SERF_ERROR_AUTHN_FAILED:
+        return "An error occurred during authentication";
+    case SERF_ERROR_AUTHN_NOT_SUPPORTED:
+        return "The requested authentication type(s) are not supported";
+    case SERF_ERROR_AUTHN_MISSING_ATTRIBUTE:
+        return "An authentication attribute is missing";
+    case SERF_ERROR_AUTHN_INITALIZATION_FAILED:
+        return "Initialization of an authentication type failed";
+
+    default:
+        return NULL;
+    }
+
+    /* NOTREACHED  */
+}

=== modified file 'debian/changelog'
--- debian/changelog	2011-06-03 03:18:07 +0000
+++ debian/changelog	2011-06-27 18:09:28 +0000
@@ -1,3 +1,16 @@
+serf (1.0.0~0+svn1514-1) experimental; urgency=low
+
+  * New upstream snapshot.
+    - patches/abi-0.x: Remove as obsolete.
+    - patches/kqueue: Forward-port.
+    - Bump ABI: libserf0.7{,-dbg} -> libserf1{,-dbg}
+    - patches/ip6-localhost: New patch: temporary (I hope) workaround for
+      IPv4 / IPv6 confusion in testsuite.
+  * Implement Multi-Arch: same.
+  * libserf-dev Conflicts: libserf-0-0-dev, not Breaks.  Thanks, lintian.
+
+ -- Peter Samuelson <peter@p12n.org>  Mon, 27 Jun 2011 18:09:28 -0500
+
 serf (0.7.2-1) experimental; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-06-03 03:18:07 +0000
+++ debian/control	2011-06-27 18:09:28 +0000
@@ -2,14 +2,17 @@
 Section: libs
 Priority: optional
 Maintainer: Peter Samuelson <peter@p12n.org>
-Build-Depends: debhelper (>= 5), quilt, autoconf, autotools-dev, libapr1-dev, libaprutil1-dev
+Build-Depends: dpkg-dev (>= 1.16.0~), debhelper,
+    quilt, autoconf, autotools-dev, libapr1-dev, libaprutil1-dev
 Standards-Version: 3.9.1
 Homepage: http://code.google.com/p/serf/
 
-Package: libserf0.7
+Package: libserf1
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: multiarch-support
+Multi-Arch: same
 Description: high-performance asynchronous HTTP client library
  serf library is a C-based HTTP client library built upon the Apache
  Portable Runtime (APR) library.  It multiplexes connections, running the
@@ -20,9 +23,9 @@
 Package: libserf-dev
 Section: libdevel
 Architecture: any
-Depends: libserf0.7 (= ${binary:Version}), ${misc:Depends}, libapr1-dev, libaprutil1-dev
+Depends: libserf1 (= ${binary:Version}), ${misc:Depends}, libapr1-dev, libaprutil1-dev
 Replaces: libserf-0-0 (<< 0.3.0-1), libserf-0-0-dev
-Breaks: libserf-0-0-dev
+Conflicts: libserf-0-0-dev
 Provides: libserf-0-0-dev
 Description: high-performance asynchronous HTTP client library headers
  serf library is a C-based HTTP client library built upon the Apache
@@ -33,11 +36,11 @@
  .
  This package contains development headers for serf.
 
-Package: libserf0.7-dbg
+Package: libserf1-dbg
 Section: debug
 Priority: extra
 Architecture: any
-Depends: libserf0.7 (= ${binary:Version}), ${misc:Depends}
+Depends: libserf1 (= ${binary:Version}), ${misc:Depends}
 Provides: libserf-dbg
 Description: high-performance asynchronous HTTP client library debugging symbols
  serf library is a C-based HTTP client library built upon the Apache

=== removed file 'debian/libserf-dev.install'
--- debian/libserf-dev.install	2011-06-03 03:18:07 +0000
+++ debian/libserf-dev.install	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-debian/tmp/usr/include		usr/
-debian/tmp/usr/lib/libserf*.a	usr/lib/
-debian/tmp/usr/lib/libserf-?.so	usr/lib/
-#usr/lib/pkgconfig		usr/lib/
-#usr/share/pkgconfig		usr/share/

=== added file 'debian/libserf-dev.lintian-overrides'
--- debian/libserf-dev.lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/libserf-dev.lintian-overrides	2011-06-27 18:09:28 +0000
@@ -0,0 +1,2 @@
+# Bug in lintian 2.5.0.  Remove as soon as ftpmaster has upgraded to 2.5.1.
+missing-pre-dependency-on-multiarch-support

=== removed file 'debian/libserf0.7.install'
--- debian/libserf0.7.install	2011-06-03 03:18:07 +0000
+++ debian/libserf0.7.install	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-debian/tmp/usr/lib/libserf-*.*.so

=== removed file 'debian/libserf0.7.symbols'
--- debian/libserf0.7.symbols	2011-06-03 03:18:07 +0000
+++ debian/libserf0.7.symbols	1970-01-01 00:00:00 +0000
@@ -1,134 +0,0 @@
-libserf-0.7.so libserf0.7 #MINVER#
- serf_bmemdup@Base 0.7
- serf_bstrdup@Base 0.7
- serf_bstrmemdup@Base 0.7
- serf_bucket_aggregate_append@Base 0.7
- serf_bucket_aggregate_append_iovec@Base 0.7
- serf_bucket_aggregate_become@Base 0.7
- serf_bucket_aggregate_cleanup@Base 0.7.1
- serf_bucket_aggregate_create@Base 0.7
- serf_bucket_aggregate_hold_open@Base 0.7.1
- serf_bucket_aggregate_prepend@Base 0.7
- serf_bucket_aggregate_prepend_iovec@Base 0.7
- serf_bucket_allocator_create@Base 0.7
- serf_bucket_allocator_get_pool@Base 0.7
- serf_bucket_barrier_create@Base 0.7
- serf_bucket_bwtp_channel_close@Base 0.7.1
- serf_bucket_bwtp_channel_open@Base 0.7.1
- serf_bucket_bwtp_frame_get_channel@Base 0.7.1
- serf_bucket_bwtp_frame_get_headers@Base 0.7.1
- serf_bucket_bwtp_frame_get_phrase@Base 0.7.1
- serf_bucket_bwtp_frame_get_type@Base 0.7.1
- serf_bucket_bwtp_header_create@Base 0.7.1
- serf_bucket_bwtp_incoming_frame_create@Base 0.7.1
- serf_bucket_bwtp_incoming_frame_wait_for_headers@Base 0.7.1
- serf_bucket_bwtp_message_create@Base 0.7.1
- serf_bucket_chunk_create@Base 0.7
- serf_bucket_create@Base 0.7
- serf_bucket_dechunk_create@Base 0.7
- serf_bucket_deflate_create@Base 0.7
- serf_bucket_file_create@Base 0.7
- serf_bucket_headers_create@Base 0.7
- serf_bucket_headers_do@Base 0.7
- serf_bucket_headers_get@Base 0.7
- serf_bucket_headers_set@Base 0.7
- serf_bucket_headers_setc@Base 0.7
- serf_bucket_headers_setn@Base 0.7
- serf_bucket_headers_setx@Base 0.7
- serf_bucket_limit_create@Base 0.7
- serf_bucket_mem_alloc@Base 0.7
- serf_bucket_mem_calloc@Base 0.7
- serf_bucket_mem_free@Base 0.7
- serf_bucket_mmap_create@Base 0.7
- serf_bucket_request_become@Base 0.7
- serf_bucket_request_create@Base 0.7
- serf_bucket_request_get_headers@Base 0.7
- serf_bucket_request_set_root@Base 0.7
- serf_bucket_response_create@Base 0.7
- serf_bucket_response_get_headers@Base 0.7
- serf_bucket_response_set_head@Base 0.7
- serf_bucket_response_status@Base 0.7
- serf_bucket_response_wait_for_headers@Base 0.7
- serf_bucket_simple_copy_create@Base 0.7
- serf_bucket_simple_create@Base 0.7
- serf_bucket_socket_create@Base 0.7
- serf_bucket_socket_set_read_progress_cb@Base 0.7
- serf_bucket_ssl_decrypt_context_get@Base 0.7
- serf_bucket_ssl_decrypt_create@Base 0.7
- serf_bucket_ssl_encrypt_context_get@Base 0.7
- serf_bucket_ssl_encrypt_create@Base 0.7
- serf_bucket_type_aggregate@Base 0.7
- serf_bucket_type_barrier@Base 0.7
- serf_bucket_type_bwtp_frame@Base 0.7.1
- serf_bucket_type_bwtp_incoming_frame@Base 0.7.1
- serf_bucket_type_chunk@Base 0.7
- serf_bucket_type_dechunk@Base 0.7
- serf_bucket_type_deflate@Base 0.7
- serf_bucket_type_file@Base 0.7
- serf_bucket_type_headers@Base 0.7
- serf_bucket_type_limit@Base 0.7
- serf_bucket_type_mmap@Base 0.7
- serf_bucket_type_request@Base 0.7
- serf_bucket_type_response@Base 0.7
- serf_bucket_type_simple@Base 0.7
- serf_bucket_type_socket@Base 0.7
- serf_bucket_type_ssl_decrypt@Base 0.7
- serf_bucket_type_ssl_encrypt@Base 0.7
- serf_config_authn_types@Base 0.7.1
- serf_config_credentials_callback@Base 0.7.1
- serf_config_proxy@Base 0.7
- serf_connection_close@Base 0.7
- serf_connection_create2@Base 0.7
- serf_connection_create@Base 0.7
- serf_connection_priority_request_create@Base 0.7
- serf_connection_request_create@Base 0.7
- serf_connection_reset@Base 0.7
- serf_connection_set_async_responses@Base 0.7.1
- serf_connection_set_max_outstanding_requests@Base 0.7
- serf_context_bucket_socket_create@Base 0.7
- serf_context_create@Base 0.7
- serf_context_create_ex@Base 0.7
- serf_context_prerun@Base 0.7
- serf_context_run@Base 0.7
- serf_context_set_progress_cb@Base 0.7
- serf_databuf_init@Base 0.7
- serf_databuf_peek@Base 0.7
- serf_databuf_read@Base 0.7
- serf_databuf_readline@Base 0.7
- serf_debug__bucket_alloc_check@Base 0.7
- serf_debug__bucket_destroy@Base 0.7
- serf_debug__closed_conn@Base 0.7
- serf_debug__entered_loop@Base 0.7
- serf_debug__record_read@Base 0.7
- serf_default_destroy@Base 0.7
- serf_default_destroy_and_data@Base 0.7
- serf_default_is_snapshot_set@Base 0.7
- serf_default_read_bucket@Base 0.7
- serf_default_read_for_sendfile@Base 0.7
- serf_default_read_iovec@Base 0.7
- serf_default_restore_snapshot@Base 0.7
- serf_default_snapshot@Base 0.7
- serf_event_trigger@Base 0.7
- serf_incoming_create@Base 0.7.1
- serf_lib_version@Base 0.7.1
- serf_linebuf_fetch@Base 0.7
- serf_linebuf_init@Base 0.7
- serf_listener_create@Base 0.7.1
- serf_request_bucket_request_create@Base 0.7
- serf_request_cancel@Base 0.7
- serf_request_get_alloc@Base 0.7
- serf_request_get_conn@Base 0.7
- serf_request_get_pool@Base 0.7
- serf_request_set_handler@Base 0.7
- serf_ssl_cert_certificate@Base 0.7
- serf_ssl_cert_depth@Base 0.7
- serf_ssl_cert_export@Base 0.7
- serf_ssl_cert_issuer@Base 0.7
- serf_ssl_cert_subject@Base 0.7
- serf_ssl_client_cert_password_set@Base 0.7
- serf_ssl_client_cert_provider_set@Base 0.7
- serf_ssl_load_cert_file@Base 0.7
- serf_ssl_server_cert_callback_set@Base 0.7
- serf_ssl_trust_cert@Base 0.7
- serf_ssl_use_default_certificates@Base 0.7
- serf_util_readline@Base 0.7

=== added file 'debian/libserf1.lintian-overrides'
--- debian/libserf1.lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/libserf1.lintian-overrides	2011-06-27 18:09:28 +0000
@@ -0,0 +1,4 @@
+# This one is intentional
+symbols-declares-dependency-on-other-package libserf-private
+# This one is just silly
+package-name-doesnt-match-sonames libserf-1-0

=== added file 'debian/libserf1.symbols'
--- debian/libserf1.symbols	1970-01-01 00:00:00 +0000
+++ debian/libserf1.symbols	2011-06-27 18:09:28 +0000
@@ -0,0 +1,133 @@
+libserf-1.so.0 libserf1 #MINVER#
+| libserf-private
+* Build-Depends-Package: libserf-dev
+ (regex)__ 0 1
+ serf_bmemdup@Base 1.0
+ serf_bstrdup@Base 1.0
+ serf_bstrmemdup@Base 1.0
+ serf_bucket_aggregate_append@Base 1.0
+ serf_bucket_aggregate_append_iovec@Base 1.0
+ serf_bucket_aggregate_become@Base 1.0
+ serf_bucket_aggregate_cleanup@Base 1.0
+ serf_bucket_aggregate_create@Base 1.0
+ serf_bucket_aggregate_hold_open@Base 1.0
+ serf_bucket_aggregate_prepend@Base 1.0
+ serf_bucket_aggregate_prepend_iovec@Base 1.0
+ serf_bucket_allocator_create@Base 1.0
+ serf_bucket_allocator_get_pool@Base 1.0
+ serf_bucket_barrier_create@Base 1.0
+ serf_bucket_bwtp_channel_close@Base 1.0
+ serf_bucket_bwtp_channel_open@Base 1.0
+ serf_bucket_bwtp_frame_get_channel@Base 1.0
+ serf_bucket_bwtp_frame_get_headers@Base 1.0
+ serf_bucket_bwtp_frame_get_phrase@Base 1.0
+ serf_bucket_bwtp_frame_get_type@Base 1.0
+ serf_bucket_bwtp_header_create@Base 1.0
+ serf_bucket_bwtp_incoming_frame_create@Base 1.0
+ serf_bucket_bwtp_incoming_frame_wait_for_headers@Base 1.0
+ serf_bucket_bwtp_message_create@Base 1.0
+ serf_bucket_chunk_create@Base 1.0
+ serf_bucket_create@Base 1.0
+ serf_bucket_dechunk_create@Base 1.0
+ serf_bucket_deflate_create@Base 1.0
+ serf_bucket_file_create@Base 1.0
+ serf_bucket_headers_create@Base 1.0
+ serf_bucket_headers_do@Base 1.0
+ serf_bucket_headers_get@Base 1.0
+ serf_bucket_headers_set@Base 1.0
+ serf_bucket_headers_setc@Base 1.0
+ serf_bucket_headers_setn@Base 1.0
+ serf_bucket_headers_setx@Base 1.0
+ serf_bucket_iovec_create@Base 1.0
+ serf_bucket_limit_create@Base 1.0
+ serf_bucket_mem_alloc@Base 1.0
+ serf_bucket_mem_calloc@Base 1.0
+ serf_bucket_mem_free@Base 1.0
+ serf_bucket_mmap_create@Base 1.0
+ serf_bucket_request_become@Base 1.0
+ serf_bucket_request_create@Base 1.0
+ serf_bucket_request_get_headers@Base 1.0
+ serf_bucket_request_set_root@Base 1.0
+ serf_bucket_response_create@Base 1.0
+ serf_bucket_response_get_headers@Base 1.0
+ serf_bucket_response_set_head@Base 1.0
+ serf_bucket_response_status@Base 1.0
+ serf_bucket_response_wait_for_headers@Base 1.0
+ serf_bucket_simple_copy_create@Base 1.0
+ serf_bucket_simple_create@Base 1.0
+ serf_bucket_socket_create@Base 1.0
+ serf_bucket_socket_set_read_progress_cb@Base 1.0
+ serf_bucket_ssl_decrypt_context_get@Base 1.0
+ serf_bucket_ssl_decrypt_create@Base 1.0
+ serf_bucket_ssl_encrypt_context_get@Base 1.0
+ serf_bucket_ssl_encrypt_create@Base 1.0
+ serf_bucket_type_aggregate@Base 1.0
+ serf_bucket_type_barrier@Base 1.0
+ serf_bucket_type_bwtp_frame@Base 1.0
+ serf_bucket_type_bwtp_incoming_frame@Base 1.0
+ serf_bucket_type_chunk@Base 1.0
+ serf_bucket_type_dechunk@Base 1.0
+ serf_bucket_type_deflate@Base 1.0
+ serf_bucket_type_file@Base 1.0
+ serf_bucket_type_headers@Base 1.0
+ serf_bucket_type_iovec@Base 1.0
+ serf_bucket_type_limit@Base 1.0
+ serf_bucket_type_mmap@Base 1.0
+ serf_bucket_type_request@Base 1.0
+ serf_bucket_type_response@Base 1.0
+ serf_bucket_type_simple@Base 1.0
+ serf_bucket_type_socket@Base 1.0
+ serf_bucket_type_ssl_decrypt@Base 1.0
+ serf_bucket_type_ssl_encrypt@Base 1.0
+ serf_config_authn_types@Base 1.0
+ serf_config_credentials_callback@Base 1.0
+ serf_config_proxy@Base 1.0
+ serf_connection_close@Base 1.0
+ serf_connection_create2@Base 1.0
+ serf_connection_create@Base 1.0
+ serf_connection_priority_request_create@Base 1.0
+ serf_connection_request_create@Base 1.0
+ serf_connection_reset@Base 1.0
+ serf_connection_set_async_responses@Base 1.0
+ serf_connection_set_max_outstanding_requests@Base 1.0
+ serf_context_bucket_socket_create@Base 1.0
+ serf_context_create@Base 1.0
+ serf_context_create_ex@Base 1.0
+ serf_context_prerun@Base 1.0
+ serf_context_run@Base 1.0
+ serf_context_set_progress_cb@Base 1.0
+ serf_databuf_init@Base 1.0
+ serf_databuf_peek@Base 1.0
+ serf_databuf_read@Base 1.0
+ serf_databuf_readline@Base 1.0
+ serf_default_destroy@Base 1.0
+ serf_default_destroy_and_data@Base 1.0
+ serf_default_read_bucket@Base 1.0
+ serf_default_read_for_sendfile@Base 1.0
+ serf_default_read_iovec@Base 1.0
+ serf_error_string@Base 1.0
+ serf_event_trigger@Base 1.0
+ serf_incoming_create@Base 1.0
+ serf_lib_version@Base 1.0
+ serf_linebuf_fetch@Base 1.0
+ serf_linebuf_init@Base 1.0
+ serf_listener_create@Base 1.0
+ serf_request_bucket_request_create@Base 1.0
+ serf_request_cancel@Base 1.0
+ serf_request_get_alloc@Base 1.0
+ serf_request_get_conn@Base 1.0
+ serf_request_get_pool@Base 1.0
+ serf_request_set_handler@Base 1.0
+ serf_ssl_cert_certificate@Base 1.0
+ serf_ssl_cert_depth@Base 1.0
+ serf_ssl_cert_export@Base 1.0
+ serf_ssl_cert_issuer@Base 1.0
+ serf_ssl_cert_subject@Base 1.0
+ serf_ssl_client_cert_password_set@Base 1.0
+ serf_ssl_client_cert_provider_set@Base 1.0
+ serf_ssl_load_cert_file@Base 1.0
+ serf_ssl_server_cert_callback_set@Base 1.0
+ serf_ssl_set_hostname@Base 1.0
+ serf_ssl_trust_cert@Base 1.0
+ serf_ssl_use_default_certificates@Base 1.0
+ serf_util_readline@Base 1.0

=== removed file 'debian/patches/abi-0.x'
--- debian/patches/abi-0.x	2011-06-03 03:18:07 +0000
+++ debian/patches/abi-0.x	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
---- a/Makefile.in
-+++ b/Makefile.in
-@@ -6,6 +6,7 @@ VPATH = @srcdir@
- 
- SERF_MAJOR_VERSION=@SERF_MAJOR_VERSION@
- SERF_DOTTED_VERSION=@SERF_DOTTED_VERSION@
-+LTVERSION=-release @LTVERSION@
- 
- OBJECTS = buckets/aggregate_buckets.lo buckets/request_buckets.lo context.lo \
-           buckets/buckets.lo buckets/simple_buckets.lo buckets/file_buckets.lo \
-@@ -19,7 +20,7 @@ OBJECTS = buckets/aggregate_buckets.lo b
-           auth/auth.lo auth/auth_basic.lo auth/auth_digest.lo \
-           auth/auth_kerb.lo auth/auth_kerb_gss.lo
- 
--TARGET_LIB=libserf-$(SERF_MAJOR_VERSION).la
-+TARGET_LIB=libserf.la
- 
- TEST_OBJECTS = test/serf_get.lo test/serf_response.lo test/serf_request.lo \
-                test/serf_spider.lo test/serf_server.lo test/serf_bwtp.lo
-@@ -92,7 +93,7 @@ test/test_context.lo: test/test_context.
- test/test_ssl.lo: test/test_ssl.c $(HEADERS)
- 
- $(TARGET_LIB): $(OBJECTS)
--	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -rpath $(libdir) -o $@ $^ $(LIBS)
-+	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -rpath $(libdir) $(LTVERSION) -o $@ $^ $(LIBS)
- 
- test/serf_get: $(TARGET_LIB) test/serf_get.lo
- 	$(LIBTOOL) $(LTFLAGS) --mode=link $(CC) $(LDFLAGS) -static -o $@ $^ $(LIBS)
---- a/configure.in
-+++ b/configure.in
-@@ -160,9 +160,11 @@ get_version="$abs_srcdir/build/get-versi
- version_hdr="$abs_srcdir/serf.h"
- SERF_MAJOR_VERSION="`$get_version major $version_hdr SERF`"
- SERF_DOTTED_VERSION="`$get_version all $version_hdr SERF`"
-+LTVERSION=${SERF_DOTTED_VERSION%.*}
- 
- AC_SUBST(SERF_MAJOR_VERSION)
- AC_SUBST(SERF_DOTTED_VERSION)
-+AC_SUBST(LTVERSION)
- 
- AC_SUBST(SERF_BUILD_SRCLIB_DIRS)
- AC_SUBST(SERF_CLEAN_SRCLIB_DIRS)

=== added file 'debian/patches/ip6-localhost'
--- debian/patches/ip6-localhost	1970-01-01 00:00:00 +0000
+++ debian/patches/ip6-localhost	2011-06-27 18:09:28 +0000
@@ -0,0 +1,67 @@
+Temporary workaround for testsuite problem wherein serf looks up
+'localhost' but then expects to be able to use it with an IPv6 socket.
+I'm not sure of the details, but using 'ip6-localhost' everywhere works.
+
+
+--- a/test/test_util.c
++++ b/test/test_util.c
+@@ -27,13 +27,13 @@
+ /* Server setup function(s)
+  */
+ 
+-#define SERV_URL "http://localhost:" SERV_PORT_STR
++#define SERV_URL "http://ip6-localhost:" SERV_PORT_STR
+ 
+ static apr_status_t default_server_address(apr_sockaddr_t **address,
+                                            apr_pool_t *pool)
+ {
+     return apr_sockaddr_info_get(address,
+-                                 "localhost", APR_UNSPEC, SERV_PORT, 0,
++                                 "ip6-localhost", APR_UNSPEC, SERV_PORT, 0,
+                                  pool);
+ }
+ 
+@@ -41,7 +41,7 @@ static apr_status_t default_proxy_addres
+                                           apr_pool_t *pool)
+ {
+     return apr_sockaddr_info_get(address,
+-                                 "localhost", APR_UNSPEC, PROXY_PORT, 0,
++                                 "ip6-localhost", APR_UNSPEC, PROXY_PORT, 0,
+                                  pool);
+ }
+ 
+--- a/test/serf_request.c
++++ b/test/serf_request.c
+@@ -65,7 +65,7 @@ int main(int argc, const char **argv)
+     hdrs_bkt = serf_bucket_request_get_headers(req_bkt);
+ 
+     /* FIXME: Shouldn't we be able to figure out the host ourselves? */
+-    serf_bucket_headers_setn(hdrs_bkt, "Host", "localhost");
++    serf_bucket_headers_setn(hdrs_bkt, "Host", "ip6-localhost");
+     serf_bucket_headers_setn(hdrs_bkt, "User-Agent",
+                              "Serf/" SERF_VERSION_STRING);
+ 
+--- a/test/test_context.c
++++ b/test/test_context.c
+@@ -473,8 +473,8 @@ static void test_serf_setup_proxy(CuTest
+     apr_sockaddr_t *proxy_address;
+ 
+     test_server_message_t message_list[] = {
+-        {"GET http://localhost:" SERV_PORT_STR " HTTP/1.1" CRLF\
+-         "Host: localhost:" SERV_PORT_STR CRLF\
++        {"GET http://ip6-localhost:" SERV_PORT_STR " HTTP/1.1" CRLF\
++         "Host: ip6-localhost:" SERV_PORT_STR CRLF\
+          "Transfer-Encoding: chunked" CRLF\
+          CRLF\
+          "1" CRLF\
+--- a/test/test_serf.h
++++ b/test/test_serf.h
+@@ -52,7 +52,7 @@ CuSuite *test_ssl(void);
+ 
+ #define CHUNKED_REQUEST(len, body)\
+         "GET / HTTP/1.1" CRLF\
+-        "Host: localhost:12345" CRLF\
++        "Host: ip6-localhost:12345" CRLF\
+         "Transfer-Encoding: chunked" CRLF\
+         CRLF\
+         #len CRLF\

=== modified file 'debian/patches/kqueue'
--- debian/patches/kqueue	2009-08-20 08:36:44 +0000
+++ debian/patches/kqueue	2011-06-27 18:09:28 +0000
@@ -5,9 +5,9 @@
 are not true with the FreeBSD kernel.
 
 
---- a/test/test_util.c
-+++ b/test/test_util.c
-@@ -168,6 +168,7 @@
+--- a/test/server/test_server.c
++++ b/test/server/test_server.c
+@@ -217,6 +217,7 @@ apr_status_t test_server_run(serv_ctx_t 
      apr_pollset_t *pollset;
      apr_int32_t num;
      const apr_pollfd_t *desc;
@@ -15,19 +15,19 @@
  
      /* create a new pollset */
      status = apr_pollset_create(&pollset, 32, pool, 0);
-@@ -211,7 +212,14 @@
+@@ -260,7 +261,14 @@ apr_status_t test_server_run(serv_ctx_t 
              goto cleanup;
          }
  
--        if (desc->desc.s == tb->client_sock) {
-+        if (desc->desc.s == tb->client_sock && !client_sock_handled) {
+-        if (desc->desc.s == servctx->client_sock) {
++        if (desc->desc.s == servctx->client_sock && !client_sock_handled) {
 +            /* Note: on some implementations (for example with kqueue),
 +               apr_pollset_poll() returns separate events for APR_POLLIN
-+               and APR_POLLOUT. client_sock_handled filters the second 
++               and APR_POLLOUT. client_sock_handled filters the second
 +               event.
 +            */
 +            client_sock_handled = 1;
 +
              /* Replay data to socket. */
-             status = replay(tb, pool);
+             status = replay(servctx, desc->rtnevents, pool);
  

=== modified file 'debian/patches/out-of-tree'
--- debian/patches/out-of-tree	2009-11-23 03:25:24 +0000
+++ debian/patches/out-of-tree	2011-06-27 18:09:28 +0000
@@ -2,7 +2,7 @@
 
 --- a/Makefile.in
 +++ b/Makefile.in
-@@ -104,7 +104,7 @@
+@@ -121,7 +121,7 @@ test/test_all: $(TARGET_LIB) $(TEST_SUIT
  check: test/serf_response test/test_all
  	@for i in $(TESTCASES); \
  		 do echo "== Testing $$i =="; \
@@ -11,7 +11,7 @@
  	done;
  	@echo "== Running test_all ==";
  	@./test/test_all
-@@ -135,6 +135,9 @@
+@@ -152,6 +152,9 @@ mkdir-vpath:
  	@if [ ! -d test ]; then \
  		$(MKDIR) test; \
  	fi;

=== modified file 'debian/patches/series'
--- debian/patches/series	2011-06-03 03:18:07 +0000
+++ debian/patches/series	2011-06-27 18:09:28 +0000
@@ -1,4 +1,4 @@
-abi-0.x
 libtool
 kqueue
 out-of-tree
+ip6-localhost

=== modified file 'debian/rules'
--- debian/rules	2011-06-03 03:18:07 +0000
+++ debian/rules	2011-06-27 18:09:28 +0000
@@ -13,12 +13,16 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
 CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
 else
 CROSS= --build $(DEB_BUILD_GNU_TYPE)
 endif
 
+libdir := /usr/lib/$(DEB_HOST_MULTIARCH)
+includedir := /usr/include
+
 configure: patch
 	autoconf
 
@@ -27,7 +31,8 @@
 	cp -f /usr/share/misc/config.sub config.sub
 	cp -f /usr/share/misc/config.guess config.guess
 	mkdir -p BUILD
-	cd BUILD; ../configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man \
+	cd BUILD; ../configure $(CROSS) --prefix=/usr \
+	    --libdir=$(libdir) --mandir=/usr/share/man \
 	    CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"
 
 
@@ -54,12 +59,8 @@
 	dh_testdir
 	dh_testroot
 	dh_clean -k 
-	dh_installdirs
 
 	$(MAKE) -C BUILD DESTDIR=$(CURDIR)/debian/tmp install
-	# A kludge related to patches/abi-0.x
-	mv debian/tmp/usr/lib/libserf.so debian/tmp/usr/lib/libserf-0.so
-	mv debian/tmp/usr/lib/libserf.a debian/tmp/usr/lib/libserf-0.a
 
 binary-indep: build install
 
@@ -69,23 +70,29 @@
 	dh_installchangelogs -s CHANGES
 	dh_installdocs -s NOTICE
 	dh_installexamples -s
-	dh_install -s
 	dh_installman -s
-	for p in $$(dh_listpackages -s -Nlibserf0.7); do \
-		doc0=debian/$$p/usr/share/doc/libserf0.7; \
+	install -d debian/libserf1/$(libdir) debian/libserf-dev/$(libdir)
+	install -d debian/libserf-dev/$(includedir)
+	mv debian/tmp$(libdir)/*.so.* debian/libserf1$(libdir)/
+	mv debian/tmp$(libdir)/*.so debian/libserf-dev$(libdir)/
+	mv debian/tmp$(libdir)/*.a debian/libserf-dev$(libdir)/
+	mv debian/tmp$(includedir)/* debian/libserf-dev$(includedir)/
+	for p in $$(dh_listpackages -s -Nlibserf1); do \
+		doc0=debian/$$p/usr/share/doc/libserf1; \
 		doc=debian/$$p/usr/share/doc/$$p; \
 		rm -f $$doc/changelog* $$doc/copyright; \
 		mv $$doc $$doc0; \
 		rmdir --ignore-fail-on-non-empty $$doc0; \
-		ln -s libserf0.7 $$doc; \
+		ln -s libserf1 $$doc; \
 	done;
 	dh_link -s
-	dh_strip -s --dbg-package=libserf0.7-dbg
+	dh_strip -s --dbg-package=libserf1-dbg
 	dh_compress -s
 	dh_fixperms -s
 	dh_makeshlibs -s
 	dh_installdeb -s
 	dh_shlibdeps -s
+	dh_lintian -s || true
 	dh_gencontrol -s
 	dh_md5sums -s
 	dh_builddeb -s

=== added file 'debian/source/lintian-overrides'
--- debian/source/lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/source/lintian-overrides	2011-06-27 18:09:28 +0000
@@ -0,0 +1,3 @@
+# Versioned build-dep older than oldstable would be rather silly
+package-lacks-versioned-build-depends-on-debhelper
+debhelper-script-needs-versioned-build-depends

=== modified file 'incoming.c'
--- incoming.c	2011-06-03 03:18:07 +0000
+++ incoming.c	2011-06-27 18:09:28 +0000
@@ -75,7 +75,7 @@
         return rv;
     }
 
-    rv = l->accept(l->ctx, l, l->accept_baton, in, p);
+    rv = l->accept_func(l->ctx, l, l->accept_baton, in, p);
 
     if (rv) {
         apr_pool_destroy(p);
@@ -131,7 +131,7 @@
     l->ctx = ctx;
     l->baton.type = SERF_IO_LISTENER;
     l->baton.u.listener = l;
-    l->accept = accept;
+    l->accept_func = accept;
     l->accept_baton = accept_baton;
 
     apr_pool_create(&l->pool, pool);

=== modified file 'outgoing.c'
--- outgoing.c	2011-06-03 03:18:07 +0000
+++ outgoing.c	2011-06-27 18:09:28 +0000
@@ -38,12 +38,30 @@
 
 static apr_status_t clean_resp(void *data)
 {
-    serf_request_t *req = data;
+    serf_request_t *request = data;
+
+    /* The request's RESPOOL is being cleared.  */
+
+    /* If the response has allocated some buckets, then destroy them (since
+       the bucket may hold resources other than memory in RESPOOL). Also
+       make sure to set their fields to NULL so connection closure does
+       not attempt to free them again.  */
+    if (request->resp_bkt) {
+        serf_bucket_destroy(request->resp_bkt);
+        request->resp_bkt = NULL;
+    }
+    if (request->req_bkt) {
+        serf_bucket_destroy(request->req_bkt);
+        request->req_bkt = NULL;
+    }
+
+    /* ### should we worry about debug stuff, like that performed in
+       ### destroy_request()? should we worry about calling req->handler
+       ### to notify this "cancellation" due to pool clearing?  */
 
     /* This pool just got cleared/destroyed. Don't try to destroy the pool
-     * (again) when the request is canceled.
-     */
-    req->respool = NULL;
+       (again) when the request is canceled.  */
+    request->respool = NULL;
 
     return APR_SUCCESS;
 }
@@ -232,6 +250,12 @@
         if (conn->ctx->authn_info.scheme)
             conn->ctx->authn_info.scheme->init_conn_func(401, conn,
                                                          conn->pool);
+
+        /* Does this connection require a SSL tunnel over the proxy? */
+        if (ctx->proxy_address && strcmp(conn->host_info.scheme, "https") == 0)
+            serf__ssltunnel_connect(conn);
+        else
+            conn->state = SERF_CONN_CONNECTED;
     }
 
     return APR_SUCCESS;
@@ -241,7 +265,7 @@
                                    serf_request_t *request)
 {
     /* Note that we should hold new requests until we open our new socket. */
-    conn->closing = 1;
+    conn->state = SERF_CONN_CLOSING;
 
     /* We can take the *next* request in our list and assume it hasn't
      * been written yet and 'save' it for the new socket.
@@ -304,14 +328,17 @@
     if (request->resp_bkt) {
         serf_debug__closed_conn(request->resp_bkt->allocator);
         serf_bucket_destroy(request->resp_bkt);
+        request->resp_bkt = NULL;
     }
     if (request->req_bkt) {
         serf_debug__closed_conn(request->req_bkt->allocator);
         serf_bucket_destroy(request->req_bkt);
+        request->req_bkt = NULL;
     }
 
     serf_debug__bucket_alloc_check(request->allocator);
     if (request->respool) {
+        /* ### unregister the pool cleanup for self?  */
         apr_pool_destroy(request->respool);
     }
 
@@ -394,10 +421,9 @@
     held_reqs = conn->hold_requests;
     held_reqs_tail = conn->hold_requests_tail;
 
-    if (conn->closing) {
+    if (conn->state == SERF_CONN_CLOSING) {
         conn->hold_requests = NULL;
         conn->hold_requests_tail = NULL;
-        conn->closing = 0;
     }
 
     conn->requests = NULL;
@@ -449,6 +475,7 @@
 
     conn->dirty_conn = 1;
     conn->ctx->dirty_pollset = 1;
+    conn->state = SERF_CONN_INIT;
 
     conn->status = APR_SUCCESS;
 
@@ -538,6 +565,53 @@
     return status;
 }
 
+/* Set up the input and output stream buckets.
+   When a tunnel over an http proxy is needed, create a socket bucket and
+   empty aggregate bucket for sending and receiving unencrypted requests
+   over the socket.
+
+   After the tunnel is there, or no tunnel was needed, ask the application
+   to create the input and output buckets, which should take care of the
+   [en/de]cryption.
+*/
+
+static apr_status_t prepare_conn_streams(serf_connection_t *conn,
+                                         serf_bucket_t **istream,
+                                         serf_bucket_t **ostreamt,
+                                         serf_bucket_t **ostreamh)
+{
+    apr_status_t status;
+
+    /* Do we need a SSL tunnel first? */
+    if (conn->state == SERF_CONN_CONNECTED) {
+        /* If the connection does not have an associated bucket, then
+         * call the setup callback to get one.
+         */
+        if (conn->stream == NULL) {
+            status = do_conn_setup(conn);
+            if (status) {
+                return status;
+            }
+        }
+        *ostreamt = conn->ostream_tail;
+        *ostreamh = conn->ostream_head;
+        *istream = conn->stream;
+    } else {
+        /* SSL tunnel needed and not set up yet, get a direct unencrypted
+           stream for this socket */
+        if (conn->stream == NULL) {
+            *istream = serf_bucket_socket_create(conn->skt,
+                                                 conn->allocator);
+        }
+        /* Don't create the ostream bucket chain including the ssl_encrypt
+           bucket yet. This ensure the CONNECT request is sent unencrypted
+           to the proxy. */
+        *ostreamt = *ostreamh = conn->ssltunnel_ostream;
+    }
+
+    return APR_SUCCESS;
+}
+
 /* write data out to the connection */
 static apr_status_t write_to_connection(serf_connection_t *conn)
 {
@@ -545,6 +619,10 @@
 
     if (conn->probable_keepalive_limit &&
         conn->completed_requests > conn->probable_keepalive_limit) {
+
+        conn->dirty_conn = 1;
+        conn->ctx->dirty_pollset = 1;
+
         /* backoff for now. */
         return APR_SUCCESS;
     }
@@ -563,10 +641,19 @@
         int stop_reading = 0;
         apr_status_t status;
         apr_status_t read_status;
-
-        if (conn->max_outstanding_requests &&
+        serf_bucket_t *ostreamt, *ostreamh;
+        int max_outstanding_requests = conn->max_outstanding_requests;
+
+        /* If we're setting up an ssl tunnel, we can't send real requests
+           at yet, as they need to be encrypted and our encrypt buckets
+           aren't created yet as we still need to read the unencrypted
+           response of the CONNECT request. */
+        if (conn->state != SERF_CONN_CONNECTED)
+            max_outstanding_requests = 1;
+
+        if (max_outstanding_requests &&
             conn->completed_requests -
-                conn->completed_responses >= conn->max_outstanding_requests) {
+                conn->completed_responses >= max_outstanding_requests) {
             /* backoff for now. */
             return APR_SUCCESS;
         }
@@ -606,14 +693,9 @@
             return APR_SUCCESS;
         }
 
-        /* If the connection does not have an associated bucket, then
-         * call the setup callback to get one.
-         */
-        if (conn->stream == NULL) {
-            status = do_conn_setup(conn);
-            if (status) {
-                return status;
-            }
+        status = prepare_conn_streams(conn, &conn->stream, &ostreamt, &ostreamh);
+        if (status) {
+            return status;
         }
 
         if (request->req_bkt == NULL) {
@@ -639,18 +721,19 @@
             }
 
             request->written = 1;
-            serf_bucket_aggregate_append(conn->ostream_tail, request->req_bkt);
+            serf_bucket_aggregate_append(ostreamt, request->req_bkt);
         }
 
         /* ### optimize at some point by using read_for_sendfile */
-        read_status = serf_bucket_read_iovec(conn->ostream_head,
+        read_status = serf_bucket_read_iovec(ostreamh,
                                              SERF_READ_ALL_AVAIL,
                                              IOV_MAX,
                                              conn->vec,
                                              &conn->vec_len);
 
         if (!conn->hit_eof) {
-            if (APR_STATUS_IS_EAGAIN(read_status)) {
+            if (APR_STATUS_IS_EAGAIN(read_status) ||
+                read_status == SERF_ERROR_WAIT_CONN) {
                 /* We read some stuff, but should not try to read again. */
                 stop_reading = 1;
 
@@ -686,8 +769,10 @@
                 return status;
         }
 
-        if (conn->hit_eof &&
-            conn->vec_len == 0) {
+        if (read_status == SERF_ERROR_WAIT_CONN) {
+            stop_reading = 1;
+        }
+        else if (read_status && conn->hit_eof && conn->vec_len == 0) {
             /* If we hit the end of the request bucket and all of its data has
              * been written, then clear it out to signify that we're done
              * sending the request. On the next iteration through this loop:
@@ -697,6 +782,7 @@
              * ("pipelining").
              */
             conn->hit_eof = 0;
+            serf_bucket_destroy(request->req_bkt);
             request->req_bkt = NULL;
 
             /* If our connection has async responses enabled, we're not
@@ -728,7 +814,7 @@
 static apr_status_t handle_response(serf_request_t *request,
                                     apr_pool_t *pool)
 {
-    apr_status_t status;
+    apr_status_t status = APR_SUCCESS;
     int consumed_response = 0;
 
     /* Only enable the new authentication framework if the program has
@@ -809,16 +895,14 @@
 
     /* Invoke response handlers until we have no more work. */
     while (1) {
+        serf_bucket_t *dummy1, *dummy2;
+
         apr_pool_clear(tmppool);
 
-        /* If the connection does not have an associated bucket, then
-         * call the setup callback to get one.
-         */
-        if (conn->stream == NULL) {
-            status = do_conn_setup(conn);
-            if (status) {
-                goto error;
-            }
+        /* Only interested in the input stream here. */
+        status = prepare_conn_streams(conn, &conn->stream, &dummy1, &dummy2);
+        if (status) {
+            goto error;
         }
 
         /* We have a different codepath when we can have async responses. */
@@ -934,6 +1018,10 @@
 
         conn->completed_responses++;
 
+        /* We've to rebuild pollset since completed_responses is changed. */
+        conn->dirty_conn = 1;
+        conn->ctx->dirty_pollset = 1;
+
         /* This means that we're being advised that the connection is done. */
         if (close_connection == SERF_ERROR_CLOSING) {
             reset_connection(conn, 1);
@@ -991,7 +1079,10 @@
         }
     }
     if ((events & APR_POLLHUP) != 0) {
-        return APR_ECONNRESET;
+        /* The connection got reset by the server. On Windows this can happen
+           when all data is read, so just cleanup the connection and open
+           a new one. */
+        return reset_connection(conn, 1);
     }
     if ((events & APR_POLLERR) != 0) {
         /* We might be talking to a buggy HTTP server that doesn't
@@ -1001,7 +1092,7 @@
          *
          * http://issues.apache.org/bugzilla/show_bug.cgi?id=35292
          */
-        if (!conn->probable_keepalive_limit) {
+        if (conn->completed_requests && !conn->probable_keepalive_limit) {
             return reset_connection(conn, 1);
         }
         return APR_EGENERAL;
@@ -1039,6 +1130,7 @@
     conn->baton.type = SERF_IO_CONN;
     conn->baton.u.conn = conn;
     conn->hit_eof = 0;
+    conn->state = SERF_CONN_INIT;
 
     /* Create a subpool for our connection. */
     apr_pool_create(&conn->skt_pool, conn->pool);
@@ -1066,10 +1158,6 @@
     serf_connection_t *c;
     apr_sockaddr_t *host_address;
 
-    /* Support for HTTPS proxies is not implemented yet. */
-    if (ctx->proxy_address && strcmp(host_info.scheme, "https") == 0)
-        return APR_ENOTIMPL;
-
     /* Parse the url, store the address of the server. */
     status = apr_sockaddr_info_get(&host_address,
                                    host_info.hostname,
@@ -1186,11 +1274,12 @@
     request->respool = NULL;
     request->req_bkt = NULL;
     request->resp_bkt = NULL;
+    request->priority = 0;
     request->written = 0;
     request->next = NULL;
 
     /* Link the request to the end of the request chain. */
-    if (conn->closing) {
+    if (conn->state == SERF_CONN_CLOSING) {
         link_requests(&conn->hold_requests, &conn->hold_requests_tail, request);
     }
     else {
@@ -1221,12 +1310,13 @@
     request->respool = NULL;
     request->req_bkt = NULL;
     request->resp_bkt = NULL;
+    request->priority = 1;
     request->written = 0;
     request->next = NULL;
 
     /* Link the new request after the last written request, but before all
        upcoming requests. */
-    if (conn->closing) {
+    if (conn->state == SERF_CONN_CLOSING) {
         iter = conn->hold_requests;
     }
     else {
@@ -1240,12 +1330,18 @@
         iter = iter->next;
     }
 
+    /* Advance to next non priority request */
+    while (iter != NULL && iter->priority) {
+        prev = iter;
+        iter = iter->next;
+    }
+
     if (prev) {
         request->next = iter;
         prev->next = request;
     } else {
         request->next = iter;
-        if (conn->closing) {
+        if (conn->state == SERF_CONN_CLOSING) {
             conn->hold_requests = request;
         }
         else {
@@ -1253,7 +1349,7 @@
         }
     }
 
-    if (! conn->closing) {
+    if (conn->state != SERF_CONN_CLOSING) {
         /* Ensure our pollset becomes writable in context run */
         conn->ctx->dirty_pollset = 1;
         conn->dirty_conn = 1;

=== modified file 'serf.h'
--- serf.h	2011-06-03 03:18:07 +0000
+++ serf.h	2011-06-27 18:09:28 +0000
@@ -69,6 +69,19 @@
  * could be processed on the other side.
  */
 #define SERF_ERROR_REQUEST_LOST (APR_OS_START_USERERR + SERF_ERROR_RANGE + 2)
+/* This code is for when the connection is blocked - we can not proceed
+ * until something happens - generally due to SSL negotiation-like behavior
+ * where a write() is blocked until a read() is processed.
+ */
+#define SERF_ERROR_WAIT_CONN (APR_OS_START_USERERR + SERF_ERROR_RANGE + 3)
+/* This code is for when something went wrong during deflating compressed
+ * data e.g. a CRC error. */
+#define SERF_ERROR_DECOMPRESSION_FAILED (APR_OS_START_USERERR + \
+                                             SERF_ERROR_RANGE + 4)
+/* This code is for when a response received from a http server is not in
+ * http-compliant syntax. */
+#define SERF_ERROR_BAD_HTTP_RESPONSE (APR_OS_START_USERERR + \
+                                             SERF_ERROR_RANGE + 5)
 
 /* General authentication related errors */
 #define SERF_ERROR_AUTHN_FAILED (APR_OS_START_USERERR + SERF_ERROR_RANGE + 90)
@@ -83,6 +96,22 @@
 #define SERF_ERROR_AUTHN_INITALIZATION_FAILED (APR_OS_START_USERERR +\
     SERF_ERROR_RANGE + 93)
 
+/* This macro groups errors potentially raised when reading a http response.  */
+#define SERF_BAD_RESPONSE_ERROR(status) ((status) \
+    && ((SERF_ERROR_DECOMPRESSION_FAILED == (status)) \
+        ||(SERF_ERROR_BAD_HTTP_RESPONSE == (status))))
+
+/**
+ * Return a string that describes the specified error code.
+ *
+ * If the error code is not one of the above Serf error codes, then
+ * NULL will be returned.
+ *
+ * Note regarding lifetime: the string is a statically-allocated constant
+ */
+const char *serf_error_string(apr_status_t errcode);
+
+
 /**
  * Create a new context for serf operations.
  *
@@ -813,27 +842,6 @@
      */
     void (*destroy)(serf_bucket_t *bucket);
 
-    /**
-     * Save the current state of the @a bucket for later retrieval and return
-     * APR_SUCCESS. A previously set snapshot will be cleared.
-     * In case of error, the bucket should be considered invalid.
-     */
-    apr_status_t (*snapshot)(serf_bucket_t *bucket);
-
-    /**
-     * Restore the state of the @a bucket to the state set in the last
-     * snapshot and returns APR_SUCCESS. If no snapshot was set, the bucket's
-     * state is unchanged and APR_SUCCESS is returned.
-     * In case of error, the bucket should be considered invalid.
-     */
-    apr_status_t (*restore_snapshot)(serf_bucket_t *bucket);
-
-    /**
-     * Test if a snapshot is set. Returns 0 if no snapshot was set, a non-0
-     * value if there is a snapshot set.
-     */
-    int (*is_snapshot_set)(serf_bucket_t *bucket);
-
     /* ### apr buckets have 'copy', 'split', and 'setaside' functions.
        ### not sure whether those will be needed in this bucket model.
     */
@@ -878,9 +886,6 @@
 #define serf_bucket_read_bucket(b,t) ((b)->type->read_bucket(b,t))
 #define serf_bucket_peek(b,d,l) ((b)->type->peek(b,d,l))
 #define serf_bucket_destroy(b) ((b)->type->destroy(b))
-#define serf_bucket_snapshot(b) ((b)->type->snapshot(b))
-#define serf_bucket_restore_snapshot(b) ((b)->type->restore_snapshot(b))
-#define serf_bucket_is_snapshot_set(b) ((b)->type->is_snapshot_set(b))
 
 /**
  * Check whether a real error occurred. Note that bucket read functions
@@ -889,7 +894,8 @@
  */
 #define SERF_BUCKET_READ_ERROR(status) ((status) \
                                         && !APR_STATUS_IS_EOF(status) \
-                                        && !APR_STATUS_IS_EAGAIN(status))
+                                        && !APR_STATUS_IS_EAGAIN(status) \
+                                        && (SERF_ERROR_WAIT_CONN != status))
 
 
 struct serf_bucket_t {
@@ -1023,9 +1029,9 @@
     serf_bucket_alloc_t *allocator);
 
 /* Version info */
-#define SERF_MAJOR_VERSION 0
-#define SERF_MINOR_VERSION 7
-#define SERF_PATCH_VERSION 2
+#define SERF_MAJOR_VERSION 1
+#define SERF_MINOR_VERSION 0
+#define SERF_PATCH_VERSION 0
 
 /* Version number string */
 #define SERF_VERSION_STRING APR_STRINGIFY(SERF_MAJOR_VERSION) "." \

=== modified file 'serf.mak'
--- serf.mak	2011-06-03 03:18:07 +0000
+++ serf.mak	2011-06-27 18:09:28 +0000
@@ -13,11 +13,11 @@
 !IF "$(DEBUG_BUILD)" == ""
 INTDIR = Release
 CFLAGS = /MD /O2 /D "NDEBUG" $(CFLAGS)
-STATIC_LIB = $(INTDIR)\serf.lib
+STATIC_LIB = $(INTDIR)\serf-1.lib
 !ELSE
 INTDIR = Debug
 CFLAGS = /MDd /Od /W3 /Gm /D "_DEBUG" $(CFLAGS)
-STATIC_LIB = $(INTDIR)\serf.lib
+STATIC_LIB = $(INTDIR)\serf-1.lib
 !ENDIF
 
 ########
@@ -93,7 +93,7 @@
 WIN32_DEFS = /D WIN32 /D WIN32_LEAN_AND_MEAN /D NOUSER /D NOGDI /D NONLS /D NOCRYPT /D SERF_HAVE_SSPI
 
 CPP=cl.exe
-CPP_PROJ = /c /nologo $(CFLAGS) $(WIN32_DEFS) $(EXPAT_FLAGS) $(APR_FLAGS) $(APRUTIL_FLAGS) $(OPENSSL_FLAGS) $(ZLIB_FLAGS) /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\"
+CPP_PROJ = /c /nologo $(CFLAGS) $(WIN32_DEFS) $(APR_FLAGS) $(APRUTIL_FLAGS) $(OPENSSL_FLAGS) $(ZLIB_FLAGS) /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\"
 LIB32=link.exe
 LIB32_FLAGS=/nologo
 
@@ -106,6 +106,7 @@
     "$(INTDIR)\auth_kerb_gss.obj" \
     "$(INTDIR)\auth_kerb_sspi.obj" \
     "$(INTDIR)\context.obj" \
+    "$(INTDIR)\ssltunnel.obj" \
     "$(INTDIR)\allocator.obj" \
     "$(INTDIR)\barrier_buckets.obj" \
     "$(INTDIR)\buckets.obj" \
@@ -115,6 +116,7 @@
     "$(INTDIR)\file_buckets.obj" \
     "$(INTDIR)\headers_buckets.obj" \
     "$(INTDIR)\incoming.obj" \
+    "$(INTDIR)\iovec_buckets.obj" \
     "$(INTDIR)\limit_buckets.obj" \
     "$(INTDIR)\mmap_buckets.obj" \
     "$(INTDIR)\outgoing.obj" \
@@ -143,6 +145,7 @@
     "$(INTDIR)\test_context.obj" \
     "$(INTDIR)\test_buckets.obj" \
     "$(INTDIR)\test_ssl.obj" \
+    "$(INTDIR)\test_server.obj" \
 
 TEST_LIBS = user32.lib advapi32.lib gdi32.lib ws2_32.lib
 
@@ -192,6 +195,11 @@
     $(CPP_PROJ) $<
 <<
 
+{test\server}.c{$(INTDIR)}.obj: 
+  $(CPP) @<<
+    $(CPP_PROJ) $<
+<<
+
 $(INTDIR)\serf_response.exe: $(INTDIR)\serf_response.obj $(STATIC_LIB)
   $(LIB32) /DEBUG /OUT:$@ $** $(LIB32_FLAGS) $(TEST_LIBS)
 

=== modified file 'serf_bucket_types.h'
--- serf_bucket_types.h	2011-06-03 03:18:07 +0000
+++ serf_bucket_types.h	2011-06-27 18:09:28 +0000
@@ -455,7 +455,7 @@
 
 serf_bucket_t *serf_bucket_limit_create(
     serf_bucket_t *stream,
-    apr_size_t limit,
+    apr_uint64_t limit,
     serf_bucket_alloc_t *allocator);
 
 
@@ -514,6 +514,12 @@
     serf_ssl_context_t *context);
 
 /**
+ * Allow SNI indicators to be sent to the server.
+ */
+apr_status_t serf_ssl_set_hostname(
+    serf_ssl_context_t *context, const char *hostname);
+
+/**
  * Return the depth of the certificate.
  */
 int serf_ssl_cert_depth(
@@ -606,6 +612,17 @@
 
 /* ==================================================================== */
 
+extern const serf_bucket_type_t serf_bucket_type_iovec;
+#define SERF_BUCKET_IS_IOVEC(b) SERF_BUCKET_CHECK((b), iovec)
+
+serf_bucket_t *serf_bucket_iovec_create(
+    struct iovec vecs[],
+    int len,
+    serf_bucket_alloc_t *allocator);
+
+
+/* ==================================================================== */
+
 /* ### do we need a PIPE bucket type? they are simple apr_file_t objects */
 
 

=== modified file 'serf_bucket_util.h'
--- serf_bucket_util.h	2011-06-03 03:18:07 +0000
+++ serf_bucket_util.h	2011-06-27 18:09:28 +0000
@@ -97,29 +97,6 @@
 void serf_default_destroy_and_data(
     serf_bucket_t *bucket);
 
-/**
- * Default implementation of the @see snapshot functionality
- *
- * This function will return an error to indicate it's not implemented.
- */
-apr_status_t serf_default_snapshot(
-    serf_bucket_t *bucket);
-
-/*
- * Default implementation of the @see restore_snapshot functionality
- *
- * This function will return an error to indicate it's not implemented.
- */
-apr_status_t serf_default_restore_snapshot(
-    serf_bucket_t *bucket);
-
-/*
- * Default implementation of the @see is_snapshot_set functionality
- *
- * This function will return 0 (no snapshot set).
- */
-int serf_default_is_snapshot_set(
-    serf_bucket_t *bucket);
 
 /**
  * Allocate @a size bytes of memory using @a allocator.

=== modified file 'serf_private.h'
--- serf_private.h	2011-06-03 03:18:07 +0000
+++ serf_private.h	2011-06-27 18:09:28 +0000
@@ -65,6 +65,7 @@
     serf_bucket_t *resp_bkt;
 
     int written;
+    int priority;
 
     struct serf_request_t *next;
 };
@@ -123,7 +124,7 @@
     apr_pool_t *pool;
     apr_pollfd_t desc;
     void *accept_baton;
-    serf_accept_client_t accept;
+    serf_accept_client_t accept_func;
 };
 
 struct serf_incoming_t {
@@ -135,6 +136,15 @@
     apr_pollfd_t desc;
 };
 
+/* States for the different stages in the lifecyle of a connection. */
+typedef enum {
+    SERF_CONN_INIT,             /* no socket created yet */
+    SERF_CONN_SETUP_SSLTUNNEL,  /* ssl tunnel being setup, no requests sent */
+    SERF_CONN_CONNECTED,        /* conn is ready to send requests */
+    SERF_CONN_CLOSING,          /* conn is closing, no more requests,
+                                   start a new socket */
+} serf__connection_state_t;
+
 struct serf_connection_t {
     serf_context_t *ctx;
 
@@ -167,10 +177,8 @@
     /* keepalive */
     unsigned int probable_keepalive_limit;
 
-    /* someone has told us that the connection is closing
-     * so, let's start a new socket.
-     */
-    int closing;
+    /* Current state of the connection (whether or not it is connected). */
+    serf__connection_state_t state;
 
     /* This connection may have responses without a request! */
     int async_responses;
@@ -188,6 +196,9 @@
     serf_bucket_t *ostream_head;
     serf_bucket_t *ostream_tail;
 
+    /* Aggregate bucket used to send the CONNECT request. */
+    serf_bucket_t *ssltunnel_ostream;
+
     /* The list of active requests. */
     serf_request_t *requests;
     serf_request_t *requests_tail;
@@ -336,4 +347,7 @@
                                        apr_int16_t events);
 apr_status_t serf__conn_update_pollset(serf_connection_t *conn);
 
+/* from ssltunnel.c */
+apr_status_t serf__ssltunnel_connect(serf_connection_t *conn);
+
 #endif

=== modified file 'serfmake'
--- serfmake	2011-06-03 03:18:07 +0000
+++ serfmake	2011-06-27 18:09:28 +0000
@@ -5,6 +5,10 @@
 import shutil
 import sys
 import stat
+import copy
+
+LIBNAME = 'libserf-1'
+INCLUDES = 'serf-1'
 
 FILES_HDR = [
   ('.', 'serf'),
@@ -16,6 +20,7 @@
   ('.', 'context'),
   ('.', 'incoming'),
   ('.', 'outgoing'),
+  ('.', 'ssltunnel'),
 
   ('buckets', 'aggregate_buckets'),
   ('buckets', 'request_buckets'),
@@ -33,6 +38,7 @@
   ('buckets', 'ssl_buckets'),
   ('buckets', 'barrier_buckets'),
   ('buckets', 'chunk_buckets'),
+  ('buckets', 'iovec_buckets'),
   ('auth', 'auth'),
   ('auth', 'auth_basic'),
   ('auth', 'auth_digest'),
@@ -46,6 +52,7 @@
   ('test', 'test_context'),
   ('test', 'test_buckets'),
   ('test', 'test_ssl'),
+  ('test/server', 'test_server'),
   ]
 
 TEST_HDR_FILES = [
@@ -121,12 +128,12 @@
 
 def cmd_build(param):
   builder = Builder(param)
-  builder.build_target(File('.', 'libserf-0', 'la'), False)
+  builder.build_target(File('.', LIBNAME, 'la'), False)
 
 
 def cmd_install(param):
   builder = Builder(param)
-  builder.install_target(File('.', 'libserf-0', 'la'), False)
+  builder.install_target(File('.', LIBNAME, 'la'), False)
 
 
 def cmd_check(param):
@@ -149,7 +156,7 @@
 def cmd_clean(param):
   targets = [File(dirpath, fname, 'o') for dirpath, fname in LIB_FILES]
   targets += [File(dirpath, fname, 'lo') for dirpath, fname in LIB_FILES]
-  targets += [File('.', 'libserf-0', 'la')]
+  targets += [File('.', LIBNAME, 'la')]
   targets += [File(dirpath, fname, 'o') for dirpath, fname in TEST_FILES]
   targets += [File(dirpath, fname, 'lo') for dirpath, fname in TEST_FILES]
   targets += [File(dirpath, fname, None) for dirpath, fname in TEST_FILES]
@@ -177,10 +184,10 @@
 
     try:
       self.libdir = os.path.join(params['prefix'], 'lib')
-      self.includedir = os.path.join(params['prefix'], 'include', 'serf-0')
+      self.includedir = os.path.join(params['prefix'], 'include', INCLUDES)
     except:
       self.libdir = '/usr/local/lib'
-      self.includedir = '/usr/local/include/serf-0'
+      self.includedir = '/usr/local/include/' + INCLUDES
 
     self.load_vars()
     self.load_deps()
@@ -220,14 +227,14 @@
 
     self.hdrs = hdrs
 
-    lib = File('.', 'libserf-0', 'la')
+    lib = File('.', LIBNAME, 'la')
     cmd = '%s --silent --mode=link %s %s -rpath %s -o %s %s %s' % (
       self.LIBTOOL, self.CC, self.LDFLAGS, self.libdir,
       lib.fname, ' '.join([l.fname for l in libobjs]), self.LIBS)
     self._add_dep(lib, libobjs, cmd)
 
     # load the test program dependencies now
-    testhdrs = hdrs
+    testhdrs = copy.deepcopy(hdrs)
     testhdrs += [File(dirpath, fname, 'h') for dirpath, fname in TEST_HDR_FILES]
     testdeps = [File(dirpath, fname, 'c') for dirpath, fname in TEST_DEPS]
     testobjs = [File(dirpath, fname, 'lo') for dirpath, fname in TEST_DEPS]

=== added file 'ssltunnel.c'
--- ssltunnel.c	1970-01-01 00:00:00 +0000
+++ ssltunnel.c	2011-06-27 18:09:28 +0000
@@ -0,0 +1,168 @@
+/* Copyright 2011 Justin Erenkrantz and Greg Stein
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+/*** Setup a SSL tunnel over a HTTP proxy, according to RFC 2817. ***/
+
+#include <apr_pools.h>
+#include <apr_strings.h>
+
+#include "serf.h"
+#include "serf_private.h"
+
+
+/* Structure passed around as baton for the CONNECT request and respone. */
+typedef struct {
+    apr_pool_t *pool;
+    const char *uri;
+} req_ctx_t;
+
+/* forward declaration. */
+static apr_status_t setup_request(serf_request_t *request,
+                                  void *setup_baton,
+                                  serf_bucket_t **req_bkt,
+                                  serf_response_acceptor_t *acceptor,
+                                  void **acceptor_baton,
+                                  serf_response_handler_t *handler,
+                                  void **handler_baton,
+                                  apr_pool_t *pool);
+
+static serf_bucket_t* accept_response(serf_request_t *request,
+                                      serf_bucket_t *stream,
+                                      void *acceptor_baton,
+                                      apr_pool_t *pool)
+{
+    serf_bucket_t *c;
+    serf_bucket_alloc_t *bkt_alloc;
+#if 0
+    req_ctx_t *ctx = acceptor_baton;
+#endif
+
+    /* get the per-request bucket allocator */
+    bkt_alloc = serf_request_get_alloc(request);
+
+    /* Create a barrier so the response doesn't eat us! */
+    c = serf_bucket_barrier_create(stream, bkt_alloc);
+
+    return serf_bucket_response_create(c, bkt_alloc);
+}
+
+/* If a 200 OK was received for the CONNECT request, consider the connection
+   as ready for use. */
+static apr_status_t handle_response(serf_request_t *request,
+                                    serf_bucket_t *response,
+                                    void *handler_baton,
+                                    apr_pool_t *pool)
+{
+    apr_status_t status;
+    serf_status_line sl;
+    req_ctx_t *ctx = handler_baton;
+
+    if (! response) {
+        serf_connection_request_create(request->conn,
+                                       setup_request,
+                                       ctx);
+        return APR_SUCCESS;
+    }
+
+    status = serf_bucket_response_status(response, &sl);
+    if (SERF_BUCKET_READ_ERROR(status)) {
+        return status;
+    }
+    if (!sl.version && (APR_STATUS_IS_EOF(status) ||
+                      APR_STATUS_IS_EAGAIN(status)))
+    {
+        return status;
+    }
+
+    status = serf_bucket_response_wait_for_headers(response);
+    if (status && !APR_STATUS_IS_EOF(status)) {
+        return status;
+    }
+
+    /* Body is supposed to be empty. */
+    if (sl.code == 200) {
+        request->conn->state = SERF_CONN_CONNECTED;
+
+        apr_pool_destroy(ctx->pool);
+        serf_bucket_destroy(request->conn->ssltunnel_ostream);
+        request->conn->stream = NULL;
+        ctx = NULL;
+
+        return APR_EOF;
+    }
+
+    /* Authentication failure and 200 Ok are handled at this point,
+       the rest are errors. */
+    return APR_EGENERAL; /* TODO: better error code */
+}
+
+/* Prepare the CONNECT request. */
+static apr_status_t setup_request(serf_request_t *request,
+                                  void *setup_baton,
+                                  serf_bucket_t **req_bkt,
+                                  serf_response_acceptor_t *acceptor,
+                                  void **acceptor_baton,
+                                  serf_response_handler_t *handler,
+                                  void **handler_baton,
+                                  apr_pool_t *pool)
+{
+    req_ctx_t *ctx = setup_baton;
+
+    *req_bkt =
+        serf_request_bucket_request_create(request,
+                                           "CONNECT", ctx->uri,
+                                           NULL,
+                                           serf_request_get_alloc(request));
+    *acceptor = accept_response;
+    *acceptor_baton = ctx;
+    *handler = handle_response;
+    *handler_baton = ctx;
+
+    return APR_SUCCESS;
+}
+
+static apr_status_t detect_eof(void *baton, serf_bucket_t *aggregate_bucket)
+{
+    serf_connection_t *conn = baton;
+    conn->hit_eof = 1;
+    return APR_EAGAIN;
+}
+
+/* SSL tunnel is needed, push a CONNECT request on the connection. */
+apr_status_t serf__ssltunnel_connect(serf_connection_t *conn)
+{
+    req_ctx_t *ctx;
+    apr_pool_t *ssltunnel_pool;
+
+    apr_pool_create(&ssltunnel_pool, conn->pool);
+
+    ctx = apr_palloc(ssltunnel_pool, sizeof(*ctx));
+    ctx->pool = ssltunnel_pool;
+    ctx->uri = apr_psprintf(ctx->pool, "%s:%d", conn->host_info.hostinfo,
+                            conn->host_info.port);
+
+    conn->ssltunnel_ostream = serf__bucket_stream_create(conn->allocator,
+                                                         detect_eof,
+                                                         conn);
+
+    /* TODO: should be the first request on the connection. */
+    serf_connection_priority_request_create(conn,
+                                            setup_request,
+                                            ctx);
+
+    conn->state = SERF_CONN_SETUP_SSLTUNNEL;
+
+    return APR_SUCCESS;
+}

=== modified file 'test/serf_get.c'
--- test/serf_get.c	2011-06-03 03:18:07 +0000
+++ test/serf_get.c	2011-06-27 18:09:28 +0000
@@ -26,6 +26,7 @@
 #include "serf.h"
 
 typedef struct {
+    const char *hostinfo;
     int using_ssl;
     serf_ssl_context_t *ssl_ctx;
     serf_bucket_alloc_t *bkt_alloc;
@@ -64,6 +65,7 @@
             ctx->ssl_ctx = serf_bucket_ssl_decrypt_context_get(c);
         }
         serf_ssl_server_cert_callback_set(ctx->ssl_ctx, ignore_all_cert_errors, NULL);
+        serf_ssl_set_hostname(ctx->ssl_ctx, ctx->hostinfo);
 
         *output_bkt = serf_bucket_ssl_encrypt_create(*output_bkt, ctx->ssl_ctx,
                                                     ctx->bkt_alloc);
@@ -346,6 +348,8 @@
         app_ctx.using_ssl = 0;
     }
 
+    app_ctx.hostinfo = url.hostinfo;
+
     context = serf_context_create(pool);
 
     if (proxy)

=== added directory 'test/server'
=== added file 'test/server/test_server.c'
--- test/server/test_server.c	1970-01-01 00:00:00 +0000
+++ test/server/test_server.c	2011-06-27 18:09:28 +0000
@@ -0,0 +1,358 @@
+/* Copyright 2011 Justin Erenkrantz and Greg Stein
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include "apr.h"
+#include "apr_pools.h"
+#include <apr_poll.h>
+#include <apr_version.h>
+#include <stdlib.h>
+
+#include "serf.h"
+
+#include "test_server.h"
+
+struct serv_ctx_t {
+    /* Pool for resource allocation. */
+    apr_pool_t *pool;
+
+    apr_int32_t options;
+
+    /* Array of actions which server will replay when client connected. */
+    test_server_action_t *action_list;
+    /* Size of action_list array. */
+    apr_size_t action_count;
+    /* Index of current action. */
+    apr_size_t cur_action;
+
+    /* Array of messages the server will receive from the client. */
+    test_server_message_t *message_list;
+    /* Size of message_list array. */
+    apr_size_t message_count;
+    /* Index of current message. */
+    apr_size_t cur_message;
+
+    /* Number of messages received that the server didn't respond to yet. */
+    apr_size_t outstanding_responses;
+
+    /* Position in message buffer (incoming messages being read). */
+    apr_size_t message_buf_pos;
+
+    /* Position in action buffer. (outgoing messages being sent). */
+    apr_size_t action_buf_pos;
+
+    /* Address for server binding. */
+    apr_sockaddr_t *serv_addr;
+    apr_socket_t *serv_sock;
+
+    /* Accepted client socket. NULL if there is no client socket. */
+    apr_socket_t *client_sock;
+
+};
+
+/* Replay support functions */
+static void next_message(serv_ctx_t *servctx)
+{
+    servctx->cur_message++;
+}
+
+static void next_action(serv_ctx_t *servctx)
+{
+    servctx->cur_action++;
+    servctx->action_buf_pos = 0;
+}
+
+/* Verify received requests and take the necessary actions
+   (return a response, kill the connection ...) */
+static apr_status_t replay(serv_ctx_t *servctx,
+                           apr_int16_t rtnevents,
+                           apr_pool_t *pool)
+{
+    apr_status_t status = APR_SUCCESS;
+    test_server_action_t *action;
+
+    if (rtnevents & APR_POLLIN) {
+        if (servctx->message_list == NULL) {
+            /* we're not expecting any requests to reach this server! */
+            printf("Received request where none was expected\n");
+
+            return APR_EGENERAL;
+        }
+
+        if (servctx->cur_action >= servctx->action_count) {
+            char buf[128];
+            apr_size_t len = sizeof(buf);
+
+            status = apr_socket_recv(servctx->client_sock, buf, &len);
+            if (! APR_STATUS_IS_EAGAIN(status)) {
+                /* we're out of actions! */
+                printf("Received more requests than expected.\n");
+
+                return APR_EGENERAL;
+            }
+            return status;
+        }
+
+        action = &servctx->action_list[servctx->cur_action];
+
+        if (action->kind == SERVER_IGNORE_AND_KILL_CONNECTION) {
+            char buf[128];
+            apr_size_t len = sizeof(buf);
+
+            status = apr_socket_recv(servctx->client_sock, buf, &len);
+
+            if (status == APR_EOF) {
+                apr_socket_close(servctx->client_sock);
+                servctx->client_sock = NULL;
+                next_action(servctx);
+                return APR_SUCCESS;
+            }
+
+            return status;
+        }
+        else if (action->kind == SERVER_RECV ||
+                 (action->kind == SERVER_RESPOND &&
+                  servctx->outstanding_responses == 0)) {
+            apr_size_t msg_len, len;
+            char buf[128];
+            test_server_message_t *message;
+
+            message = &servctx->message_list[servctx->cur_message];
+            msg_len = strlen(message->text);
+
+            len = msg_len - servctx->message_buf_pos;
+            if (len > sizeof(buf))
+                len = sizeof(buf);
+
+            status = apr_socket_recv(servctx->client_sock, buf, &len);
+            if (status != APR_SUCCESS)
+                return status;
+
+            if (servctx->options & TEST_SERVER_DUMP)
+                fwrite(buf, len, 1, stdout);
+
+            if (strncmp(buf, message->text + servctx->message_buf_pos, len) != 0) {
+                /* ## TODO: Better diagnostics. */
+                printf("Expected: (\n");
+                fwrite(message->text + servctx->message_buf_pos, len, 1, stdout);
+                printf(")\n");
+                printf("Actual: (\n");
+                fwrite(buf, len, 1, stdout);
+                printf(")\n");
+
+                return APR_EGENERAL;
+            }
+
+            servctx->message_buf_pos += len;
+
+            if (servctx->message_buf_pos >= msg_len) {
+                next_message(servctx);
+                servctx->message_buf_pos -= msg_len;
+                if (action->kind == SERVER_RESPOND)
+                    servctx->outstanding_responses++;
+                if (action->kind == SERVER_RECV)
+                    next_action(servctx);
+            }
+        }
+    }
+    if (rtnevents & APR_POLLOUT) {
+        action = &servctx->action_list[servctx->cur_action];
+
+        if (action->kind == SERVER_RESPOND && servctx->outstanding_responses) {
+            apr_size_t msg_len;
+            apr_size_t len;
+
+            msg_len = strlen(action->text);
+            len = msg_len - servctx->action_buf_pos;
+
+            status = apr_socket_send(servctx->client_sock,
+                                     action->text + servctx->action_buf_pos, &len);
+            if (status != APR_SUCCESS)
+                return status;
+
+            if (servctx->options & TEST_SERVER_DUMP)
+                fwrite(action->text + servctx->action_buf_pos, len, 1, stdout);
+
+            servctx->action_buf_pos += len;
+
+            if (servctx->action_buf_pos >= msg_len) {
+                next_action(servctx);
+                servctx->outstanding_responses--;
+            }
+        }
+        else if (action->kind == SERVER_KILL_CONNECTION ||
+                 action->kind == SERVER_IGNORE_AND_KILL_CONNECTION) {
+            apr_socket_close(servctx->client_sock);
+            servctx->client_sock = NULL;
+            next_action(servctx);
+        }
+    }
+    else if (rtnevents & APR_POLLIN) {
+        /* ignore */
+    }
+    else {
+        printf("Unknown rtnevents: %d\n", rtnevents);
+        abort();
+    }
+
+    return status;
+}
+
+apr_status_t test_server_run(serv_ctx_t *servctx,
+                             apr_short_interval_time_t duration,
+                             apr_pool_t *pool)
+{
+    apr_status_t status;
+    apr_pollset_t *pollset;
+    apr_int32_t num;
+    const apr_pollfd_t *desc;
+
+    /* create a new pollset */
+    status = apr_pollset_create(&pollset, 32, pool, 0);
+    if (status != APR_SUCCESS)
+        return status;
+
+    /* Don't accept new connection while processing client connection. At
+       least for present time.*/
+    if (servctx->client_sock) {
+        apr_pollfd_t pfd = { pool, APR_POLL_SOCKET, APR_POLLIN | APR_POLLOUT, 0,
+                             { NULL }, NULL };
+        pfd.desc.s = servctx->client_sock;
+        status = apr_pollset_add(pollset, &pfd);
+        if (status != APR_SUCCESS)
+            goto cleanup;
+    }
+    else {
+        apr_pollfd_t pfd = { pool, APR_POLL_SOCKET, APR_POLLIN, 0,
+                             { NULL }, NULL };
+        pfd.desc.s = servctx->serv_sock;
+        status = apr_pollset_add(pollset, &pfd);
+        if (status != APR_SUCCESS)
+            goto cleanup;
+    }
+
+    status = apr_pollset_poll(pollset, APR_USEC_PER_SEC >> 1, &num, &desc);
+    if (status != APR_SUCCESS)
+        goto cleanup;
+
+    while (num--) {
+        if (desc->desc.s == servctx->serv_sock) {
+            status = apr_socket_accept(&servctx->client_sock, servctx->serv_sock,
+                                       servctx->pool);
+            if (status != APR_SUCCESS)
+                goto cleanup;
+
+            apr_socket_opt_set(servctx->client_sock, APR_SO_NONBLOCK, 1);
+            apr_socket_timeout_set(servctx->client_sock, 0);
+
+            status = APR_SUCCESS;
+            goto cleanup;
+        }
+
+        if (desc->desc.s == servctx->client_sock) {
+            /* Replay data to socket. */
+            status = replay(servctx, desc->rtnevents, pool);
+
+            if (APR_STATUS_IS_EOF(status)) {
+                apr_socket_close(servctx->client_sock);
+                servctx->client_sock = NULL;
+            }
+            else if (APR_STATUS_IS_EAGAIN(status)) {
+                status = APR_SUCCESS;
+            }
+            else if (status != APR_SUCCESS) {
+                /* Real error. */
+                goto cleanup;
+            }
+        }
+
+        desc++;
+    }
+
+cleanup:
+    apr_pollset_destroy(pollset);
+
+    return status;
+}
+
+/* Start a TCP server on port SERV_PORT in thread THREAD. srv_replay is a array
+   of action to replay when connection started. replay_count is count of
+   actions in srv_replay. */
+apr_status_t test_start_server(serv_ctx_t **servctx_p,
+                               apr_sockaddr_t *address,
+                               test_server_message_t *message_list,
+                               apr_size_t message_count,
+                               test_server_action_t *action_list,
+                               apr_size_t action_count,
+                               apr_int32_t options,
+                               apr_pool_t *pool)
+{
+    apr_status_t status;
+    apr_socket_t *serv_sock;
+    serv_ctx_t *servctx;
+
+    servctx = apr_pcalloc(pool, sizeof(*servctx));
+    *servctx_p = servctx;
+
+    servctx->serv_addr = address;
+    servctx->options = options;
+    servctx->pool = pool;
+    servctx->message_list = message_list;
+    servctx->message_count = message_count;
+    servctx->action_list = action_list;
+    servctx->action_count = action_count;
+
+    /* create server socket */
+#if APR_VERSION_AT_LEAST(1, 0, 0)
+    status = apr_socket_create(&serv_sock, APR_UNSPEC, SOCK_STREAM, 0, pool);
+#else
+    status = apr_socket_create(&serv_sock, APR_UNSPEC, SOCK_STREAM, pool);
+#endif
+
+    if (status != APR_SUCCESS)
+        return status;
+
+    apr_socket_opt_set(serv_sock, APR_SO_NONBLOCK, 1);
+    apr_socket_timeout_set(serv_sock, 0);
+    apr_socket_opt_set(serv_sock, APR_SO_REUSEADDR, 1);
+
+    status = apr_socket_bind(serv_sock, servctx->serv_addr);
+    if (status != APR_SUCCESS)
+        return status;
+
+    /* Start replay from first action. */
+    servctx->cur_action = 0;
+    servctx->action_buf_pos = 0;
+    servctx->outstanding_responses = 0;
+
+    /* listen for clients */
+    apr_socket_listen(serv_sock, SOMAXCONN);
+    if (status != APR_SUCCESS)
+        return status;
+
+    servctx->serv_sock = serv_sock;
+    servctx->client_sock = NULL;
+    return APR_SUCCESS;
+}
+
+apr_status_t test_server_destroy(serv_ctx_t *servctx, apr_pool_t *pool)
+{
+    apr_socket_close(servctx->serv_sock);
+
+    if (servctx->client_sock) {
+        apr_socket_close(servctx->client_sock);
+    }
+
+    return APR_SUCCESS;
+}

=== added file 'test/server/test_server.h'
--- test/server/test_server.h	1970-01-01 00:00:00 +0000
+++ test/server/test_server.h	2011-06-27 18:09:28 +0000
@@ -0,0 +1,70 @@
+/* Copyright 2011 Justin Erenkrantz and Greg Stein
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef TEST_SERVER_H
+#define TEST_SERVER_H
+
+typedef struct serv_ctx_t serv_ctx_t;
+
+#define TEST_SERVER_DUMP 1
+
+/* Default port for our test server. */
+#define SERV_PORT 12345
+#define SERV_PORT_STR "12345"
+
+#define PROXY_PORT 23456
+
+typedef struct
+{
+    enum {
+        SERVER_RECV,
+        SERVER_SEND,
+        SERVER_RESPOND,
+        SERVER_IGNORE_AND_KILL_CONNECTION,
+        SERVER_KILL_CONNECTION
+    } kind;
+
+    const char *text;
+} test_server_action_t;
+
+typedef struct
+{
+    const char *text;
+} test_server_message_t;
+
+apr_status_t test_start_server(serv_ctx_t **servctx_p,
+                               apr_sockaddr_t *address,
+                               test_server_message_t *message_list,
+                               apr_size_t message_count,
+                               test_server_action_t *action_list,
+                               apr_size_t action_count,
+                               apr_int32_t options,
+                               apr_pool_t *pool);
+
+apr_status_t test_server_run(serv_ctx_t *servctx,
+                             apr_short_interval_time_t duration,
+                             apr_pool_t *pool);
+
+apr_status_t test_server_destroy(serv_ctx_t *servctx, apr_pool_t *pool);
+
+#ifndef APR_VERSION_AT_LEAST /* Introduced in APR 1.3.0 */
+#define APR_VERSION_AT_LEAST(major,minor,patch)                  \
+(((major) < APR_MAJOR_VERSION)                                       \
+ || ((major) == APR_MAJOR_VERSION && (minor) < APR_MINOR_VERSION)    \
+ || ((major) == APR_MAJOR_VERSION && (minor) == APR_MINOR_VERSION && \
+     (patch) <= APR_PATCH_VERSION))
+#endif /* APR_VERSION_AT_LEAST */
+
+#endif /* TEST_SERVER_H */

=== modified file 'test/test_all.c'
--- test/test_all.c	2008-06-22 11:14:06 +0000
+++ test/test_all.c	2011-06-27 18:09:28 +0000
@@ -18,9 +18,6 @@
 #include "test_serf.h"
 #include <stdlib.h>
 
-/* Top-level pool which can be used by tests. */
-apr_pool_t *test_pool;
-
 static const struct testlist {
     const char *testname;
     CuSuite *(*func)(void);
@@ -42,8 +39,6 @@
     apr_initialize();
     atexit(apr_terminate);
 
-    apr_pool_create(&test_pool, NULL);
-
     for (i = 1; i < argc; i++) {
         if (!strcmp(argv[i], "-v")) {
             continue;
@@ -102,7 +97,5 @@
     CuSuiteFreeDeep(alltests);
     CuStringFree(output);
 
-    apr_pool_destroy(test_pool);
-
     return exit_code;
 }

=== modified file 'test/test_buckets.c'
--- test/test_buckets.c	2011-06-03 03:18:07 +0000
+++ test/test_buckets.c	2011-06-27 18:09:28 +0000
@@ -24,14 +24,16 @@
 
 static void test_simple_bucket_readline(CuTest *tc)
 {
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
     apr_status_t status;
     serf_bucket_t *bkt;
     const char *data;
     int found;
     apr_size_t len;
 
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
     bkt = SERF_BUCKET_SIMPLE_STRING(
         "line1" CRLF
         "line2",
@@ -56,6 +58,7 @@
     CuAssertIntEquals(tc, SERF_NEWLINE_NONE, found);
     CuAssertIntEquals(tc, 5, len);
     CuAssert(tc, data, strncmp("line2", data, len) == 0);
+    test_teardown(test_pool);
 }
 
 /* Reads bucket until EOF found and compares read data with zero terminated
@@ -85,10 +88,12 @@
 
 static void test_response_bucket_read(CuTest *tc)
 {
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
     serf_bucket_t *bkt, *tmp;
 
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
     tmp = SERF_BUCKET_SIMPLE_STRING(
         "HTTP/1.1 200 OK" CRLF
         "Content-Length: 7" CRLF
@@ -100,14 +105,17 @@
 
     /* Read all bucket and check it content. */
     read_and_check_bucket(tc, bkt, "abc1234");
+    test_teardown(test_pool);
 }
 
 static void test_response_bucket_headers(CuTest *tc)
 {
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
     serf_bucket_t *bkt, *tmp, *hdr;
 
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
     tmp = SERF_BUCKET_SIMPLE_STRING(
         "HTTP/1.1 405 Method Not Allowed" CRLF
         "Date: Sat, 12 Jun 2010 14:17:10 GMT"  CRLF
@@ -135,14 +143,17 @@
     CuAssertStrEquals(tc,
         "",
         serf_bucket_headers_get(hdr, "NoSpace"));
+    test_teardown(test_pool);
 }
 
 static void test_response_bucket_chunked_read(CuTest *tc)
 {
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
     serf_bucket_t *bkt, *tmp, *hdrs;
 
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
     tmp = SERF_BUCKET_SIMPLE_STRING(
         "HTTP/1.1 200 OK" CRLF
         "Transfer-Encoding: chunked" CRLF
@@ -166,10 +177,12 @@
 
     /* Check that trailing headers parsed correctly. */
     CuAssertStrEquals(tc, "value", serf_bucket_headers_get(hdrs, "Footer"));
+    test_teardown(test_pool);
 }
 
 static void test_bucket_header_set(CuTest *tc)
 {
+    apr_pool_t *test_pool = test_setup();
     serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
                                                               NULL);
     serf_bucket_t *hdrs = serf_bucket_headers_create(alloc);
@@ -190,55 +203,7 @@
 
     // headers are case insensitive.
     CuAssertStrEquals(tc, "bar,baz,test", serf_bucket_headers_get(hdrs, "fOo"));
-}
-
-static void test_simple_read_restore_snapshot_read(CuTest *tc)
-{
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
-    apr_status_t status;
-    serf_bucket_t *bkt;
-    const char *data;
-    int found;
-    apr_size_t len;
-
-    bkt = SERF_BUCKET_SIMPLE_STRING(
-        "line1" CRLF
-        "line2",
-        alloc);
-
-    /* Take snapshot. */
-    status = serf_bucket_snapshot(bkt);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-    /* Read the first line of text from the bucket. */
-    status = serf_bucket_readline(bkt, SERF_NEWLINE_CRLF, &found, &data, &len);
-
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-    CuAssertIntEquals(tc, SERF_NEWLINE_CRLF, found);
-    CuAssertIntEquals(tc, 7, len);
-    CuAssert(tc, data, strncmp("line1" CRLF, data, len) == 0);
-
-    /* Restore the buckets original content. */
-    CuAssertTrue(tc, serf_bucket_is_snapshot_set(bkt) != 0);
-    status = serf_bucket_restore_snapshot(bkt);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-    CuAssertTrue(tc, serf_bucket_is_snapshot_set(bkt) == 0);
-
-    /* Now read both lines from the bucket. */
-    status = serf_bucket_readline(bkt, SERF_NEWLINE_CRLF, &found, &data, &len);
-
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-    CuAssertIntEquals(tc, SERF_NEWLINE_CRLF, found);
-    CuAssertIntEquals(tc, 7, len);
-    CuAssert(tc, data, strncmp("line1" CRLF, data, len) == 0);
-
-    status = serf_bucket_readline(bkt, SERF_NEWLINE_CRLF, &found, &data, &len);
-
-    CuAssertIntEquals(tc, APR_EOF, status);
-    CuAssertIntEquals(tc, SERF_NEWLINE_NONE, found);
-    CuAssertIntEquals(tc, 5, len);
-    CuAssert(tc, data, strncmp("line2", data, len) == 0);
+    test_teardown(test_pool);
 }
 
 static apr_status_t read_requested_bytes(serf_bucket_t *bkt,
@@ -266,53 +231,182 @@
     return status;
 }
 
-static void test_aggregate_read_restore_snapshot_read(CuTest *tc)
+
+static void test_iovec_buckets(CuTest *tc)
 {
-    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
-                                                              NULL);
     apr_status_t status;
-    serf_bucket_t *bkt;
-    serf_bucket_t *tmp;
+    serf_bucket_t *bkt, *iobkt;
     const char *data;
     apr_size_t len;
-
-    bkt = serf_bucket_aggregate_create(alloc);
-
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN("<", 1, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN("tagname", 7, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN(">", 1, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN("value", 5, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN("</", 2, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN("tagname", 7, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-    tmp = SERF_BUCKET_SIMPLE_STRING_LEN(">", 1, alloc);
-    serf_bucket_aggregate_append(bkt, tmp);
-
-    /* Take snapshot. */
-    status = serf_bucket_snapshot(bkt);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-    status = read_requested_bytes(bkt, 9, &data, &len, test_pool);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-    CuAssertIntEquals(tc, 9, len);
-    CuAssert(tc, data, strncmp("<tagname>", data, len) == 0);
-
-    CuAssertTrue(tc, serf_bucket_is_snapshot_set(bkt) != 0);
-    status = serf_bucket_restore_snapshot(bkt);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-    CuAssertTrue(tc, serf_bucket_is_snapshot_set(bkt) == 0);
-
-    /* Ask more bytes than expected, just to make sure that we get 
-       everything. */
-    status = read_requested_bytes(bkt, 50, &data, &len, test_pool);
-    CuAssertIntEquals(tc, APR_EOF, status);
-    CuAssertIntEquals(tc, 24, len);
-    CuAssert(tc, data, strncmp("<tagname>value</tagname>", data, len) == 0);
+    struct iovec vecs[32];
+    struct iovec tgt_vecs[32];
+    int i;
+    int vecs_used;
+
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
+    /* Test 1: Read a single string in an iovec, store it in a iovec_bucket
+       and then read it back. */
+    bkt = SERF_BUCKET_SIMPLE_STRING(
+        "line1" CRLF
+        "line2",
+        alloc);
+
+    status = serf_bucket_read_iovec(bkt, SERF_READ_ALL_AVAIL, 32, vecs,
+                                    &vecs_used);
+
+    iobkt = serf_bucket_iovec_create(vecs, vecs_used, alloc);
+
+    /* Check available data */
+    status = serf_bucket_peek(iobkt, &data, &len);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, strlen("line1" CRLF "line2"), len);
+
+    /* Try to read only a few bytes (less than what's in the first buffer). */
+    status = serf_bucket_read_iovec(iobkt, 3, 32, tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 1, vecs_used);
+    CuAssertIntEquals(tc, 3, tgt_vecs[0].iov_len);
+    CuAssert(tc, tgt_vecs[0].iov_base,
+             strncmp("lin", tgt_vecs[0].iov_base, tgt_vecs[0].iov_len) == 0);
+
+    /* Read the rest of the data. */
+    status = serf_bucket_read_iovec(iobkt, SERF_READ_ALL_AVAIL, 32, tgt_vecs,
+                                    &vecs_used);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 1, vecs_used);
+    CuAssertIntEquals(tc, strlen("e1" CRLF "line2"), tgt_vecs[0].iov_len);
+    CuAssert(tc, tgt_vecs[0].iov_base,
+             strncmp("e1" CRLF "line2", tgt_vecs[0].iov_base, tgt_vecs[0].iov_len - 3) == 0);
+
+    /* Bucket should now be empty */
+    status = serf_bucket_peek(iobkt, &data, &len);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 0, len);
+
+    /* Test 2: Read multiple character bufs in an iovec, then read them back
+       in bursts. */
+    for (i = 0; i < 32 ; i++) {
+        vecs[i].iov_base = apr_psprintf(test_pool, "data %02d 901234567890", i);
+        vecs[i].iov_len = strlen(vecs[i].iov_base);
+    }
+
+    iobkt = serf_bucket_iovec_create(vecs, 32, alloc);
+
+    /* Check that some data is in the buffer. Don't verify the actual data, the
+       amount of data returned is not guaranteed to be the full buffer. */
+    status = serf_bucket_peek(iobkt, &data, &len);
+    CuAssertTrue(tc, len > 0);
+    CuAssertIntEquals(tc, APR_SUCCESS, status); /* this assumes not all data is
+                                                   returned at once,
+                                                   not guaranteed! */
+
+    /* Read 1 buf.   20 = sizeof("data %2d 901234567890") */
+    status = serf_bucket_read_iovec(iobkt, 1 * 20, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 1, vecs_used);
+    CuAssert(tc, tgt_vecs[0].iov_base,
+             strncmp("data 00 901234567890", tgt_vecs[0].iov_base, tgt_vecs[0].iov_len) == 0);
+
+    /* Read 2 bufs. */
+    status = serf_bucket_read_iovec(iobkt, 2 * 20, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 2, vecs_used);
+
+    /* Read the remaining 29 bufs. */
+    vecs_used = 400;  /* test if iovec code correctly resets vecs_used */
+    status = serf_bucket_read_iovec(iobkt, SERF_READ_ALL_AVAIL, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 29, vecs_used);
+
+    /* Test 3: use serf_bucket_read */
+    for (i = 0; i < 32 ; i++) {
+        vecs[i].iov_base = apr_psprintf(test_pool, "DATA %02d 901234567890", i);
+        vecs[i].iov_len = strlen(vecs[i].iov_base);
+    }
+
+    iobkt = serf_bucket_iovec_create(vecs, 32, alloc);
+
+    status = serf_bucket_read(iobkt, 10, &data, &len);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 10, len);
+    CuAssert(tc, data,
+             strncmp("DATA 00 90", data, len) == 0);
+
+    status = serf_bucket_read(iobkt, 10, &data, &len);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 10, len);
+    CuAssert(tc, tgt_vecs[0].iov_base,
+             strncmp("1234567890", data, len) == 0);
+
+    for (i = 1; i < 31 ; i++) {
+        const char *exp = apr_psprintf(test_pool, "DATA %02d 901234567890", i);
+        status = serf_bucket_read(iobkt, SERF_READ_ALL_AVAIL, &data, &len);
+        CuAssertIntEquals(tc, APR_SUCCESS, status);
+        CuAssertIntEquals(tc, 20, len);
+        CuAssert(tc, data,
+                 strncmp(exp, data, len) == 0);
+
+    }
+
+    status = serf_bucket_read(iobkt, 20, &data, &len);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 20, len);
+    CuAssert(tc, data,
+             strncmp("DATA 31 901234567890", data, len) == 0);
+
+    /* Test 3: read an empty iovec */
+    iobkt = serf_bucket_iovec_create(vecs, 0, alloc);
+    status = serf_bucket_read_iovec(iobkt, SERF_READ_ALL_AVAIL, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 0, vecs_used);
+
+    status = serf_bucket_read(iobkt, SERF_READ_ALL_AVAIL, &data, &len);
+    CuAssertIntEquals(tc, APR_EOF, status);
+    CuAssertIntEquals(tc, 0, len);
+
+    /* Test 4: read 0 bytes from an iovec */
+    bkt = SERF_BUCKET_SIMPLE_STRING("line1" CRLF, alloc);
+    status = serf_bucket_read_iovec(bkt, SERF_READ_ALL_AVAIL, 32, vecs,
+                                    &vecs_used);
+    iobkt = serf_bucket_iovec_create(vecs, vecs_used, alloc);
+    status = serf_bucket_read_iovec(iobkt, 0, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 0, vecs_used);
+
+    test_teardown(test_pool);
+}
+
+static void test_aggregate_buckets(CuTest *tc)
+{
+    apr_status_t status;
+    serf_bucket_t *bkt, *aggbkt;
+    struct iovec tgt_vecs[32];
+    int vecs_used;
+
+    apr_pool_t *test_pool = test_setup();
+    serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
+                                                              NULL);
+
+    /* Test 1: read 0 bytes from an aggregate */
+    aggbkt = serf_bucket_aggregate_create(alloc);
+
+    bkt = SERF_BUCKET_SIMPLE_STRING("line1" CRLF, alloc);
+    serf_bucket_aggregate_append(aggbkt, bkt);
+
+    status = serf_bucket_read_iovec(aggbkt, 0, 32,
+                                    tgt_vecs, &vecs_used);
+    CuAssertIntEquals(tc, APR_SUCCESS, status);
+    CuAssertIntEquals(tc, 0, vecs_used);
+
+    test_teardown(test_pool);
 }
 
 CuSuite *test_buckets(void)
@@ -324,8 +418,8 @@
     SUITE_ADD_TEST(suite, test_response_bucket_headers);
     SUITE_ADD_TEST(suite, test_response_bucket_chunked_read);
     SUITE_ADD_TEST(suite, test_bucket_header_set);
-    SUITE_ADD_TEST(suite, test_simple_read_restore_snapshot_read);
-    SUITE_ADD_TEST(suite, test_aggregate_read_restore_snapshot_read);
+    SUITE_ADD_TEST(suite, test_iovec_buckets);
+    SUITE_ADD_TEST(suite, test_aggregate_buckets);
 
     return suite;
 }

=== modified file 'test/test_context.c'
--- test/test_context.c	2011-06-03 03:18:07 +0000
+++ test/test_context.c	2011-06-27 18:09:28 +0000
@@ -23,6 +23,7 @@
 #include "serf.h"
 
 #include "test_serf.h"
+#include "server/test_server.h"
 
 typedef struct {
     serf_response_acceptor_t acceptor;
@@ -39,9 +40,6 @@
     const char *path;
     int done;
 
-    const char *server_root;
-    int use_proxy;
-
     test_baton_t *tb;
 } handler_baton_t;
 
@@ -146,46 +144,25 @@
     apr_array_header_t *accepted_requests, *handled_requests, *sent_requests;
     int i;
     test_server_message_t message_list[] = {
-        {"GET / HTTP/1.1" CRLF
-         "Transfer-Encoding: chunked" CRLF
-         CRLF
-         "1" CRLF
-         "1" CRLF
-         "0" CRLF
-         CRLF},
-        {"GET / HTTP/1.1" CRLF
-         "Transfer-Encoding: chunked" CRLF
-         "" CRLF
-         "1" CRLF
-         "2" CRLF
-         "0" CRLF
-         CRLF}
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
     };
 
     test_server_action_t action_list[] = {
-        {SERVER_RESPOND,
-         "HTTP/1.1 200 OK" CRLF
-         "Transfer-Encoding: chunked" CRLF
-         CRLF
-         "0" CRLF
-         CRLF},
-        {SERVER_RESPOND,
-         "HTTP/1.1 200 OK" CRLF
-         "Transfer-Encoding: chunked" CRLF
-         CRLF
-         "0" CRLF
-         CRLF}
+        {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
+        {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
+    apr_pool_t *test_pool = test_setup();
 
     accepted_requests = apr_array_make(test_pool, 2, sizeof(int));
     sent_requests = apr_array_make(test_pool, 2, sizeof(int));
     handled_requests = apr_array_make(test_pool, 2, sizeof(int));
 
     /* Set up a test context with a server */
-    status = test_server_create(&tb,
-                                message_list, 2,
-                                action_list, 2, 0, NULL, NULL, NULL,
-                                test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 2,
+                               action_list, 2, 0, NULL,
+                               test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     handler_ctx.method = "GET";
@@ -199,8 +176,6 @@
     handler_ctx.accepted_requests = accepted_requests;
     handler_ctx.sent_requests = sent_requests;
     handler_ctx.handled_requests = handled_requests;
-    handler_ctx.use_proxy = FALSE;
-    handler_ctx.server_root = NULL;
 
     request1 = serf_connection_request_create(tb->connection,
                                               setup_request,
@@ -219,7 +194,7 @@
     {
         apr_pool_clear(iter_pool);
 
-        status = test_server_run(tb, 0, iter_pool);
+        status = test_server_run(tb->serv_ctx, 0, iter_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -228,9 +203,6 @@
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-        /* Debugging purposes only! */
-        serf_debug__closed_conn(tb->bkt_alloc);
     }
     apr_pool_destroy(iter_pool);
 
@@ -251,7 +223,8 @@
         CuAssertIntEquals(tc, i + 1, req_nr);
     }
 
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 
 /* Validate that priority requests are sent and completed before normal
@@ -267,9 +240,9 @@
     int i;
 
     test_server_message_t message_list[] = {
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "2")},
-        {CHUNCKED_REQUEST(1, "3")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
+        {CHUNKED_REQUEST(1, "3")},
     };
 
     test_server_action_t action_list[] = {
@@ -278,15 +251,17 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, 3, sizeof(int));
     sent_requests = apr_array_make(test_pool, 3, sizeof(int));
     handled_requests = apr_array_make(test_pool, 3, sizeof(int));
 
     /* Set up a test context with a server */
-    status = test_server_create(&tb,
-                                message_list, 3,
-                                action_list, 3, 0, NULL, NULL, NULL,
-                                test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 3,
+                               action_list, 3, 0, NULL,
+                               test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     handler_ctx.method = "GET";
@@ -300,8 +275,6 @@
     handler_ctx.accepted_requests = accepted_requests;
     handler_ctx.sent_requests = sent_requests;
     handler_ctx.handled_requests = handled_requests;
-    handler_ctx.use_proxy = FALSE;
-    handler_ctx.server_root = NULL;
 
     request1 = serf_connection_request_create(tb->connection,
                                               setup_request,
@@ -326,7 +299,7 @@
     {
         apr_pool_clear(iter_pool);
 
-        status = test_server_run(tb, 0, iter_pool);
+        status = test_server_run(tb->serv_ctx, 0, iter_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -358,7 +331,8 @@
         CuAssertIntEquals(tc, i + 1, req_nr);
     }
 
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 
 /* Test that serf correctly handles the 'Connection:close' header when the
@@ -373,16 +347,16 @@
     int done = FALSE, i;
 
     test_server_message_t message_list[] = {
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "2")},
-        {CHUNCKED_REQUEST(1, "3")},
-        {CHUNCKED_REQUEST(1, "4")},
-        {CHUNCKED_REQUEST(1, "5")},
-        {CHUNCKED_REQUEST(1, "6")},
-        {CHUNCKED_REQUEST(1, "7")},
-        {CHUNCKED_REQUEST(1, "8")},
-        {CHUNCKED_REQUEST(1, "9")},
-        {CHUNCKED_REQUEST(2, "10")}
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
+        {CHUNKED_REQUEST(1, "3")},
+        {CHUNKED_REQUEST(1, "4")},
+        {CHUNKED_REQUEST(1, "5")},
+        {CHUNKED_REQUEST(1, "6")},
+        {CHUNKED_REQUEST(1, "7")},
+        {CHUNKED_REQUEST(1, "8")},
+        {CHUNKED_REQUEST(1, "9")},
+        {CHUNKED_REQUEST(2, "10")}
         };
 
     test_server_action_t action_list[] = {
@@ -414,17 +388,19 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
     sent_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
     handled_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
 
     /* Set up a test context with a server. */
-    status = test_server_create(&tb,
-                                message_list, 10,
-                                action_list, 12,
-                                0,
-                                NULL, NULL, NULL,
-                                test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 10,
+                               action_list, 12,
+                               0,
+                               NULL,
+                               test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     for (i = 0 ; i < NUM_REQUESTS ; i++) {
@@ -441,8 +417,6 @@
         handler_ctx[i].sent_requests = sent_requests;
         handler_ctx[i].handled_requests = handled_requests;
         handler_ctx[i].tb = tb;
-        handler_ctx[i].use_proxy = FALSE;
-        handler_ctx[i].server_root = NULL;
 
         serf_connection_request_create(tb->connection,
                                        setup_request,
@@ -450,7 +424,7 @@
     }
 
     while (1) {
-        status = test_server_run(tb, 0, test_pool);
+        status = test_server_run(tb->serv_ctx, 0, test_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -479,7 +453,8 @@
     CuAssertIntEquals(tc, NUM_REQUESTS, handled_requests->nelts);
 
     /* Cleanup */
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 #undef NUM_REQUESTS
 
@@ -487,7 +462,7 @@
    directly. */
 static void test_serf_setup_proxy(CuTest *tc)
 {
-    test_baton_t *tb_server, *tb_proxy;
+    test_baton_t *tb;
     serf_request_t *request;
     handler_baton_t handler_ctx;
     apr_status_t status;
@@ -512,30 +487,22 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, numrequests, sizeof(int));
     sent_requests = apr_array_make(test_pool, numrequests, sizeof(int));
     handled_requests = apr_array_make(test_pool, numrequests, sizeof(int));
 
     /* Set up a test context with a server, no messages expected. */
-    status = test_server_create(&tb_server,
-                                NULL, 0,
-                                NULL, 0, 0,
-                                "http://localhost:" SERV_PORT_STR, NULL,
-                                NULL, test_pool);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-    /* Set up another test context for the proxy server */
-    status = apr_sockaddr_info_get(&proxy_address,
-                                   "localhost", APR_INET, 21212, 0,
-                                   test_pool);
-    CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-    status = test_server_create(&tb_proxy,
-                                message_list, 1,
-                                action_list_proxy, 1, 0,
-                                NULL, proxy_address, NULL,
-                                test_pool);
-
+    status = test_server_proxy_setup(&tb,
+                                     /* server messages and actions */
+                                     NULL, 0,
+                                     NULL, 0,
+                                     /* server messages and actions */
+                                     message_list, 1,
+                                     action_list_proxy, 1,
+                                     0,
+                                     NULL, test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     handler_ctx.method = "GET";
@@ -549,13 +516,8 @@
     handler_ctx.accepted_requests = accepted_requests;
     handler_ctx.sent_requests = sent_requests;
     handler_ctx.handled_requests = handled_requests;
-    handler_ctx.use_proxy = TRUE;
-    handler_ctx.server_root = "http://localhost:" SERV_PORT_STR;
-
-    /* Configure serf to use the proxy server */
-    serf_config_proxy(tb_server->context, proxy_address);
-
-    request = serf_connection_request_create(tb_server->connection,
+
+    request = serf_connection_request_create(tb->connection,
                                              setup_request,
                                              &handler_ctx);
 
@@ -565,23 +527,23 @@
     {
         apr_pool_clear(iter_pool);
 
-        status = test_server_run(tb_server, 0, iter_pool);
-        if (APR_STATUS_IS_TIMEUP(status))
-            status = APR_SUCCESS;
-        CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-        status = test_server_run(tb_proxy, 0, iter_pool);
-        if (APR_STATUS_IS_TIMEUP(status))
-            status = APR_SUCCESS;
-        CuAssertIntEquals(tc, APR_SUCCESS, status);
-
-        status = serf_context_run(tb_server->context, 0, iter_pool);
+        status = test_server_run(tb->serv_ctx, 0, iter_pool);
+        if (APR_STATUS_IS_TIMEUP(status))
+            status = APR_SUCCESS;
+        CuAssertIntEquals(tc, APR_SUCCESS, status);
+
+        status = test_server_run(tb->proxy_ctx, 0, iter_pool);
+        if (APR_STATUS_IS_TIMEUP(status))
+            status = APR_SUCCESS;
+        CuAssertIntEquals(tc, APR_SUCCESS, status);
+
+        status = serf_context_run(tb->context, 0, iter_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
 
         /* Debugging purposes only! */
-        serf_debug__closed_conn(tb_server->bkt_alloc);
+        serf_debug__closed_conn(tb->bkt_alloc);
     }
     apr_pool_destroy(iter_pool);
 
@@ -602,7 +564,8 @@
         CuAssertIntEquals(tc, i + 1, req_nr);
     }
 
-    test_server_destroy(tb_server, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 
 /*****************************************************************************
@@ -661,13 +624,13 @@
     int done = FALSE, i;
 
     test_server_message_t message_list[] = {
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "2")},
-        {CHUNCKED_REQUEST(1, "3")},
-        {CHUNCKED_REQUEST(1, "4")},
-        {CHUNCKED_REQUEST(1, "5")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
+        {CHUNKED_REQUEST(1, "3")},
+        {CHUNKED_REQUEST(1, "4")},
+        {CHUNKED_REQUEST(1, "5")},
     };
 
     test_server_action_t action_list[] = {
@@ -680,15 +643,17 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
     sent_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
     handled_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
 
     /* Set up a test context with a server. */
-    status = test_server_create(&tb,
-                                message_list, 7,
-                                action_list, 7, 0, NULL, NULL, NULL,
-                                test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 7,
+                               action_list, 7, 0, NULL,
+                               test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     for (i = 0 ; i < SEND_REQUESTS ; i++) {
@@ -705,8 +670,6 @@
         handler_ctx[i].sent_requests = sent_requests;
         handler_ctx[i].handled_requests = handled_requests;
         handler_ctx[i].tb = tb;
-        handler_ctx[i].use_proxy = FALSE;
-        handler_ctx[i].server_root = NULL;
 
         serf_connection_request_create(tb->connection,
                                        setup_request,
@@ -715,7 +678,7 @@
     }
 
     while (1) {
-        status = test_server_run(tb, 0, test_pool);
+        status = test_server_run(tb->serv_ctx, 0, test_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -744,7 +707,8 @@
     CuAssertIntEquals(tc, RCVD_REQUESTS, handled_requests->nelts);
 
     /* Cleanup */
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 #undef SEND_REQUESTS
 #undef RCVD_REQUESTS
@@ -814,13 +778,13 @@
     int done = FALSE, i;
 
     test_server_message_t message_list[] = {
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "2")},
-        {CHUNCKED_REQUEST(1, "3")},
-        {CHUNCKED_REQUEST(1, "4")},
-        {CHUNCKED_REQUEST(1, "5")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
+        {CHUNKED_REQUEST(1, "3")},
+        {CHUNKED_REQUEST(1, "4")},
+        {CHUNKED_REQUEST(1, "5")},
     };
 
     test_server_action_t action_list[] = {
@@ -833,15 +797,17 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
     sent_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
     handled_requests = apr_array_make(test_pool, RCVD_REQUESTS, sizeof(int));
 
     /* Set up a test context with a server. */
-    status = test_server_create(&tb,
-                                message_list, 7,
-                                action_list, 7, 0, NULL, NULL, NULL, 
-                                test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 7,
+                               action_list, 7, 0, NULL,
+                               test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     for (i = 0 ; i < SEND_REQUESTS ; i++) {
@@ -858,8 +824,6 @@
         handler_ctx[i].sent_requests = sent_requests;
         handler_ctx[i].handled_requests = handled_requests;
         handler_ctx[i].tb = tb;
-        handler_ctx[i].use_proxy = FALSE;
-        handler_ctx[i].server_root = NULL;
 
         serf_connection_request_create(tb->connection,
                                        setup_request,
@@ -868,7 +832,7 @@
     }
 
     while (1) {
-        status = test_server_run(tb, 0, test_pool);
+        status = test_server_run(tb->serv_ctx, 0, test_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -897,7 +861,8 @@
     CuAssertIntEquals(tc, RCVD_REQUESTS, handled_requests->nelts);
 
     /* Cleanup */
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 #undef SEND_REQUESTS
 #undef RCVD_REQUESTS
@@ -939,11 +904,11 @@
     progress_baton_t *pb;
 
     test_server_message_t message_list[] = {
-        {CHUNCKED_REQUEST(1, "1")},
-        {CHUNCKED_REQUEST(1, "2")},
-        {CHUNCKED_REQUEST(1, "3")},
-        {CHUNCKED_REQUEST(1, "4")},
-        {CHUNCKED_REQUEST(1, "5")},
+        {CHUNKED_REQUEST(1, "1")},
+        {CHUNKED_REQUEST(1, "2")},
+        {CHUNKED_REQUEST(1, "3")},
+        {CHUNKED_REQUEST(1, "4")},
+        {CHUNKED_REQUEST(1, "5")},
     };
 
     test_server_action_t action_list[] = {
@@ -954,15 +919,17 @@
         {SERVER_RESPOND, CHUNKED_EMPTY_RESPONSE},
     };
 
+    apr_pool_t *test_pool = test_setup();
+
     accepted_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
     sent_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
     handled_requests = apr_array_make(test_pool, NUM_REQUESTS, sizeof(int));
 
     /* Set up a test context with a server. */
-    status = test_server_create(&tb,
-                                message_list, 5,
-                                action_list, 5, 0, NULL, NULL, 
-                                progress_conn_setup, test_pool);
+    status = test_server_setup(&tb,
+                               message_list, 5,
+                               action_list, 5, 0,
+                               progress_conn_setup, test_pool);
     CuAssertIntEquals(tc, APR_SUCCESS, status);
 
     /* Set up the progress callback. */
@@ -984,8 +951,6 @@
         handler_ctx[i].sent_requests = sent_requests;
         handler_ctx[i].handled_requests = handled_requests;
         handler_ctx[i].tb = tb;
-        handler_ctx[i].use_proxy = FALSE;
-        handler_ctx[i].server_root = NULL;
 
         serf_connection_request_create(tb->connection,
                                        setup_request,
@@ -993,7 +958,7 @@
     }
 
     while (1) {
-        status = test_server_run(tb, 0, test_pool);
+        status = test_server_run(tb->serv_ctx, 0, test_pool);
         if (APR_STATUS_IS_TIMEUP(status))
             status = APR_SUCCESS;
         CuAssertIntEquals(tc, APR_SUCCESS, status);
@@ -1026,7 +991,8 @@
     CuAssertTrue(tc, pb->read > 0);
 
     /* Cleanup */
-    test_server_destroy(tb, test_pool);
+    test_server_teardown(tb, test_pool);
+    test_teardown(test_pool);
 }
 #undef NUM_REQUESTS
 

=== modified file 'test/test_serf.h'
--- test/test_serf.h	2011-06-03 03:18:07 +0000
+++ test/test_serf.h	2011-06-27 18:09:28 +0000
@@ -23,6 +23,7 @@
 #include <apr_uri.h>
 
 #include "serf.h"
+#include "server/test_server.h"
 
 /** These macros are provided by APR itself from version 1.3.
  * Definitions are provided here for when using older versions of APR.
@@ -38,8 +39,6 @@
 #define APR_ARRAY_PUSH(ary,type) (*((type *)apr_array_push(ary)))
 #endif
 
-extern apr_pool_t *test_pool;
-
 /* CuTest declarations */
 CuSuite *getsuite(void);
 
@@ -51,8 +50,9 @@
 
 #define CRLF "\r\n"
 
-#define CHUNCKED_REQUEST(len, body)\
+#define CHUNKED_REQUEST(len, body)\
         "GET / HTTP/1.1" CRLF\
+        "Host: localhost:12345" CRLF\
         "Transfer-Encoding: chunked" CRLF\
         CRLF\
         #len CRLF\
@@ -76,24 +76,6 @@
         "0" CRLF\
         CRLF
 
-typedef struct
-{
-    enum {
-        SERVER_RECV,
-        SERVER_SEND,
-        SERVER_RESPOND,
-        SERVER_IGNORE_AND_KILL_CONNECTION,
-        SERVER_KILL_CONNECTION
-    } kind;
-
-    const char *text;
-} test_server_action_t;
-
-typedef struct
-{
-    const char *text;
-} test_server_message_t;
-
 typedef struct {
     /* Pool for resource allocation. */
     apr_pool_t *pool;
@@ -101,72 +83,44 @@
     serf_context_t *context;
     serf_connection_t *connection;
     serf_bucket_alloc_t *bkt_alloc;
-    apr_int32_t options;
-
-    /* Array of actions which server will replay when client connected. */
-    test_server_action_t *action_list;
-    /* Size of action_list array. */
-    apr_size_t action_count;
-    /* Index of current action. */
-    apr_size_t cur_action;
-
-    /* Array of messages the server will receive from the client. */
-    test_server_message_t *message_list;
-    /* Size of message_list array. */
-    apr_size_t message_count;
-    /* Index of current message. */
-    apr_size_t cur_message;
-
-    /* Number of messages received that the server didn't respond to yet. */
-    apr_size_t outstanding_responses;
-
-    /* Position in message buffer (incoming messages being read). */
-    apr_size_t message_buf_pos;
-
-    /* Position in action buffer. (outgoing messages being sent). */
-    apr_size_t action_buf_pos;
-
-    /* Address for server binding. */
+
+    serv_ctx_t *serv_ctx;
     apr_sockaddr_t *serv_addr;
-    apr_socket_t *serv_sock;
 
-    /* Accepted client socket. NULL if there is no client socket. */
-    apr_socket_t *client_sock;
+    serv_ctx_t *proxy_ctx;
+    apr_sockaddr_t *proxy_addr;
 
     /* An extra baton which can be freely used by tests. */
     void *user_baton;
 
 } test_baton_t;
 
-#define TEST_SERVER_DUMP 1
-
-/* Default port for our test server. */
-#define SERV_PORT 12345
-#define SERV_PORT_STR "12345"
-
-apr_status_t test_server_create(test_baton_t **tb,
-                                test_server_message_t *message_list,
-                                apr_size_t message_count,
-                                test_server_action_t *action_list,
-                                apr_size_t action_count,
-                                apr_int32_t options,
-                                const char *host_url,
-                                apr_sockaddr_t *address,
-                                serf_connection_setup_t conn_setup,
-                                apr_pool_t *pool);
-
-apr_status_t test_server_run(test_baton_t *tb,
-                             apr_short_interval_time_t duration,
-                             apr_pool_t *pool);
-
-apr_status_t test_server_destroy(test_baton_t *tb, apr_pool_t *pool);
-
-#ifndef APR_VERSION_AT_LEAST /* Introduced in APR 1.3.0 */
-#define APR_VERSION_AT_LEAST(major,minor,patch)                  \
-(((major) < APR_MAJOR_VERSION)                                       \
- || ((major) == APR_MAJOR_VERSION && (minor) < APR_MINOR_VERSION)    \
- || ((major) == APR_MAJOR_VERSION && (minor) == APR_MINOR_VERSION && \
-     (patch) <= APR_PATCH_VERSION))
-#endif /* APR_VERSION_AT_LEAST */
+apr_status_t test_server_setup(test_baton_t **tb_p,
+                               test_server_message_t *message_list,
+                               apr_size_t message_count,
+                               test_server_action_t *action_list,
+                               apr_size_t action_count,
+                               apr_int32_t options,
+                               serf_connection_setup_t conn_setup,
+                               apr_pool_t *pool);
+
+apr_status_t test_server_proxy_setup(
+                 test_baton_t **tb_p,
+                 test_server_message_t *serv_message_list,
+                 apr_size_t serv_message_count,
+                 test_server_action_t *serv_action_list,
+                 apr_size_t serv_action_count,
+                 test_server_message_t *proxy_message_list,
+                 apr_size_t proxy_message_count,
+                 test_server_action_t *proxy_action_list,
+                 apr_size_t proxy_action_count,
+                 apr_int32_t options,
+                 serf_connection_setup_t conn_setup,
+                 apr_pool_t *pool);
+
+apr_status_t test_server_teardown(test_baton_t *tb, apr_pool_t *pool);
+
+apr_pool_t *test_setup();
+void test_teardown(apr_pool_t *test_pool);
 
 #endif /* TEST_SERF_H */

=== modified file 'test/test_ssl.c'
--- test/test_ssl.c	2011-06-03 03:18:07 +0000
+++ test/test_ssl.c	2011-06-27 18:09:28 +0000
@@ -32,10 +32,12 @@
 static void test_ssl_init(CuTest *tc)
 {
     serf_bucket_t *bkt, *stream;
+    serf_ssl_context_t *ssl_context;
+    apr_status_t status;
+
+    apr_pool_t *test_pool = test_setup();
     serf_bucket_alloc_t *alloc = serf_bucket_allocator_create(test_pool, NULL,
                                                               NULL);
-    serf_ssl_context_t *ssl_context;
-    apr_status_t status;
 
     stream = SERF_BUCKET_SIMPLE_STRING("", alloc);
 
@@ -49,34 +51,38 @@
     status = serf_ssl_use_default_certificates(ssl_context);
 
     CuAssertIntEquals(tc, APR_SUCCESS, status);
+    test_teardown(test_pool);
 }
 
 /* Test that loading a custom CA certificate file works. */
 static void test_ssl_load_cert_file(CuTest *tc)
 {
     serf_ssl_certificate_t *cert = NULL;
+
+    apr_pool_t *test_pool = test_setup();
     apr_status_t status = serf_ssl_load_cert_file(&cert, "test/serftestca.pem",
                                                   test_pool);
 
     CuAssertIntEquals(tc, APR_SUCCESS, status);
     CuAssertPtrNotNull(tc, cert);
+    test_teardown(test_pool);
 }
 
 /* Test that reading a custom CA certificate file works. */
 static void test_ssl_cert_subject(CuTest *tc)
 {
-    apr_pool_t *subpool;
     apr_hash_t *subject;
     serf_ssl_certificate_t *cert = NULL;
     apr_status_t status;
 
-    apr_pool_create(&subpool, test_pool);
-    status = serf_ssl_load_cert_file(&cert, "test/serftestca.pem", subpool);
+    apr_pool_t *test_pool = test_setup();
+
+    status = serf_ssl_load_cert_file(&cert, "test/serftestca.pem", test_pool);
 
     CuAssertIntEquals(tc, APR_SUCCESS, status);
     CuAssertPtrNotNull(tc, cert);
 
-    subject = serf_ssl_cert_subject(cert, subpool);
+    subject = serf_ssl_cert_subject(cert, test_pool);
     CuAssertStrEquals(tc, "Test Suite", 
                       apr_hash_get(subject, "OU", APR_HASH_KEY_STRING));
     CuAssertStrEquals(tc, "In Serf we trust, Inc.", 
@@ -90,7 +96,7 @@
     CuAssertStrEquals(tc, "serf@example.com", 
                       apr_hash_get(subject, "E", APR_HASH_KEY_STRING));
 
-    apr_pool_destroy(subpool);
+    test_teardown(test_pool);
 }
 
 CuSuite *test_ssl(void)

=== modified file 'test/test_util.c'
--- test/test_util.c	2011-06-03 03:18:07 +0000
+++ test/test_util.c	2011-06-27 18:09:28 +0000
@@ -15,18 +15,36 @@
 
 #include "apr.h"
 #include "apr_pools.h"
-#include <apr_poll.h>
-#include <apr_version.h>
 #include <stdlib.h>
 
 #include "serf.h"
 
 #include "test_serf.h"
+#include "server/test_server.h"
+
 
 /*****************************************************************************/
-/* Server setup functions
+/* Server setup function(s)
  */
 
+#define SERV_URL "http://localhost:" SERV_PORT_STR
+
+static apr_status_t default_server_address(apr_sockaddr_t **address,
+                                           apr_pool_t *pool)
+{
+    return apr_sockaddr_info_get(address,
+                                 "localhost", APR_UNSPEC, SERV_PORT, 0,
+                                 pool);
+}
+
+static apr_status_t default_proxy_address(apr_sockaddr_t **address,
+                                          apr_pool_t *pool)
+{
+    return apr_sockaddr_info_get(address,
+                                 "localhost", APR_UNSPEC, PROXY_PORT, 0,
+                                 pool);
+}
+
 /* Default implementation of a serf_connection_closed_t callback. */
 static void default_closed_connection(serf_connection_t *conn,
                                       void *closed_baton,
@@ -51,358 +69,146 @@
     return APR_SUCCESS;
 }
 
-static apr_status_t get_server_address(apr_sockaddr_t **address,
-                                       apr_pool_t *pool)
-{
-    return apr_sockaddr_info_get(address,
-                                 "localhost", APR_INET, SERV_PORT, 0,
-                                 pool);
-}
-
-static void next_message(test_baton_t *tb)
-{
-    tb->cur_message++;
-}
-
-static void next_action(test_baton_t *tb)
-{
-    tb->cur_action++;
-    tb->action_buf_pos = 0;
-}
-
-static apr_status_t replay(test_baton_t *tb,
-                           apr_int16_t rtnevents,
-                           apr_pool_t *pool)
-{
-    apr_status_t status = APR_SUCCESS;
-    test_server_action_t *action;
-
-    if (rtnevents & APR_POLLIN) {
-        if (tb->message_list == NULL) {
-            /* we're not expecting any requests to reach this server! */
-            printf("Received request where none was expected\n");
-
-            return APR_EGENERAL;
-        }
-
-        if (tb->cur_action >= tb->action_count) {
-            char buf[128];
-            apr_size_t len = sizeof(buf);
-
-            status = apr_socket_recv(tb->client_sock, buf, &len);
-            if (! APR_STATUS_IS_EAGAIN(status)) {
-                /* we're out of actions! */
-                printf("Received more requests than expected.\n");
-
-                return APR_EGENERAL;
-            }
-            return status;
-        }
-
-        action = &tb->action_list[tb->cur_action];
-
-        if (action->kind == SERVER_IGNORE_AND_KILL_CONNECTION) {
-            char buf[128];
-            apr_size_t len = sizeof(buf);
-
-            status = apr_socket_recv(tb->client_sock, buf, &len);
-
-            if (status == APR_EOF) {
-                apr_socket_close(tb->client_sock);
-                tb->client_sock = NULL;
-                next_action(tb);
-                return APR_SUCCESS;
-            }
-
-            return status;
-        }
-        else if (action->kind == SERVER_RECV ||
-                 (action->kind == SERVER_RESPOND &&
-                  tb->outstanding_responses == 0)) {
-            apr_size_t msg_len, len;
-            char buf[128];
-            test_server_message_t *message;
-
-            message = &tb->message_list[tb->cur_message];
-            msg_len = strlen(message->text);
-
-            len = msg_len - tb->message_buf_pos;
-            if (len > sizeof(buf))
-                len = sizeof(buf);
-
-            status = apr_socket_recv(tb->client_sock, buf, &len);
-            if (status != APR_SUCCESS)
-                return status;
-
-            if (tb->options & TEST_SERVER_DUMP)
-                fwrite(buf, len, 1, stdout);
-
-            if (strncmp(buf, message->text + tb->message_buf_pos, len) != 0) {
-                /* ## TODO: Better diagnostics. */
-                printf("Expected: (\n");
-                fwrite(message->text + tb->message_buf_pos, len, 1, stdout);
-                printf(")\n");
-                printf("Actual: (\n");
-                fwrite(buf, len, 1, stdout);
-                printf(")\n");
-
-                return APR_EGENERAL;
-            }
-
-            tb->message_buf_pos += len;
-
-            if (tb->message_buf_pos >= msg_len) {
-                next_message(tb);
-                tb->message_buf_pos -= msg_len;
-                if (action->kind == SERVER_RESPOND)
-                    tb->outstanding_responses++;
-                if (action->kind == SERVER_RECV)
-                    next_action(tb);
-            }
-        }
-    }
-    if (rtnevents & APR_POLLOUT) {
-        action = &tb->action_list[tb->cur_action];
-
-        if (action->kind == SERVER_RESPOND && tb->outstanding_responses) {
-            apr_size_t msg_len;
-            apr_size_t len;
-
-            msg_len = strlen(action->text);
-            len = msg_len - tb->action_buf_pos;
-
-            status = apr_socket_send(tb->client_sock,
-                                     action->text + tb->action_buf_pos, &len);
-            if (status != APR_SUCCESS)
-                return status;
-
-            if (tb->options & TEST_SERVER_DUMP)
-                fwrite(action->text + tb->action_buf_pos, len, 1, stdout);
-
-            tb->action_buf_pos += len;
-
-            if (tb->action_buf_pos >= msg_len) {
-                next_action(tb);
-                tb->outstanding_responses--;
-            }
-        }
-    }
-    else if (action->kind == SERVER_KILL_CONNECTION ||
-             action->kind == SERVER_IGNORE_AND_KILL_CONNECTION) {
-        apr_socket_close(tb->client_sock);
-        tb->client_sock = NULL;
-        next_action(tb);
-    }
-    else if (rtnevents & APR_POLLIN) {
-        /* ignore */
-    }
-    else {
-        printf("Unknown rtnevents: %d\n", rtnevents);
-        abort();
-    }
-
-    return status;
-}
-
-apr_status_t test_server_run(test_baton_t *tb,
-                             apr_short_interval_time_t duration,
-                             apr_pool_t *pool)
-{
-    apr_status_t status;
-    apr_pollset_t *pollset;
-    apr_int32_t num;
-    const apr_pollfd_t *desc;
-
-    /* create a new pollset */
-    status = apr_pollset_create(&pollset, 32, pool, 0);
-    if (status != APR_SUCCESS)
-        return status;
-
-    /* Don't accept new connection while processing client connection. At
-       least for present time.*/
-    if (tb->client_sock) {
-        apr_pollfd_t pfd = { pool, APR_POLL_SOCKET, APR_POLLIN | APR_POLLOUT, 0,
-                             { NULL }, NULL };
-        pfd.desc.s = tb->client_sock;
-        status = apr_pollset_add(pollset, &pfd);
-        if (status != APR_SUCCESS)
-            goto cleanup;
-    }
-    else {
-        apr_pollfd_t pfd = { pool, APR_POLL_SOCKET, APR_POLLIN, 0,
-                             { NULL }, NULL };
-        pfd.desc.s = tb->serv_sock;
-        status = apr_pollset_add(pollset, &pfd);
-        if (status != APR_SUCCESS)
-            goto cleanup;
-    }
-
-    status = apr_pollset_poll(pollset, APR_USEC_PER_SEC >> 1, &num, &desc);
-    if (status != APR_SUCCESS)
-        goto cleanup;
-
-    while (num--) {
-        if (desc->desc.s == tb->serv_sock) {
-            status = apr_socket_accept(&tb->client_sock, tb->serv_sock,
-                                       tb->pool);
-            if (status != APR_SUCCESS)
-                goto cleanup;
-
-            apr_socket_opt_set(tb->client_sock, APR_SO_NONBLOCK, 1);
-            apr_socket_timeout_set(tb->client_sock, 0);
-
-            status = APR_SUCCESS;
-            goto cleanup;
-        }
-
-        if (desc->desc.s == tb->client_sock) {
-            /* Replay data to socket. */
-            status = replay(tb, desc->rtnevents, pool);
-
-            if (APR_STATUS_IS_EOF(status)) {
-                apr_socket_close(tb->client_sock);
-                tb->client_sock = NULL;
-            }
-            else if (APR_STATUS_IS_EAGAIN(status)) {
-                status = APR_SUCCESS;
-            }
-            else if (status != APR_SUCCESS) {
-                /* Real error. */
-                goto cleanup;
-            }
-        }
-
-        desc++;
-    }
-
-cleanup:
-    apr_pollset_destroy(pollset);
-
-    return status;
-}
-
-/* Start a TCP server on port SERV_PORT in thread THREAD. srv_replay is a array
-   of action to replay when connection started. replay_count is count of
-   actions in srv_replay. */
-static apr_status_t prepare_server(test_baton_t *tb,
-                                   apr_pool_t *pool)
-{
-    apr_status_t status;
-    apr_socket_t *serv_sock;
-
-    /* create server socket */
-#if APR_VERSION_AT_LEAST(1, 0, 0)
-    status = apr_socket_create(&serv_sock, APR_INET, SOCK_STREAM, 0, pool);
-#else
-    status = apr_socket_create(&serv_sock, APR_INET, SOCK_STREAM, pool);
-#endif
-
-    if (status != APR_SUCCESS)
-        return status;
-
-    apr_socket_opt_set(serv_sock, APR_SO_NONBLOCK, 1);
-    apr_socket_timeout_set(serv_sock, 0);
-    apr_socket_opt_set(serv_sock, APR_SO_REUSEADDR, 1);
-
-    status = apr_socket_bind(serv_sock, tb->serv_addr);
-    if (status != APR_SUCCESS)
-        return status;
-
-    /* Start replay from first action. */
-    tb->cur_action = 0;
-    tb->action_buf_pos = 0;
-    tb->outstanding_responses = 0;
-
-    /* listen for clients */
-    apr_socket_listen(serv_sock, SOMAXCONN);
-    if (status != APR_SUCCESS)
-        return status;
-
-    tb->serv_sock = serv_sock;
-    tb->client_sock = NULL;
-    return APR_SUCCESS;
-}
-
-/*****************************************************************************/
-
-apr_status_t test_server_create(test_baton_t **tb_p,
-                                test_server_message_t *message_list,
-                                apr_size_t message_count,
-                                test_server_action_t *action_list,
-                                apr_size_t action_count,
-                                apr_int32_t options,
-                                const char *host_url,
-                                apr_sockaddr_t *address,
-                                serf_connection_setup_t conn_setup,
-                                apr_pool_t *pool)
+
+static apr_status_t setup(test_baton_t **tb_p,
+                          serf_connection_setup_t conn_setup,
+                          int use_proxy,
+                          apr_pool_t *pool)
 {
     apr_status_t status;
     test_baton_t *tb;
+    apr_uri_t url;
 
     tb = apr_pcalloc(pool, sizeof(*tb));
     *tb_p = tb;
 
-    if (address) {
-        tb->serv_addr = address;
-    }
-    else {
-        status = get_server_address(&tb->serv_addr, pool);
-        if (status != APR_SUCCESS)
-          return status;
-    }
-
     tb->pool = pool;
-    tb->options = options;
     tb->context = serf_context_create(pool);
     tb->bkt_alloc = serf_bucket_allocator_create(pool, NULL, NULL);
-    if (host_url) {
-        apr_uri_t url;
-        status = apr_uri_parse(pool, host_url, &url);
+
+    status = default_server_address(&tb->serv_addr, pool);
+    if (status != APR_SUCCESS)
+        return status;
+
+    if (use_proxy) {
+        status = default_proxy_address(&tb->proxy_addr, pool);
         if (status != APR_SUCCESS)
             return status;
 
-        status = serf_connection_create2(&tb->connection, tb->context,
-                                         url,
-                                         conn_setup ? conn_setup : 
-                                             default_conn_setup,
-                                         tb,
-                                         default_closed_connection,
-                                         tb,
-                                         pool);
-        if (status != APR_SUCCESS)
-          return status;
-    } else {
-        tb->connection = serf_connection_create(tb->context,
-                                                tb->serv_addr,
-                                                conn_setup ? conn_setup : 
-                                                    default_conn_setup,
-                                                tb,
-                                                default_closed_connection,
-                                                tb,
-                                                pool);
+        /* Configure serf to use the proxy server */
+        serf_config_proxy(tb->context, tb->proxy_addr);
     }
-    tb->message_list = message_list;
-    tb->message_count = message_count;
-    tb->action_list = action_list;
-    tb->action_count = action_count;
+
+    status = apr_uri_parse(pool, SERV_URL, &url);
+    if (status != APR_SUCCESS)
+        return status;
+
+    status = serf_connection_create2(&tb->connection, tb->context,
+                                     url,
+                                     conn_setup ? conn_setup :
+                                         default_conn_setup,
+                                     tb,
+                                     default_closed_connection,
+                                     tb,
+                                     pool);
+
+    return status;
+}
+
+
+
+apr_status_t test_server_setup(test_baton_t **tb_p,
+                               test_server_message_t *message_list,
+                               apr_size_t message_count,
+                               test_server_action_t *action_list,
+                               apr_size_t action_count,
+                               apr_int32_t options,
+                               serf_connection_setup_t conn_setup,
+                               apr_pool_t *pool)
+{
+    apr_status_t status;
+    test_baton_t *tb;
+
+    status = setup(tb_p,
+                   conn_setup,
+                   FALSE,
+                   pool);
+    if (status != APR_SUCCESS)
+        return status;
+
+    tb = *tb_p;
 
     /* Prepare a server. */
-    status = prepare_server(tb, pool);
-    if (status != APR_SUCCESS)
-      return status;
-
-    return APR_SUCCESS;
-}
-
-apr_status_t test_server_destroy(test_baton_t *tb, apr_pool_t *pool)
+    status = test_start_server(&tb->serv_ctx, tb->serv_addr,
+                               message_list, message_count,
+                               action_list, action_count, options, pool);
+
+    return status;
+}
+
+apr_status_t
+test_server_proxy_setup(test_baton_t **tb_p,
+                        test_server_message_t *serv_message_list,
+                        apr_size_t serv_message_count,
+                        test_server_action_t *serv_action_list,
+                        apr_size_t serv_action_count,
+                        test_server_message_t *proxy_message_list,
+                        apr_size_t proxy_message_count,
+                        test_server_action_t *proxy_action_list,
+                        apr_size_t proxy_action_count,
+                        apr_int32_t options,
+                        serf_connection_setup_t conn_setup,
+                        apr_pool_t *pool)
+{
+    apr_status_t status;
+    test_baton_t *tb;
+
+    status = setup(tb_p,
+                   conn_setup,
+                   TRUE,
+                   pool);
+    if (status != APR_SUCCESS)
+        return status;
+
+    tb = *tb_p;
+
+    /* Prepare the server. */
+    status = test_start_server(&tb->serv_ctx, tb->serv_addr,
+                               serv_message_list, serv_message_count,
+                               serv_action_list, serv_action_count,
+                               options, pool);
+    if (status != APR_SUCCESS)
+        return status;
+
+    /* Prepare the proxy. */
+    status = test_start_server(&tb->proxy_ctx, tb->proxy_addr,
+                               proxy_message_list, proxy_message_count,
+                               proxy_action_list, proxy_action_count,
+                               options, pool);
+
+    return status;
+}
+
+apr_status_t test_server_teardown(test_baton_t *tb, apr_pool_t *pool)
 {
     serf_connection_close(tb->connection);
 
-    apr_socket_close(tb->serv_sock);
-
-    if (tb->client_sock) {
-        apr_socket_close(tb->client_sock);
-    }
+    if (tb->serv_ctx)
+        test_server_destroy(tb->serv_ctx, pool);
+    if (tb->proxy_ctx)
+        test_server_destroy(tb->proxy_ctx, pool);
 
     return APR_SUCCESS;
 }
+
+apr_pool_t *test_setup()
+{
+    apr_pool_t *test_pool;
+    apr_pool_create(&test_pool, NULL);
+    return test_pool;
+}
+
+void test_teardown(apr_pool_t *test_pool)
+{
+    apr_pool_destroy(test_pool);
+}

